"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Breadcrumbs = void 0;
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var Link_1 = require("../Link");
var Flex_1 = require("../Flex");
var Txt_1 = require("../Txt");
var useTheme_1 = require("../../hooks/useTheme");
var Circle = styled_components_1.default(Flex_1.Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tborder: 1px solid\n\t\t", ";\n\tborder-radius: 50%;\n\twidth: ", "px;\n\theight: ", "px;\n\tbackground: ", ";\n"], ["\n\tborder: 1px solid\n\t\t",
    ";\n\tborder-radius: 50%;\n\twidth: ", "px;\n\theight: ", "px;\n\tbackground: ",
    ";\n"])), function (props) {
    return props.isLast
        ? props.dark
            ? props.theme.colors.secondary.dark
            : props.theme.colors.quartenary.light
        : props.dark
            ? props.theme.colors.tertiary.light
            : props.theme.colors.text.light;
}, function (props) { return props.theme.space[props.emphasized ? 3 : 2]; }, function (props) { return props.theme.space[props.emphasized ? 3 : 2]; }, function (props) {
    return props.isLast
        ? props.dark
            ? props.theme.colors.secondary.dark
            : props.theme.colors.quartenary.light
        : props.dark
            ? props.theme.colors.tertiary.light
            : props.theme.colors.text.light;
});
var BreadcrumbContent = React.memo(function (_a) {
    var icon = _a.icon, text = _a.text, secondaryIcon = _a.secondaryIcon;
    var crumbRef = React.useRef(null);
    var _b = React.useState(false), shouldShowTooltip = _b[0], setShouldShowTooltip = _b[1];
    React.useEffect(function () {
        if (!(crumbRef === null || crumbRef === void 0 ? void 0 : crumbRef.current)) {
            return;
        }
        setShouldShowTooltip(crumbRef.current.scrollWidth > crumbRef.current.clientWidth);
    }, []);
    return (React.createElement(Flex_1.Flex, { ref: crumbRef, alignItems: "center", width: "100%" },
        icon && React.createElement(Flex_1.Flex, { mr: 2 }, icon),
        React.createElement(Txt_1.Txt, { tooltip: shouldShowTooltip ? text : undefined, whitespace: "nowrap", truncate: shouldShowTooltip }, text),
        secondaryIcon && React.createElement(Flex_1.Flex, { ml: 2 }, secondaryIcon)));
});
exports.Breadcrumbs = function (_a) {
    var crumbs = _a.crumbs, _b = _a.isCollapsed, isCollapsed = _b === void 0 ? false : _b, emphasized = _a.emphasized, dark = _a.dark;
    var theme = useTheme_1.useTheme();
    return (React.createElement(Flex_1.Flex, { flexDirection: "column", flexWrap: "wrap", width: "100%" }, crumbs.map(function (crumb, i) {
        var _a, _b;
        var isLast = i === crumbs.length - 1;
        return (crumb && (React.createElement(Txt_1.Txt, { bold: isLast, fontSize: 2, color: isLast
                ? "" + (dark ? 'secondary.dark' : 'white')
                : "" + (dark ? 'tertiary.light' : 'secondary.semilight'), key: crumb.text, width: "100%" },
            React.createElement(Flex_1.Flex, { flexDirection: "column", width: "100%" },
                React.createElement(Flex_1.Flex, { alignItems: "center", width: "100%" },
                    !crumb.component && (React.createElement(Circle, { dark: dark, isLast: isLast, emphasized: emphasized })),
                    React.createElement(Flex_1.Flex, { width: "calc(100% - " + theme.space[2] + "px)", pl: 2 }, crumb.onClick ? (React.createElement(Link_1.Link, { style: { display: 'inherit', color: 'inherit' }, onClick: crumb.onClick, width: "100%", href: crumb.href }, !!crumb.component ? (crumb.component) : (React.createElement(BreadcrumbContent, { text: isCollapsed && !crumb.icon
                            ? (_a = crumb.text) === null || _a === void 0 ? void 0 : _a.charAt(0) : isCollapsed && !!crumb.icon
                            ? ''
                            : crumb.text, icon: crumb.icon, secondaryIcon: crumb.secondaryIcon })))) : (React.createElement(BreadcrumbContent, { text: isCollapsed && !crumb.icon
                            ? (_b = crumb.text) === null || _b === void 0 ? void 0 : _b.charAt(0) : isCollapsed && !!crumb.icon
                            ? ''
                            : crumb.text, icon: crumb.icon, secondaryIcon: crumb.secondaryIcon })))),
                !isLast && (React.createElement(Flex_1.Flex, { mt: -2, mb: -2, width: theme.space[emphasized ? 3 : 2], justifyContent: "center" },
                    React.createElement(Flex_1.Flex, { height: theme.space[4], width: "1px", bg: "text." + (dark ? 'dark' : 'light') })))))));
    })));
};
var templateObject_1;
