"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var enzyme_1 = require("enzyme");
var __1 = require("../../");
var _1 = require("./");
var Txt_1 = require("../Txt");
describe('Breadcrumbs component', function () {
    describe('crumbs property', function () {
        it('should render the Breadcrumbs with four routes', function () {
            var crumbs = [
                { text: 'route 1', href: '/route1' },
                { text: 'route 2', href: '/route2' },
                { text: 'route 3', href: '/route3' },
                { text: 'route 4', href: '/route4' },
            ];
            var component = enzyme_1.mount(react_1.default.createElement(__1.Provider, null,
                react_1.default.createElement(_1.Breadcrumbs, { crumbs: crumbs })));
            var crumbsContent = component.findWhere(function (node) { return node.is(Txt_1.Txt) && typeof node.prop('children') === 'string'; });
            expect(crumbsContent).toHaveLength(4);
            crumbsContent.forEach(function (crumb, index) {
                expect(crumb.text()).toEqual(crumbs[index].text);
            });
        });
    });
});
