"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WithConfirmation = exports.Link = exports.Active = exports.IconOnly = exports.WithIcon = exports.Plain = exports.Underlined = exports.Outlined = exports.Disabled = exports.Primary = exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("../../stories/utils");
var _1 = require(".");
var faExpand_1 = require("@fortawesome/free-solid-svg-icons/faExpand");
var faRecycle_1 = require("@fortawesome/free-solid-svg-icons/faRecycle");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
exports.default = {
    title: 'Core/Button',
    component: _1.Button,
};
var Template = utils_1.createTemplate(_1.Button);
exports.Default = utils_1.createStory(Template, {
    children: 'Default',
});
exports.Primary = utils_1.createStory(Template, {
    children: 'Primary',
    primary: true,
});
exports.Disabled = utils_1.createStory(Template, {
    children: 'Disabled',
    disabled: true,
});
exports.Outlined = utils_1.createStory(Template, {
    children: 'Outlined',
    outline: true,
});
exports.Underlined = utils_1.createStory(Template, {
    children: 'Underlined',
    underline: true,
});
exports.Plain = utils_1.createStory(Template, {
    children: 'Plain',
    plain: true,
});
exports.WithIcon = utils_1.createStory(Template, {
    children: 'With icon',
    icon: react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faExpand_1.faExpand }),
    plain: true,
});
exports.IconOnly = utils_1.createStory(Template, {
    icon: react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faRecycle_1.faRecycle }),
    plain: true,
});
exports.Active = utils_1.createStory(Template, {
    children: 'Active',
    active: true,
});
exports.Link = utils_1.createStory(Template, {
    children: 'Link',
    href: '#',
});
exports.WithConfirmation = utils_1.createStory(Template, {
    children: 'Dangerous',
    danger: true,
    confirmation: {
        placement: 'bottom',
        text: 'Are you sure?',
    },
});
