"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var enzyme_1 = require("enzyme");
var sinon_1 = __importDefault(require("sinon"));
var __1 = require("../../");
test('onClick is called after confirmation', function () {
    var handleClick = sinon_1.default.spy();
    var component = enzyme_1.mount(react_1.default.createElement(__1.Provider, null,
        react_1.default.createElement(__1.Button, { confirmation: 'Sure?', onClick: handleClick, m: 2 }, "Click me")));
    expect(component.find('Popover Box[children="Sure?"]')).toHaveLength(0);
    component.find('button[children="Click me"]').simulate('click');
    expect(component.find('div[children="Sure?"]')).toHaveLength(1);
    component.find('button[children="Cancel"]').simulate('click');
    expect(handleClick.callCount).toEqual(0);
    component.find('button[children="Click me"]').simulate('click');
    component.find('button[children="OK"]').simulate('click');
    expect(handleClick.callCount).toEqual(1);
    expect(handleClick.lastCall.args[0]).toHaveProperty('target');
});
