"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WithIconButton = exports.GroupSelect = exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var faExpand_1 = require("@fortawesome/free-solid-svg-icons/faExpand");
var faRecycle_1 = require("@fortawesome/free-solid-svg-icons/faRecycle");
var faSpinner_1 = require("@fortawesome/free-solid-svg-icons/faSpinner");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var utils_1 = require("../../stories/utils");
var Button_1 = require("../Button");
var _1 = require(".");
exports.default = {
    title: 'Core/ButtonGroup',
    component: _1.ButtonGroup,
    subcomponents: { Button: Button_1.Button },
};
var OptionsDemoTemplate = function (props) {
    if (!('options' in props)) {
        return null;
    }
    if (typeof props.value !== 'object') {
        return null;
    }
    var _a = react_1.default.useState(props.value), selected = _a[0], setSelected = _a[1];
    return (react_1.default.createElement(_1.ButtonGroup, __assign({}, props, { options: props.options, onGroupChange: setSelected, value: selected })));
};
var Template = utils_1.createTemplate(_1.ButtonGroup);
var OptionsTemplate = utils_1.createTemplate(OptionsDemoTemplate);
exports.Default = utils_1.createStory(Template, {
    children: (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Button_1.Button, null, "First"),
        react_1.default.createElement(Button_1.Button, null, "Second"),
        react_1.default.createElement(Button_1.Button, null, "Third"))),
});
exports.GroupSelect = utils_1.createStory(OptionsTemplate, {
    options: [
        { label: 'option 1', value: 'option1' },
        { label: 'option 2', value: 'option2' },
        { label: 'option 3', value: 'option3' },
    ],
    value: { label: 'option 2', value: 'option2' },
});
exports.WithIconButton = utils_1.createStory(Template, {
    children: (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Button_1.Button, { icon: react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { fixedWidth: true, icon: faExpand_1.faExpand }) }),
        react_1.default.createElement(Button_1.Button, { icon: react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { fixedWidth: true, icon: faRecycle_1.faRecycle }) }),
        react_1.default.createElement(Button_1.Button, { icon: react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { fixedWidth: true, icon: faSpinner_1.faSpinner }) }))),
});
