/// <reference types="react" />
import { FlexProps } from '../Flex';
import { TooltipProps } from '../../common-types';
export declare type OptionType = ButtonGroupOption | string | number | boolean;
export interface ButtonGroupOption {
    label: string | number;
    value: unknown;
    tooltip?: string | TooltipProps;
}
export interface ButtonGroupWithOptionsProps extends Omit<FlexProps, 'children'> {
    options: OptionType[];
    disabled?: string;
    value?: OptionType;
    onGroupChange: (value: OptionType) => void;
}
export declare type ButtonGroupProps = FlexProps | ButtonGroupWithOptionsProps;
export declare const ButtonGroup: (props: ButtonGroupProps) => JSX.Element | null;
