"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ButtonGroup = void 0;
var react_1 = __importDefault(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var Flex_1 = require("../Flex");
var Button_1 = require("../Button");
var utils_1 = require("../../utils");
var ButtonGroupBase = styled_components_1.default(Flex_1.Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t", "\n\t", "\n"], ["\n\t", "\n\t",
    "\n"])), function (props) { return props.disabled && "cursor: not-allowed;"; }, function (props) {
    return props.isSelect
        ? "\n\t\t\tborder: 1px solid " + props.theme.global.control.border.color + ";\n\t\t\twidth: fit-content;\n\t\t\tborder-radius: " + props.theme.button.border.radius + ";\n\t\t\tpadding: 2px;\n\t\t\t> button {\n\t\t\t\tpadding: 2px 16px;\n\t\t\t\tborder: 0px;\n\t\t\t}\n\t\t"
        : "\n\t\t> * {\n\t\t\t&:first-child {\n\t\t\t\tborder-top-right-radius: 0;\n\t\t\t\tborder-bottom-right-radius: 0;\n\t\t\t\tpadding-left: " + utils_1.px(props.theme.space[3]) + ";\n\t\t\t}\n\t\n\t\t\t&:last-child {\n\t\t\t\tborder-top-left-radius: 0;\n\t\t\t\tborder-bottom-left-radius: 0;\n\t\t\t\tpadding-right: " + utils_1.px(props.theme.space[3]) + ";\n\t\t\t}\n\t\n\t\t\t&:not(:last-child) {\n\t\t\t\tborder-right: 0;\n\t\t\t}\n\t\n\t\t\t&:not(:last-child):not(:first-child) {\n\t\t\t\tborder-radius: 0;\n\t\t\t}\n\t\n\t\t\t&:hover {\n\t\t\t\tz-index: 1;\n\t\t\t}\n\t\t";
});
exports.ButtonGroup = function (props) {
    if ('options' in props) {
        var onGroupChange_1 = props.onGroupChange, height_1 = props.height, disabled_1 = props.disabled, otherProps = __rest(props, ["onGroupChange", "height", "disabled"]);
        return (react_1.default.createElement(ButtonGroupBase, __assign({ isSelect: true }, otherProps, { alignItems: "center", disabled: !!disabled_1, tooltip: disabled_1 }), props.options.map(function (option) {
            var label = typeof option !== 'object' ? option : option.label;
            return (react_1.default.createElement(Button_1.Button, { active: typeof option !== 'object'
                    ? option === props.value
                    : option.value === props.value, tooltip: typeof option === 'object' ? option.tooltip : undefined, onClick: function () {
                    if (onGroupChange_1) {
                        onGroupChange_1(option);
                    }
                }, height: height_1, disabled: !!disabled_1 }, label));
        })));
    }
    if ('children' in props) {
        return react_1.default.createElement(ButtonGroupBase, __assign({}, props), props.children);
    }
    return null;
};
var templateObject_1;
