"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IconOnly = exports.AlwaysShow = exports.WithTag = exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("../../stories/utils");
var __1 = require("../..");
var _1 = require(".");
var columns = [{ field: 'Name' }, { field: 'Value' }];
var data = [
    { Name: 'Type', Value: 'Beginner' },
    { Name: 'Type', Value: 'Advanced' },
];
exports.default = {
    title: 'Core/Copy',
    component: _1.Copy,
};
var Template = utils_1.createTemplate(_1.Copy);
exports.Default = utils_1.createStory(Template, {
    content: 'Plain text',
    children: react_1.default.createElement(__1.Txt, null, "Hover me and click on icon to copy"),
});
exports.WithTag = utils_1.createStory(Template, {
    content: 'Beginner',
    children: react_1.default.createElement(__1.Tag, { name: "Type", value: "Beginner" }),
});
exports.AlwaysShow = utils_1.createStory(Template, {
    content: JSON.stringify(data),
    children: react_1.default.createElement(__1.Table, { columns: columns, data: data }),
});
exports.IconOnly = utils_1.createStory(Template, {
    content: 'Hi there',
});
exports.IconOnly.decorators = [
    function (Story) { return (react_1.default.createElement(__1.Box, { m: 3 },
        "Only copy icon that can be placed anywhere.",
        react_1.default.createElement(Story, null))); },
];
