"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFilter = exports.Edit = exports.createFilter = exports.decodeFilter = exports.operators = void 0;
var React = __importStar(require("react"));
var utils_1 = require("../../utils");
var Input_1 = require("../Input");
var Textarea_1 = require("../Textarea");
var utils_2 = require("./utils");
var Select_1 = require("../Select");
var utils_3 = require("../../extra/AutoUI/utils");
exports.operators = {
    contains: {
        getLabel: function (_s) { return 'contains'; },
    },
    not_contains: {
        getLabel: function (_s) { return 'does not contain'; },
    },
};
exports.decodeFilter = function (filter) {
    var _a;
    var operator = filter.title;
    var properties = utils_3.findInObject(filter, 'properties');
    var firstPropKey = Object.keys(properties)[0];
    var field = firstPropKey;
    var value = (_a = utils_3.findInObject(filter, 'const')) !== null && _a !== void 0 ? _a : utils_3.findInObject(filter, 'pattern');
    return {
        field: field,
        operator: operator,
        value: value,
    };
};
exports.createFilter = function (field, operator, value, schema) {
    var _a, _b, _c;
    var title = schema.title;
    var base = {
        $id: utils_1.randomString(),
        title: operator,
        description: utils_2.getJsonDescription(title || field, exports.operators[operator].getLabel(schema), value),
        type: 'object',
    };
    var filter = exports.getFilter(schema, value);
    if (operator === 'contains') {
        return Object.assign(base, {
            properties: (_a = {},
                _a[field] = __assign({ type: 'array' }, filter),
                _a),
            required: [field],
        });
    }
    if (operator === 'not_contains') {
        return Object.assign(base, {
            anyOf: [
                {
                    properties: (_b = {},
                        _b[field] = {
                            type: 'array',
                            not: __assign({}, filter),
                        },
                        _b),
                },
                {
                    properties: (_c = {},
                        _c[field] = {
                            type: 'null',
                        },
                        _c),
                },
            ],
        });
    }
    return base;
};
exports.Edit = function (_a) {
    var onUpdate = _a.onUpdate, slim = _a.slim, props = __rest(_a, ["onUpdate", "slim"]);
    var schemaItems = props.schema.items;
    if (schemaItems === null || schemaItems === void 0 ? void 0 : schemaItems.oneOf) {
        return (React.createElement(Select_1.Select, __assign({}, props, { options: schemaItems.oneOf || [], valueKey: "const", labelKey: "title", value: (schemaItems.oneOf || []).find(function (x) { return x.const === props.value; }), onChange: function (_a) {
                var option = _a.option;
                return onUpdate(option.const.toString());
            } })));
    }
    if (slim) {
        return (React.createElement(Input_1.Input, __assign({ onChange: function (e) {
                return onUpdate(e.currentTarget.value);
            } }, props)));
    }
    return (React.createElement(Textarea_1.Textarea, __assign({ onChange: function (e) {
            return onUpdate(e.currentTarget.value);
        } }, props)));
};
exports.getFilter = function (schema, value) {
    if (!!(schema === null || schema === void 0 ? void 0 : schema.items) &&
        typeof schema.items !== 'boolean' &&
        'properties' in schema.items &&
        !!schema.items.properties) {
        return {
            minItems: 1,
            items: {
                properties: Object.keys(schema.items.properties).reduce(function (props, propKey) {
                    props[propKey] = {
                        regexp: {
                            pattern: utils_1.regexEscape(value),
                            flags: 'i',
                        },
                    };
                    return props;
                }, {}),
            },
        };
    }
    return {
        contains: {
            const: Number.isNaN(parseInt(value, 10)) ? value : Number(value),
        },
    };
};
