import type { JSONSchema7 as JSONSchema } from 'json-schema';
import { FilterSignature } from '../Filters';
export declare const operators: {
    is: {
        getLabel: (_s: JSONSchema) => string;
    };
};
declare type OperatorSlug = keyof typeof operators;
interface BooleanFilter extends JSONSchema {
    title: OperatorSlug;
    properties?: {
        [k: string]: {
            const: boolean;
        };
    };
}
export declare const decodeFilter: (filter: BooleanFilter) => FilterSignature | null;
export declare const createFilter: (field: string, operator: OperatorSlug, value: any, schema: JSONSchema) => BooleanFilter;
export declare const uiSchema: {
    'ui:widget': string;
};
export {};
