"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.uiSchema = exports.createFilter = exports.decodeFilter = exports.operators = void 0;
var utils_1 = require("../../utils");
var utils_2 = require("./utils");
exports.operators = {
    is: {
        getLabel: function (_s) { return 'is'; },
    },
};
exports.decodeFilter = function (filter) {
    if (!filter.properties) {
        return null;
    }
    var keys = Object.keys(filter.properties);
    if (!keys.length) {
        return null;
    }
    var field = keys[0];
    var operator = filter.title;
    var value;
    if (operator === 'is') {
        value = filter.properties[field].const;
    }
    else {
        return null;
    }
    return {
        field: field,
        operator: operator,
        value: value,
    };
};
exports.createFilter = function (field, operator, value, schema) {
    var _a;
    var title = schema.title;
    var base = {
        $id: utils_1.randomString(),
        title: operator,
        description: utils_2.getJsonDescription(title || field, exports.operators[operator].getLabel(schema), value),
        type: 'object',
    };
    var val = typeof value === 'string' ? value.toLowerCase() === 'true' : value;
    if (operator === 'is') {
        return Object.assign(base, {
            properties: (_a = {},
                _a[field] = {
                    const: val,
                },
                _a),
            required: [field],
        });
    }
    return base;
};
exports.uiSchema = {
    'ui:widget': 'select',
};
