import type { JSONSchema7 as JSONSchema } from 'json-schema';
export declare const operators: {
    is: {
        getLabel: (_s: JSONSchema) => string;
    };
    is_not: {
        getLabel: (_s: JSONSchema) => string;
    };
};
declare type OperatorSlug = keyof typeof operators;
interface EnumFilter extends JSONSchema {
    title: OperatorSlug;
    properties?: {
        [k: string]: {
            const?: any;
            not?: {
                const?: any;
            };
        };
    };
}
export declare const decodeFilter: (filter: EnumFilter) => {
    field: string;
    operator: OperatorSlug;
    value: any;
} | null;
export declare const createFilter: (field: string, operator: OperatorSlug, value: any, schema: JSONSchema) => EnumFilter;
export {};
