import type { JSONSchema7 as JSONSchema } from 'json-schema';
export declare const operators: {
    contains: {
        getLabel: (_s: JSONSchema) => string;
    };
    not_contains: {
        getLabel: (_s: JSONSchema) => string;
    };
    is: {
        getLabel: (_s: JSONSchema) => string;
    };
    full_text_search: {
        getLabel: (_s: JSONSchema) => string;
    };
    matches_re: {
        getLabel: (_s: JSONSchema) => string;
    };
    not_matches_re: {
        getLabel: (_s: JSONSchema) => string;
    };
};
declare type OperatorSlug = keyof typeof operators;
interface StringFilter extends JSONSchema {
    title: OperatorSlug;
    properties?: {
        [k: string]: {
            const?: string;
            pattern?: string;
            description?: string;
            not?: {
                pattern: string;
            };
        };
    };
    anyOf?: Array<{
        properties?: {
            [k: string]: {
                const?: string;
                pattern?: string;
                description?: string;
                not?: {
                    pattern: string;
                };
                regexp?: {
                    pattern: string;
                    flags: string;
                };
            };
        };
    }>;
}
export declare const decodeFilter: (filter: StringFilter) => {
    field: string;
    operator: OperatorSlug;
    value: string;
} | null;
export declare const createFilter: (field: string, operator: OperatorSlug, value: any, schema: JSONSchema) => JSONSchema;
export {};
