"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropUp = exports.NoListFormatting = exports.IconOnly = exports.WithPrimaryButton = exports.Joined = exports.BorderedList = exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("../../stories/utils");
var _1 = require(".");
var Button_1 = require("../Button");
var Box_1 = require("../Box");
var Divider_1 = require("../Divider");
var NonZeroOrderedButton = function (props) {
    var _a;
    if (!props.i) {
        return null;
    }
    return (react_1.default.createElement(Button_1.Button, { plain: true }, (_a = props.children) !== null && _a !== void 0 ? _a : "Non-zero indexed item " + props.i));
};
var OddIndexedButton = function (props) {
    if (props.i % 2 === 0) {
        return null;
    }
    return (react_1.default.createElement(NonZeroOrderedButton, { i: props.i },
        "Odd indexed item ",
        props.i));
};
var sampleChildren = __spreadArrays([
    react_1.default.createElement(Button_1.Button, { plain: true }, "Item")
], [0, 1, 2, 3].map(function (i) { return react_1.default.createElement(NonZeroOrderedButton, { i: i }); }), [
    react_1.default.createElement(Button_1.Button, { plain: true }, "Item"),
    react_1.default.createElement(Divider_1.Divider, null),
    react_1.default.createElement(Button_1.Button, { plain: true }, "Item")
], [0, 1, 2, 3].map(function (i) { return react_1.default.createElement(OddIndexedButton, { i: i }); }), [
    react_1.default.createElement(Button_1.Button, { plain: true }, "Item"),
]);
exports.default = {
    title: 'Core/DropDownButton',
    component: _1.DropDownButton,
};
var OpenUpStory = function (props) {
    return (react_1.default.createElement(Box_1.Box, { mt: "300px" },
        react_1.default.createElement(_1.DropDownButton, __assign({}, props))));
};
var OpenUpTemplate = utils_1.createTemplate(OpenUpStory);
var Template = utils_1.createTemplate(_1.DropDownButton);
exports.Default = utils_1.createStory(Template, {
    label: 'Dropdown',
    children: sampleChildren,
});
exports.BorderedList = utils_1.createStory(Template, {
    label: 'Dropdown',
    border: true,
    children: sampleChildren,
});
exports.Joined = utils_1.createStory(Template, {
    label: 'Dropdown',
    joined: true,
    children: sampleChildren,
});
exports.WithPrimaryButton = utils_1.createStory(Template, {
    label: 'Dropdown',
    joined: true,
    primary: true,
    children: sampleChildren,
});
exports.IconOnly = utils_1.createStory(Template, {
    joined: true,
    primary: true,
    children: sampleChildren,
});
exports.NoListFormatting = utils_1.createStory(Template, {
    noListFormat: true,
    primary: true,
    children: sampleChildren,
});
exports.DropUp = utils_1.createStory(OpenUpTemplate, {
    label: 'Dropdown',
    dropUp: true,
    children: sampleChildren,
});
