import * as React from 'react';
import { RenditionSystemProps } from '../../common-types';
import { ButtonProps } from '../Button';
interface DropDownButtonState {
    open: boolean;
}
export interface DropdownOption {
    content: string | JSX.Element;
    onClick?: React.MouseEventHandler<HTMLElement>;
    tooltip?: string;
    disabled?: boolean;
    danger?: boolean;
}
declare class BaseDropDownButton extends React.Component<InternalDropDownButtonProps, DropDownButtonState> {
    dropdownNode: HTMLDivElement | null;
    constructor(props: InternalDropDownButtonProps);
    componentWillUnmount(): void;
    handleOutsideClick: (e: MouseEvent) => void;
    toggle: () => void;
    removeListener: () => void;
    render(): JSX.Element;
}
export interface InternalDropDownButtonProps extends ButtonProps {
    items?: DropdownOption[][];
    label?: string | JSX.Element;
    border?: boolean;
    joined?: boolean;
    alignRight?: boolean;
    dropUp?: boolean;
    noListFormat?: boolean;
    listMaxHeight?: string | number;
}
export declare type DropDownButtonProps = InternalDropDownButtonProps & RenditionSystemProps;
export declare const DropDownButton: React.ForwardRefExoticComponent<InternalDropDownButtonProps & import("../../common-types").StyledSystemProps & import("../../common-types").Tooltip & React.RefAttributes<BaseDropDownButton>>;
export {};
