/// <reference types="react" />
import type { JSONSchema7 as JSONSchema } from 'json-schema';
export interface FilterFieldOption {
    field: string;
    title: string;
}
export declare type FilterFieldCompareFn = (a: FilterFieldOption, b: FilterFieldOption) => number;
export interface FilterModalProps {
    addFilter: (filters: EditModel[]) => void;
    onClose: () => void;
    schema: JSONSchema;
    edit: EditModel[];
    fieldCompareFn?: FilterFieldCompareFn;
}
export interface FilterInputProps {
    schema: JSONSchema;
    value: any;
    operator: string;
    onUpdate: (value: any) => void;
}
export interface EditModel {
    field: string;
    operator: string;
    value: string | number | {
        [k: string]: string;
    };
}
export declare const FilterModal: ({ addFilter, onClose, schema, edit, fieldCompareFn, }: FilterModalProps) => JSX.Element;
