"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RenderModes = exports.Compact = exports.ButtonProps = exports.Disabled = exports.Default = void 0;
var React = __importStar(require("react"));
var uniq_1 = __importDefault(require("lodash/uniq"));
var styled_components_1 = __importDefault(require("styled-components"));
var utils_1 = require("../../stories/utils");
var _1 = require(".");
var __1 = require("../..");
var pokedex_1 = __importStar(require("../../stories/assets/pokedex"));
var StyledTable = styled_components_1.default.table(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\twidth: 100%;\n\n\ttd {\n\t\tborder: 1px solid #eee;\n\t\tpadding: 3px 6px;\n\t}\n"], ["\n\twidth: 100%;\n\n\ttd {\n\t\tborder: 1px solid #eee;\n\t\tpadding: 3px 6px;\n\t}\n"])));
var schema = {
    type: 'object',
    properties: {
        name: {
            title: 'Pokemon Name',
            type: 'string',
        },
        description: {
            type: 'string',
        },
        abilities: {
            type: 'array',
            items: {
                type: 'string',
            },
        },
        secondaryAbilities: {
            title: 'Secondary Abilities',
            type: 'array',
            items: {
                type: 'string',
                oneOf: [
                    {
                        title: 'Swimming',
                        const: 'swimming',
                    },
                    {
                        title: 'Fly',
                        const: 'fly',
                    },
                    {
                        title: 'Cut',
                        const: 'cut',
                    },
                ],
            },
        },
        tag: {
            type: 'object',
            properties: {
                tag_name: {
                    title: 'Name',
                    description: 'key',
                    type: 'string',
                },
                tag_value: {
                    description: 'value',
                    title: 'Value',
                    type: 'string',
                },
            },
        },
        first_seen: {
            title: 'First Seen',
            type: 'string',
            format: 'date-time',
        },
        caught: {
            title: 'Has been caught',
            type: 'boolean',
        },
        biometrics: {
            type: 'object',
            properties: {
                Height: {
                    type: ['number', null],
                },
                Weight: {
                    type: 'number',
                },
            },
        },
        pokedex_number: {
            title: 'National pokedex number',
            type: 'number',
        },
        category: {
            enum: uniq_1.default(pokedex_1.default.map(function (p) { return p.Category; })),
        },
        nationality: {
            title: 'Nationality',
            oneOf: uniq_1.default(pokedex_1.default.map(function (p) { return p.nationality; })).map(function (slug) { return ({
                title: pokedex_1.getNameFromSlug(slug),
                const: slug,
            }); }),
        },
    },
};
var FiltersDemo = function (props) {
    var _a, _b;
    var _c = React.useState((_a = props.filters) !== null && _a !== void 0 ? _a : []), filters = _c[0], setFilters = _c[1];
    var _d = React.useState((_b = props.views) !== null && _b !== void 0 ? _b : []), views = _d[0], setViews = _d[1];
    var items = __1.SchemaSieve.filter(filters, pokedex_1.default);
    return (React.createElement("div", null,
        React.createElement(_1.Filters, __assign({ filters: filters, views: views, onFiltersUpdate: setFilters, onViewsUpdate: setViews }, props)),
        items.map(function (item, index) { return (React.createElement("div", { key: index },
            React.createElement("h2", null, item.Name),
            React.createElement(StyledTable, null,
                React.createElement("tbody", null,
                    React.createElement("tr", null,
                        React.createElement("td", null, "National PokeDex Number"),
                        React.createElement("td", null, item.pokedex_number)),
                    React.createElement("tr", null,
                        React.createElement("td", null, "Category"),
                        React.createElement("td", null, item.Category)),
                    React.createElement("tr", null,
                        React.createElement("td", null, "Nationality"),
                        React.createElement("td", null, pokedex_1.getNameFromSlug(item.nationality))),
                    React.createElement("tr", null,
                        React.createElement("td", null, "Height"),
                        React.createElement("td", null, item.biometrics.Height)),
                    React.createElement("tr", null,
                        React.createElement("td", null, "Weight"),
                        React.createElement("td", null, item.biometrics.Weight)),
                    React.createElement("tr", null,
                        React.createElement("td", null, "Abilities"),
                        React.createElement("td", null, item.Abilities.join(', '))),
                    React.createElement("tr", null,
                        React.createElement("td", null, "Secondary Abilities"),
                        React.createElement("td", null, item.secondaryAbilities.join(', '))),
                    React.createElement("tr", null,
                        React.createElement("td", null, "First Seen"),
                        React.createElement("td", null, item.first_seen
                            ? new Date(item.first_seen).toUTCString()
                            : '')),
                    React.createElement("tr", null,
                        React.createElement("td", null, "Caught"),
                        React.createElement("td", null, item.caught ? 'yes' : 'no')),
                    React.createElement("tr", null,
                        React.createElement("td", null, "Tags"),
                        React.createElement("td", null, !!item.Tag &&
                            item.Tag.map(function (tag) { return (React.createElement(__1.Tag, { key: tag.tag_name, value: tag.tag_value })); }))))),
            React.createElement("p", null, item.Description))); })));
};
exports.default = {
    title: 'Core/Filters',
    component: _1.Filters,
    args: {
        schema: schema,
    },
};
var Template = utils_1.createTemplate(FiltersDemo);
exports.Default = utils_1.createStory(Template, {
    filters: [],
    viewScopes: [
        {
            slug: 'bleh',
            name: 'bleh',
            label: 'bla',
        },
        {
            slug: 'foo',
            name: 'foo',
        },
    ],
});
exports.Disabled = utils_1.createStory(Template, {
    filters: [],
    disabled: true,
});
exports.ButtonProps = utils_1.createStory(Template, {
    filters: [],
    addFilterButtonProps: {
        width: 200,
    },
    viewsMenuButtonProps: {
        width: 200,
        danger: true,
    },
});
exports.Compact = utils_1.createStory(Template, {
    filters: [],
    compact: [true],
});
exports.RenderModes = utils_1.createStory(Template, {
    filters: [
        {
            $id: 'FuELaSmfCBqiV9hx',
            anyOf: [
                {
                    $id: 'QXe1ev3KzutxZ0lK',
                    title: 'is',
                    description: '{"name": "Pokemon Name", "operator": "is", "value": "Squirtle"}',
                    type: 'object',
                    properties: {
                        Name: {
                            title: 'Pokemon Name',
                            const: 'Squirtle',
                        },
                    },
                },
                {
                    $id: 'QXe1ev3KzutxZ0lm',
                    title: 'is',
                    description: '{"name": "Pokemon Name", "operator": "is", "value": "Pikachu"}',
                    type: 'object',
                    properties: {
                        Name: {
                            title: 'Pokemon Name',
                            const: 'Pikachu',
                        },
                    },
                },
            ],
        },
    ],
    renderMode: ['add', 'views', 'summary'],
});
var templateObject_1;
