import type { JSONSchema7 as JSONSchema } from 'json-schema';
import { FilterSignature } from '.';
export declare const FULL_TEXT_SLUG = "full_text_search";
export declare function filter<T>(filters: JSONSchema | JSONSchema[], collection: T[]): T[];
export declare function filter<T>(filters: JSONSchema | JSONSchema[], collection: Record<string, T>): Record<string, T>;
export declare const createFullTextSearchFilter: (schema: JSONSchema, term: string) => JSONSchema;
export declare const insertFullTextSearch: (schema: JSONSchema, filters: JSONSchema[] | undefined, term: string) => JSONSchema[];
export declare const removeFullTextSearch: (filters: JSONSchema[]) => JSONSchema[];
export declare const createFilter: (schema: JSONSchema, signatures: FilterSignature[]) => JSONSchema;
export declare const decodeFilter: (schema: JSONSchema, filter: JSONSchema) => ({} | null)[];
export declare const getOperators: (schema: JSONSchema, field: string) => {
    slug: string;
    label: any;
}[];
export declare const flattenSchema: (schema: JSONSchema, delimiter?: string) => JSONSchema;
export declare const unflattenSchema: (schema: JSONSchema, delimiter?: string) => JSONSchema;
export declare const getCleanEditModel: (schema: JSONSchema, field?: string | null | undefined) => {
    field: string;
    operator: string;
    value: any;
};
