"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var faChartPie_1 = require("@fortawesome/free-solid-svg-icons/faChartPie");
var faTrash_1 = require("@fortawesome/free-solid-svg-icons/faTrash");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var cloneDeep_1 = __importDefault(require("lodash/cloneDeep"));
var groupBy_1 = __importDefault(require("lodash/groupBy"));
var map_1 = __importDefault(require("lodash/map"));
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var utils_1 = require("../../utils");
var Box_1 = require("../Box");
var Button_1 = require("../Button");
var DropDownButton_1 = require("../DropDownButton");
var FilterDescription_1 = __importDefault(require("./FilterDescription"));
var Flex_1 = require("../Flex");
var theme_1 = __importDefault(require("../../theme"));
var PlainPanel = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tborder-radius: 2px;\n\tbackground-color: #ffffff;\n\tbox-shadow: 0 0 6px 0 rgba(0, 0, 0, 0.1);\n\tborder: solid 1px #9b9b9b;\n"], ["\n\tborder-radius: 2px;\n\tbackground-color: #ffffff;\n\tbox-shadow: 0 0 6px 0 rgba(0, 0, 0, 0.1);\n\tborder: solid 1px #9b9b9b;\n"])));
var Preview = styled_components_1.default(PlainPanel)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tdisplay: none;\n\tposition: absolute;\n\tright: 230px;\n\twidth: 300px;\n\tright: 100%;\n\tmargin-right: 3px;\n\ttop: 2px;\n\tpadding: 15px 15px 5px;\n"], ["\n\tdisplay: none;\n\tposition: absolute;\n\tright: 230px;\n\twidth: 300px;\n\tright: 100%;\n\tmargin-right: 3px;\n\ttop: 2px;\n\tpadding: 15px 15px 5px;\n"])));
var ViewsMenu = function (props) {
    var loadView = function (view) {
        var filters = cloneDeep_1.default(view.filters);
        props.setFilters(filters);
    };
    var views = props.views, renderMode = props.renderMode, hasMultipleScopes = props.hasMultipleScopes, compact = props.compact, deleteView = props.deleteView;
    var hasViews = views.length > 0;
    var groupedViews = groupBy_1.default(views, function (item) { return item.scope || 'Unscoped'; });
    var memoizedItems = React.useMemo(function () {
        return !hasViews
            ? [[{ content: "You haven't created any views yet" }]]
            : map_1.default(groupedViews, function (views, scope) {
                return views.map(function (view, index) { return ({
                    content: (React.createElement(Flex_1.Flex, { flexDirection: "row", justifyContent: "space-between", alignItems: "center", key: scope + "-" + index },
                        React.createElement(Flex_1.Flex, { flexDirection: "column", mr: 3 },
                            React.createElement(Flex_1.Flex, { flexDirection: "row" },
                                hasMultipleScopes && (React.createElement(Flex_1.Flex, { flexDirection: "column", mr: 1 },
                                    React.createElement("strong", null, scope))),
                                React.createElement(Flex_1.Flex, { flexDirection: "column" }, view.name)),
                            React.createElement(Flex_1.Flex, { flexDirection: "row", color: theme_1.default.colors.gray },
                                view.filters.length,
                                " filter",
                                view.filters.length > 1 && 's')),
                        React.createElement(Flex_1.Flex, { flexDirection: "column" },
                            React.createElement(Button_1.Button, { plain: true, onClick: function (e) {
                                    deleteView(view);
                                    utils_1.stopEvent(e);
                                } },
                                React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faTrash_1.faTrash }))),
                        React.createElement(Preview, null, view.filters.map(function (filter) { return (React.createElement(Box_1.Box, { mb: 10, key: filter.$id },
                            React.createElement(FilterDescription_1.default, { filter: filter }))); })))),
                    onClick: function () { return loadView(view); },
                }); });
            });
    }, [views, deleteView]);
    return (React.createElement(DropDownButton_1.DropDownButton, __assign({ mx: (renderMode === null || renderMode === void 0 ? void 0 : renderMode.length) === 1 ? 0 : 1, disabled: props.disabled, quartenary: true, light: props.dark, outline: true, joined: true, alignRight: (renderMode === null || renderMode === void 0 ? void 0 : renderMode.length) === 1, noListFormat: true, icon: React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faChartPie_1.faChartPie }), label: "Views", compact: compact }, props.buttonProps, { items: memoizedItems })));
};
exports.default = ViewsMenu;
var templateObject_1, templateObject_2;
