"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Filters = void 0;
var faFilter_1 = require("@fortawesome/free-solid-svg-icons/faFilter");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var castArray_1 = __importDefault(require("lodash/castArray"));
var cloneDeep_1 = __importDefault(require("lodash/cloneDeep"));
var includes_1 = __importDefault(require("lodash/includes"));
var isEmpty_1 = __importDefault(require("lodash/isEmpty"));
var isEqual_1 = __importDefault(require("lodash/isEqual"));
var reject_1 = __importDefault(require("lodash/reject"));
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var Button_1 = require("../Button");
var utils_1 = require("../../utils");
var Box_1 = require("../Box");
var Flex_1 = require("../Flex");
var Search_1 = require("../Search");
var FilterModal_1 = require("./FilterModal");
var SchemaSieve = __importStar(require("./SchemaSieve"));
var Summary_1 = __importDefault(require("./Summary"));
var ViewsMenu_1 = __importDefault(require("./ViewsMenu"));
var utils_2 = require("../../extra/AutoUI/utils");
var SearchWrapper = styled_components_1.default(Box_1.Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\twidth: 100%;\n\tflex-basis: 100%;\n\tposition: relative;\n\tmargin-right: 4px;\n\tpadding: 0 4px;\n\talign-self: center;\n"], ["\n\twidth: 100%;\n\tflex-basis: 100%;\n\tposition: relative;\n\tmargin-right: 4px;\n\tpadding: 0 4px;\n\talign-self: center;\n"])));
var FilterWrapper = styled_components_1.default(Box_1.Box)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tposition: relative;\n"], ["\n\tposition: relative;\n"])));
var BaseFilters = (function (_super) {
    __extends(BaseFilters, _super);
    function BaseFilters(props) {
        var _this = _super.call(this, props) || this;
        _this.searchContainer = React.createRef();
        _this.clearAllFilters = function () {
            _this.setFilters([]);
            _this.setState({
                searchString: '',
            });
        };
        var _a = _this.props, _b = _a.filters, filters = _b === void 0 ? [] : _b, schema = _a.schema, _c = _a.views, views = _c === void 0 ? [] : _c;
        var flatSchema = SchemaSieve.flattenSchema(schema);
        var flatViews = _this.flattenViews(views);
        var flatFilters = filters.map(function (filter) {
            return SchemaSieve.flattenSchema(filter);
        });
        _this.state = {
            showModal: false,
            searchString: '',
            editingFilter: null,
            filters: flatFilters,
            views: flatViews,
            schema: flatSchema,
            edit: [],
            showSearchDropDown: false,
        };
        _this.state.edit.push(_this.getCleanEditModel());
        _this.searchContainer = React.createRef();
        return _this;
    }
    BaseFilters.prototype.componentDidUpdate = function (prevProps) {
        var newState = {};
        if (!isEqual_1.default(prevProps.schema, this.props.schema)) {
            newState.schema = SchemaSieve.flattenSchema(this.props.schema);
        }
        if (!isEqual_1.default(prevProps.filters, this.props.filters)) {
            var filters = this.props.filters || [];
            newState.filters = filters.map(function (filter) {
                return SchemaSieve.flattenSchema(filter);
            });
        }
        if (!isEqual_1.default(prevProps.views, this.props.views)) {
            var views = this.props.views || [];
            newState.views = this.flattenViews(views);
        }
        if (!isEmpty_1.default(newState)) {
            this.setState(newState);
        }
    };
    BaseFilters.prototype.flattenViews = function (views) {
        return views.map(function (_a) {
            var filters = _a.filters, view = __rest(_a, ["filters"]);
            return (__assign(__assign({}, view), { filters: filters.map(function (filter) { return SchemaSieve.flattenSchema(filter); }) }));
        });
    };
    BaseFilters.prototype.emitViewsUpdate = function () {
        if (!this.props.onViewsUpdate) {
            return;
        }
        this.props.onViewsUpdate(this.state.views.map(function (_a) {
            var filters = _a.filters, view = __rest(_a, ["filters"]);
            return (__assign(__assign({}, view), { filters: filters.map(function (filter) { return SchemaSieve.unflattenSchema(filter); }) }));
        }));
    };
    BaseFilters.prototype.getCleanEditModel = function (field) {
        var schema = this.state.schema;
        if (!field) {
            field = Object.keys(schema.properties).shift();
        }
        var fieldOperators = this.getOperators(field);
        if (!fieldOperators.length) {
            return {
                field: field,
                operator: '',
                value: '',
            };
        }
        var operator = fieldOperators.shift().slug;
        var value = '';
        var subschema = schema.properties[field];
        if (typeof subschema !== 'boolean') {
            if (subschema.enum) {
                value = subschema.enum[0] || '';
            }
            if (subschema.oneOf) {
                value = subschema.oneOf[0].const || '';
            }
            if (subschema.type === 'boolean') {
                value = true;
            }
        }
        return {
            field: field,
            operator: operator,
            value: value,
        };
    };
    BaseFilters.prototype.getOperators = function (field) {
        var schema = this.state.schema;
        return SchemaSieve.getOperators(schema, field);
    };
    BaseFilters.prototype.emitFilterUpdate = function () {
        if (!this.props.onFiltersUpdate) {
            return;
        }
        this.props.onFiltersUpdate(this.state.filters.map(function (filter) { return SchemaSieve.unflattenSchema(filter); }));
    };
    BaseFilters.prototype.addFilter = function (edit) {
        var _this = this;
        var newFilter = SchemaSieve.createFilter(this.state.schema, edit);
        var currentFilters = !!this.state.editingFilter
            ? this.state.filters.map(function (filter) {
                return filter.$id === _this.state.editingFilter ? newFilter : filter;
            })
            : __spreadArrays(this.state.filters, [newFilter]);
        this.setState({
            filters: currentFilters,
            edit: [this.getCleanEditModel()],
            showModal: false,
            editingFilter: null,
        }, function () { return _this.emitFilterUpdate(); });
    };
    BaseFilters.prototype.editFilter = function (filter) {
        if (filter.title === SchemaSieve.FULL_TEXT_SLUG) {
            return;
        }
        var schema = this.state.schema;
        var signatures = SchemaSieve.decodeFilter(schema, filter);
        this.setState({
            edit: signatures,
            editingFilter: filter.$id,
            showModal: true,
        });
    };
    BaseFilters.prototype.removeFilter = function (_a) {
        var _this = this;
        var $id = _a.$id, title = _a.title;
        this.setState(function (prevState) {
            var newState = __assign(__assign({}, prevState), { filters: reject_1.default(prevState.filters, { $id: $id }) });
            if (title === SchemaSieve.FULL_TEXT_SLUG) {
                newState.searchString = '';
            }
            return newState;
        }, function () { return _this.emitFilterUpdate(); });
    };
    BaseFilters.prototype.setFilters = function (filters) {
        var _this = this;
        this.setState({ filters: filters }, function () { return _this.emitFilterUpdate(); });
    };
    BaseFilters.prototype.saveView = function (name, scope) {
        var _this = this;
        var view = {
            id: utils_1.randomString(),
            name: name,
            scope: scope,
            filters: cloneDeep_1.default(this.state.filters),
        };
        this.setState(function (prevState) { return ({
            views: prevState.views.concat(view),
        }); }, function () {
            return _this.props.onViewsUpdate && _this.props.onViewsUpdate(_this.state.views);
        });
    };
    BaseFilters.prototype.deleteView = function (_a) {
        var _this = this;
        var id = _a.id;
        this.setState(function (prevState) { return ({
            views: reject_1.default(prevState.views, { id: id }),
        }); }, function () {
            return _this.props.onViewsUpdate && _this.props.onViewsUpdate(_this.state.views);
        });
    };
    BaseFilters.prototype.shouldRenderComponent = function (mode) {
        if (!this.props.renderMode) {
            return true;
        }
        var allowedModes = castArray_1.default(this.props.renderMode);
        if (includes_1.default(allowedModes, 'all')) {
            return true;
        }
        return includes_1.default(allowedModes, mode);
    };
    BaseFilters.prototype.render = function () {
        var _this = this;
        var _a = this.state, filters = _a.filters, searchString = _a.searchString, showSearchDropDown = _a.showSearchDropDown;
        var renderingSummaryAndOtherComponents = this.shouldRenderComponent('summary') &&
            [
                this.shouldRenderComponent('add'),
                this.shouldRenderComponent('search'),
                this.shouldRenderComponent('views'),
            ].includes(true);
        var componentsToRender = !!this.props.renderMode
            ? castArray_1.default(this.props.renderMode)
            : [];
        return (React.createElement(FilterWrapper, null,
            React.createElement(Flex_1.Flex, { justifyContent: "space-between", mb: renderingSummaryAndOtherComponents ? 3 : undefined },
                this.shouldRenderComponent('search') && (React.createElement(SearchWrapper, { ref: this.searchContainer, onFocus: function () {
                        _this.setState({ showSearchDropDown: true });
                        if (_this.searchContainer.current) {
                            utils_2.onClickOutOrEsc(_this.searchContainer.current, function () {
                                _this.setState({ showSearchDropDown: false });
                            });
                        }
                    } },
                    React.createElement(Search_1.Search, { dark: this.props.dark, disabled: this.props.disabled, value: searchString, onChange: function (e) {
                            if (e.target.value !== '') {
                                _this.setState({ showSearchDropDown: true });
                            }
                            else {
                                _this.setState({ showSearchDropDown: false });
                            }
                            _this.setState({ searchString: e.target.value });
                        }, onEnter: function () {
                            if (!searchString) {
                                return;
                            }
                            _this.setState(function (prevState) {
                                var newFilters = SchemaSieve.insertFullTextSearch(_this.state.schema, prevState.filters, searchString);
                                return {
                                    filters: newFilters,
                                    searchString: '',
                                };
                            }, function () { return _this.emitFilterUpdate(); });
                        } }),
                    searchString &&
                        showSearchDropDown &&
                        this.props.onSearch &&
                        this.props.onSearch(searchString))),
                this.shouldRenderComponent('add') && (React.createElement(Button_1.Button, __assign({ mx: 1, disabled: this.props.disabled, light: this.props.dark, outline: true, quartenary: true, icon: React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faFilter_1.faFilter }), onClick: function () {
                        return _this.setState({ showModal: true, editingFilter: null });
                    }, label: "Add filter", compact: this.props.compact }, this.props.addFilterButtonProps))),
                this.shouldRenderComponent('views') && (React.createElement(ViewsMenu_1.default, { dark: this.props.dark, buttonProps: this.props.viewsMenuButtonProps, disabled: this.props.disabled, views: this.state.views || [], schema: this.props.schema, hasMultipleScopes: this.props.viewScopes && this.props.viewScopes.length > 1, renderMode: componentsToRender, setFilters: function (filters) { return _this.setFilters(filters); }, deleteView: function (view) { return _this.deleteView(view); }, compact: this.props.compact })),
                this.state.showModal && (React.createElement(FilterModal_1.FilterModal, { addFilter: function (edit) { return _this.addFilter(edit); }, onClose: function () { return _this.setState({ showModal: false }); }, schema: this.state.schema, edit: this.state.edit, fieldCompareFn: this.props.filterFieldCompareFn }))),
            this.shouldRenderComponent('summary') &&
                !!filters.length &&
                !this.props.disabled && (React.createElement(Summary_1.default, { scopes: this.props.viewScopes, edit: function (filter) { return _this.editFilter(filter); }, delete: function (filter) { return _this.removeFilter(filter); }, saveView: function (name, scope) { return _this.saveView(name, scope); }, clearAllFilters: this.clearAllFilters, filters: filters, views: this.state.views || [], schema: this.state.schema }))));
    };
    return BaseFilters;
}(React.Component));
exports.Filters = BaseFilters;
var templateObject_1, templateObject_2;
