"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WithDependants = exports.WithPatternProperties = exports.WithExtraWidgets = exports.WithTitles = exports.WithHelpText = exports.WithWarning = exports.WithUiSchema = exports.CustomSubmitText = exports.Disabled = exports.SecondaryAction = exports.HiddenSubmit = exports.Default = void 0;
var React = __importStar(require("react"));
var utils_1 = require("../../stories/utils");
var __1 = require("../..");
var Markdown_1 = require("../../extra/Markdown");
var _1 = require(".");
window.RECAPTCHA_V2_API_KEY = '6Ld-faYUAAAAAF92j1FX-GgG0uNPbw9sCCmnbJ2D';
var zxcvbn_1 = __importDefault(require("zxcvbn"));
window.zxcvbn = zxcvbn_1.default;
var extraWidgetsReadme = "\n# Extra widgets\nAdditional widgets for handling different formats can be registered using the `Form.registerWidget` method.\nRendition contains widgets for rendering Markdown and Mermaid text formats that can be used in the following way:\n```js\nimport * as React from 'react'\nimport * as ReactDOM from 'react-dom'\nimport { Form } from 'rendition'\nimport { MermaidWidget } from 'rendition/dist/components/Form/mermaid'\nimport { MarkdownWidget } from 'rendition/dist/components/Form/markdown'\n\nconst schema = {\n  type: 'object',\n  properties: {\n    Markdown: {\n      format: 'markdown',\n      type: 'string'\n    },\n    Mermaid: {\n      format: 'mermaid',\n      type: 'string'\n    }\n  }\n}\n\nconst rootElement = document.getElementById('root')\nReactDOM.render(<Form schema={schema} extraFormats={[{name: 'markdown', format: '.*', widget: MarkdownWidget}, {name: 'mermaid', format: '.*', widget: MermaidWidget}]} />, rootElement)\n```\n";
var basicPokedexSchema = {
    type: 'object',
    title: 'Pokèmon',
    properties: {
        Name: {
            type: 'string',
            minLength: 5,
            examples: ['Pikachu', 'Snorlax', 'Charmander', 'Bulbasaur'],
        },
        Height: {
            type: 'number',
        },
        Weight: {
            type: 'number',
        },
        Description: {
            type: 'string',
        },
        Category: {
            type: 'string',
            maxLength: 20,
        },
        Abilities: {
            type: 'string',
        },
        pokedex_number: {
            title: 'National Pokèdex Number',
            type: 'number',
        },
        caught: {
            type: 'boolean',
        },
        first_seen: {
            title: 'First seen',
            description: 'The first time you saw this pokèmon',
            type: 'string',
            format: 'date-time',
        },
        poke_password: {
            title: 'Poke Password',
            description: "Password to access the pokèmon's abilities",
            type: 'string',
        },
        environment: {
            type: 'string',
            oneOf: [
                {
                    const: 'earth',
                    title: 'Earth',
                },
                {
                    const: 'water',
                    title: 'Water',
                },
                {
                    const: 'fire',
                    title: 'Fire',
                },
            ],
        },
        tags: {
            title: 'Tags',
            description: 'Add useful tags to your pokèmon',
            type: 'array',
            items: {
                type: 'string',
            },
        },
    },
};
var basicPokedexUiSchema = {
    'ui:order': ['Name', 'caught', 'Description', 'Abilities', '*'],
    Name: {
        'ui:autocomplete': 'on',
    },
    poke_password: {
        'ui:widget': 'password',
        'ui:options': {
            showPasswordStrengthMeter: true,
        },
    },
    Height: {
        'ui:options': {
            emphasized: true,
        },
    },
    environment: {
        'ui:options': {
            emphasized: true,
        },
    },
    Description: {
        'ui:widget': 'textarea',
        'ui:options': {
            rows: 5,
        },
    },
};
var FormDemo = function (props) {
    var _a;
    var _b = React.useState((_a = props.value) !== null && _a !== void 0 ? _a : {}), data = _b[0], setData = _b[1];
    return (React.createElement(__1.Flex, null,
        React.createElement(__1.Box, { flex: "1", m: 30 },
            React.createElement(_1.Form, __assign({ onFormChange: function (_a) {
                    var formData = _a.formData;
                    return setData(formData);
                }, value: data }, props))),
        React.createElement(__1.Box, { flex: "1", maxWidth: "50%", p: 30 },
            React.createElement(__1.Txt, { monospace: true },
                React.createElement("pre", null, JSON.stringify(data, null, 4))))));
};
exports.default = {
    title: 'Core/Form',
    component: _1.Form,
};
var Template = utils_1.createTemplate(FormDemo);
exports.Default = utils_1.createStory(Template, {
    schema: basicPokedexSchema,
});
exports.HiddenSubmit = utils_1.createStory(Template, {
    schema: basicPokedexSchema,
    hideSubmitButton: true,
});
exports.SecondaryAction = utils_1.createStory(Template, {
    schema: basicPokedexSchema,
    secondaryButtonProps: { children: 'Skip' },
});
exports.Disabled = utils_1.createStory(Template, {
    schema: basicPokedexSchema,
    disabled: true,
});
exports.CustomSubmitText = utils_1.createStory(Template, {
    schema: basicPokedexSchema,
    submitButtonText: 'Save',
});
exports.WithUiSchema = utils_1.createStory(Template, {
    schema: basicPokedexSchema,
    uiSchema: basicPokedexUiSchema,
    formData: {
        poke_password: 'Secret password',
    },
});
exports.WithWarning = utils_1.createStory(Template, {
    schema: basicPokedexSchema,
    uiSchema: __assign(__assign({}, basicPokedexUiSchema), { Name: {
            'ui:warning': 'Once the `Name` is set it cannot be changed',
        } }),
});
exports.WithHelpText = utils_1.createStory(Template, {
    schema: basicPokedexSchema,
    uiSchema: __assign(__assign({}, basicPokedexUiSchema), { Name: {
            'ui:help': 'Once the `Name` is set it cannot be changed',
        } }),
});
exports.WithTitles = utils_1.createStory(Template, {
    schema: {
        type: 'object',
        title: 'Networking',
        properties: {
            vpn: {
                type: 'object',
                title: 'Virtual Private Network',
                properties: {
                    endpoint: {
                        title: 'Endpoint',
                        type: 'string',
                    },
                    certificate: {
                        title: 'Certificate',
                        type: 'string',
                    },
                },
            },
            wifiNetwork: {
                type: 'object',
                title: 'WiFi Network',
                properties: {
                    wifi: {
                        type: 'object',
                        properties: {
                            ssid: {
                                title: 'Network SSID',
                                type: 'string',
                            },
                        },
                    },
                    wifiSecurity: {
                        type: 'object',
                        properties: {
                            psk: {
                                title: 'Network Passphrase',
                                type: 'string',
                            },
                        },
                    },
                },
            },
        },
    },
});
exports.WithExtraWidgets = utils_1.createStory(Template, {
    schema: {
        type: 'object',
        properties: {
            Mermaid: {
                type: 'string',
                format: 'mermaid',
            },
            Markdown: {
                type: 'string',
                format: 'markdown',
            },
            Captcha: {
                type: 'string',
                format: 'captcha',
            },
        },
    },
});
exports.WithExtraWidgets.decorators = [
    function (Story) { return (React.createElement(React.Fragment, null,
        React.createElement(__1.Box, { px: 30, pt: 30 },
            React.createElement(Markdown_1.Markdown, null, extraWidgetsReadme)),
        React.createElement(Story, null))); },
];
exports.WithPatternProperties = utils_1.createStory(Template, {
    schema: {
        type: 'object',
        properties: {
            dynamicObject: {
                patternProperties: {
                    '^[0-9]+$': {
                        title: 'Rule',
                        type: 'string',
                    },
                },
                title: 'Rules',
                type: 'object',
            },
        },
    },
    formData: {
        dynamicObject: {
            123: 'foo',
        },
    },
});
var enumValues = ['First', 'Second', 'Third'];
exports.WithDependants = utils_1.createStory(Template, {
    schema: {
        type: 'object',
        properties: {
            application_config_variable: {
                title: 'Application configuration variables',
                type: 'array',
                items: {
                    type: 'object',
                    properties: {
                        name: {
                            title: 'Name',
                            enum: enumValues,
                        },
                    },
                    dependencies: {
                        name: {
                            oneOf: enumValues.map(function (name) {
                                return {
                                    description: 'Enter some value',
                                    properties: {
                                        name: {
                                            enum: [name],
                                        },
                                        value: {
                                            title: 'Value',
                                            enum: ['false', 'true'],
                                            default: 'true',
                                            description: undefined,
                                        },
                                    },
                                };
                            }),
                        },
                    },
                },
            },
            application_environment_variable: {
                type: 'array',
                title: 'Application environment variables',
                items: {
                    type: 'object',
                    properties: {
                        name: {
                            title: 'Name',
                            type: 'string',
                        },
                        value: {
                            title: 'Value',
                            type: 'string',
                        },
                    },
                },
            },
        },
    },
    uiSchema: {
        application_config_variable: {
            'ui:options': {
                orderable: false,
            },
            items: {
                'ui:options': {
                    responsive: true,
                    flex: ['2 2 200px', '1 1 100px'],
                },
            },
        },
        application_environment_variable: {
            'ui:options': {
                orderable: false,
            },
            items: {
                'ui:options': {
                    responsive: true,
                    flex: ['2 2 200px', '1 1 100px'],
                },
            },
        },
    },
    formData: {
        application_config_variable: [{}],
        application_environment_variable: [{}],
    },
});
