"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Form = void 0;
var uniqBy_1 = __importDefault(require("lodash/uniqBy"));
var React = __importStar(require("react"));
var core_1 = __importDefault(require("@rjsf/core"));
var styled_components_1 = __importDefault(require("styled-components"));
var Box_1 = require("../Box");
var Button_1 = require("../Button");
var utils = __importStar(require("../../utils"));
var DescriptionField_1 = require("./fields/DescriptionField");
var ObjectField_1 = __importDefault(require("./fields/ObjectField"));
var TitleField_1 = require("./fields/TitleField");
var ArrayFieldTemplate_1 = __importDefault(require("./templates/ArrayFieldTemplate"));
var FieldTemplate_1 = __importDefault(require("./templates/FieldTemplate"));
var ObjectFieldTemplate_1 = __importDefault(require("./templates/ObjectFieldTemplate"));
var BaseInput_1 = __importDefault(require("./widgets/BaseInput"));
var PasswordWidget_1 = __importDefault(require("./widgets/PasswordWidget"));
var SelectWidget_1 = __importDefault(require("./widgets/SelectWidget"));
var TextareaWidget_1 = __importDefault(require("./widgets/TextareaWidget"));
var WidgetContext_1 = require("../../contexts/WidgetContext");
var SUPPORTED_SCHEMA_FORMATS = [
    'data-url',
    'date',
    'date-time',
    'email',
    'hostname',
    'ipv4',
    'ipv6',
    'uri',
];
var widgets = {
    BaseInput: BaseInput_1.default,
    SelectWidget: SelectWidget_1.default,
    PasswordWidget: PasswordWidget_1.default,
    TextareaWidget: TextareaWidget_1.default,
};
var fields = {
    DescriptionField: DescriptionField_1.DescriptionField,
    ObjectField: ObjectField_1.default,
    TitleField: TitleField_1.TitleField,
};
var FormWrapper = styled_components_1.default(Box_1.Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tsection {\n\t\tmargin: 0;\n\t\tpadding: 0;\n\t\tborder: 0;\n\t}\n\n\tlabel {\n\t\tfont-size: ", ";\n\t}\n\n\tinput {\n\t\tfont-size: ", ";\n\t}\n\n\t/* Style the error list, since it can't be templated */\n\t.panel-danger,\n\t.error-detail {\n\t\tfont-size: ", ";\n\t\tmargin-top: ", ";\n\t\tmargin-bottom: ", ";\n\t\tlist-style-type: none;\n\t\tpadding-left: 0;\n\t}\n\n\t.text-danger {\n\t\tcolor: ", ";\n\t}\n"], ["\n\tsection {\n\t\tmargin: 0;\n\t\tpadding: 0;\n\t\tborder: 0;\n\t}\n\n\tlabel {\n\t\tfont-size: ", ";\n\t}\n\n\tinput {\n\t\tfont-size: ", ";\n\t}\n\n\t/* Style the error list, since it can't be templated */\n\t.panel-danger,\n\t.error-detail {\n\t\tfont-size: ", ";\n\t\tmargin-top: ", ";\n\t\tmargin-bottom: ", ";\n\t\tlist-style-type: none;\n\t\tpadding-left: 0;\n\t}\n\n\t.text-danger {\n\t\tcolor: ", ";\n\t}\n"])), function (props) { var _a; return utils.px((_a = props === null || props === void 0 ? void 0 : props.theme) === null || _a === void 0 ? void 0 : _a.fontSizes[1]); }, function (props) { var _a; return utils.px((_a = props === null || props === void 0 ? void 0 : props.theme) === null || _a === void 0 ? void 0 : _a.fontSizes[2]); }, function (props) { var _a, _b, _c; return utils.px((_c = (_b = (_a = props === null || props === void 0 ? void 0 : props.theme) === null || _a === void 0 ? void 0 : _a.fontSizes) === null || _b === void 0 ? void 0 : _b[1]) !== null && _c !== void 0 ? _c : 14); }, function (props) { var _a, _b, _c; return utils.px((_c = (_b = (_a = props === null || props === void 0 ? void 0 : props.theme) === null || _a === void 0 ? void 0 : _a.space) === null || _b === void 0 ? void 0 : _b[1]) !== null && _c !== void 0 ? _c : 4); }, function (props) { var _a, _b, _c; return utils.px((_c = (_b = (_a = props === null || props === void 0 ? void 0 : props.theme) === null || _a === void 0 ? void 0 : _a.space) === null || _b === void 0 ? void 0 : _b[1]) !== null && _c !== void 0 ? _c : 4); }, function (props) { var _a, _b, _c, _d; return (_d = (_c = (_b = (_a = props === null || props === void 0 ? void 0 : props.theme) === null || _a === void 0 ? void 0 : _a.colors) === null || _b === void 0 ? void 0 : _b.danger) === null || _c === void 0 ? void 0 : _c.main) !== null && _d !== void 0 ? _d : '#a94442'; });
var parseSchema = function (schema) {
    var whitelist = SUPPORTED_SCHEMA_FORMATS.concat(Object.keys(widgets));
    return utils.stripSchemaFormats(schema, whitelist);
};
var BaseForm = React.forwardRef(function (_a, ref) {
    var _b;
    var schema = _a.schema, value = _a.value, disabled = _a.disabled, extraFormats = _a.extraFormats, onFormChange = _a.onFormChange, onFormSubmit = _a.onFormSubmit, hideSubmitButton = _a.hideSubmitButton, submitButtonText = _a.submitButtonText, submitButtonProps = _a.submitButtonProps, secondaryButtonProps = _a.secondaryButtonProps, uiSchema = _a.uiSchema, validate = _a.validate, liveValidate = _a.liveValidate, noValidate = _a.noValidate, transformErrors = _a.transformErrors, props = __rest(_a, ["schema", "value", "disabled", "extraFormats", "onFormChange", "onFormSubmit", "hideSubmitButton", "submitButtonText", "submitButtonProps", "secondaryButtonProps", "uiSchema", "validate", "liveValidate", "noValidate", "transformErrors"]);
    var form = React.useContext(WidgetContext_1.WidgetContext).form;
    var contextFormats = (_b = form === null || form === void 0 ? void 0 : form.formats) !== null && _b !== void 0 ? _b : [];
    var allWidgets = React.useMemo(function () {
        return __assign(__assign({}, widgets), uniqBy_1.default(__spreadArrays((extraFormats !== null && extraFormats !== void 0 ? extraFormats : []), contextFormats), function (format) { return format.name; }).reduce(function (agg, format) {
            if (format.widget) {
                agg[format.name] = format.widget;
            }
            return agg;
        }, {}));
    }, [widgets, extraFormats]);
    widgets = allWidgets;
    var calculatedSchema = React.useMemo(function () {
        var parsedSchema = parseSchema(schema);
        var _a = utils.disallowAdditionalProperties(parsedSchema), $schema = _a.$schema, resultingSchema = __rest(_a, ["$schema"]);
        return resultingSchema;
    }, [schema]);
    var _c = React.useState(value), formState = _c[0], setFormState = _c[1];
    React.useEffect(function () {
        setFormState(value);
    }, [value]);
    var handleKeyUpDown = React.useCallback(function (e) {
        if (e.key === 'Enter' && !hideSubmitButton) {
            e.stopPropagation();
        }
    }, [hideSubmitButton]);
    var change = React.useCallback(function (data) {
        setFormState(data.formData);
        if (onFormChange) {
            onFormChange(data);
        }
    }, [onFormChange]);
    return (React.createElement(FormWrapper, __assign({}, props, { onKeyDown: handleKeyUpDown, onKeyUp: handleKeyUpDown }),
        React.createElement(core_1.default, { ref: ref, disabled: disabled, liveValidate: liveValidate, noValidate: noValidate, validate: validate, transformErrors: transformErrors, showErrorList: false, schema: calculatedSchema, formData: formState, onSubmit: onFormSubmit, onChange: change, uiSchema: uiSchema, widgets: allWidgets, fields: fields, FieldTemplate: FieldTemplate_1.default, ObjectFieldTemplate: ObjectFieldTemplate_1.default, ArrayFieldTemplate: ArrayFieldTemplate_1.default },
            hideSubmitButton && React.createElement("span", null),
            !hideSubmitButton && (React.createElement(Button_1.Button, __assign({ primary: true }, submitButtonProps, { type: "submit" }), submitButtonText || 'Submit')),
            !!secondaryButtonProps && (React.createElement(Button_1.Button, __assign({ outline: true, secondary: true, ml: 3 }, secondaryButtonProps))))));
});
exports.Form = BaseForm;
var templateObject_1;
