import * as React from 'react';
import { ResponsiveStyle, Theme } from '../../common-types';
import { ButtonProps } from '../Button';
export interface ModalProps extends React.HTMLAttributes<HTMLElement> {
    title?: string;
    width?: ResponsiveStyle;
    position?: 'center' | 'top';
    titleElement?: string | JSX.Element;
    titleDetails?: string | JSX.Element;
    action?: string | JSX.Element;
    cancel?: () => any;
    done: () => any;
    primaryButtonProps?: ButtonProps;
    secondaryButtonProps?: ButtonProps;
    cancelButtonProps?: ButtonProps;
}
export interface ThemedModalProps extends ModalProps {
    theme: Theme;
}
export declare const Modal: React.FunctionComponent<ModalProps>;
