import * as React from 'react';
import { RenditionSystemProps } from '../../common-types';
import type { Value, JSONSchema, UiSchema, Format } from './types';
export { Widget, WidgetProps, widgetFactory } from './widgets/widget-util';
export declare const getValue: (value?: string | number | boolean | any[] | {
    [key: string]: any;
} | null | undefined, schema?: JSONSchema | undefined, uiSchema?: UiSchema | undefined) => string | number | boolean | {
    [key: string]: any;
} | null | undefined;
export declare const getType: (value?: string | number | boolean | any[] | {
    [key: string]: any;
} | null | undefined) => "string" | "number" | "bigint" | "boolean" | "symbol" | "undefined" | "object" | "function" | "default" | "array" | "null";
export declare const getWidget: (value?: string | number | boolean | any[] | {
    [key: string]: any;
} | null | undefined, format?: string | undefined, uiSchemaWidget?: UiSchema['ui:widget'], extraFormats?: Format[] | undefined) => import("./widgets/widget-util").Widget<object, {}>;
interface InternalRendererProps extends React.HTMLAttributes<HTMLElement> {
    nested?: boolean;
    validate?: boolean;
    valueKey?: string;
    value?: Value;
    schema: JSONSchema | undefined;
    uiSchema?: UiSchema;
    extraFormats?: Format[];
    extraContext?: object;
}
export declare type RendererProps = InternalRendererProps & RenditionSystemProps;
export declare const Renderer: (props: RendererProps) => JSX.Element;
