"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Renderer = exports.getWidget = exports.getType = exports.getValue = void 0;
var React = __importStar(require("react"));
var castArray_1 = __importDefault(require("lodash/castArray"));
var forEach_1 = __importDefault(require("lodash/forEach"));
var uniqBy_1 = __importDefault(require("lodash/uniqBy"));
var keys_1 = __importDefault(require("lodash/keys"));
var pick_1 = __importDefault(require("lodash/pick"));
var toPath_1 = __importDefault(require("lodash/toPath"));
var isArray_1 = __importDefault(require("lodash/isArray"));
var ajv_1 = __importDefault(require("ajv"));
var asRendition_1 = __importDefault(require("../../asRendition"));
var Flex_1 = require("../Flex");
var Alert_1 = require("../Alert");
var widgets_1 = require("./widgets");
var widget_util_1 = require("./widgets/widget-util");
var types_1 = require("./types");
var WidgetContext_1 = require("../../contexts/WidgetContext");
var widget_util_2 = require("./widgets/widget-util");
Object.defineProperty(exports, "widgetFactory", { enumerable: true, get: function () { return widget_util_2.widgetFactory; } });
exports.getValue = function (value, schema, uiSchema) {
    var calculatedValue = uiSchema === null || uiSchema === void 0 ? void 0 : uiSchema['ui:value'];
    return calculatedValue !== undefined
        ? calculatedValue
        : value !== undefined
            ? value
            : schema === null || schema === void 0 ? void 0 : schema.default;
};
var widgetWrapperUiOptionKeyPaths = keys_1.default(widgets_1.WidgetWrapperUiOptions).map(toPath_1.default);
exports.getType = function (value) {
    if (value === undefined) {
        return 'default';
    }
    if (value === null) {
        return 'null';
    }
    return isArray_1.default(value) ? 'array' : typeof value;
};
exports.getWidget = function (value, format, uiSchemaWidget, extraFormats) {
    var _a, _b;
    var valueType = exports.getType(value);
    var extraFormat = extraFormats === null || extraFormats === void 0 ? void 0 : extraFormats.find(function (extraFormat) {
        var _a, _b;
        return (extraFormat.name === format || extraFormat.name === uiSchemaWidget) && ((_b = (_a = extraFormat.widget) === null || _a === void 0 ? void 0 : _a.supportedTypes) === null || _b === void 0 ? void 0 : _b.includes(valueType));
    });
    return (_b = (_a = extraFormat === null || extraFormat === void 0 ? void 0 : extraFormat.widget) !== null && _a !== void 0 ? _a : widgets_1.typeWidgets[valueType]) !== null && _b !== void 0 ? _b : widgets_1.typeWidgets.default;
};
var buildValidation = function (schema, extraFormats) {
    var validator = new ajv_1.default();
    forEach_1.default(extraFormats, function (_a) {
        var name = _a.name, format = _a.format;
        validator.addFormat(name, format);
    });
    return {
        validator: validator,
        validate: validator.compile(schema || {}),
    };
};
var RendererBase = function (_a) {
    var _b;
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, valueKey = _a.valueKey, extraFormats = _a.extraFormats, extraContext = _a.extraContext, validate = _a.validate, nested = _a.nested, props = __rest(_a, ["value", "schema", "uiSchema", "valueKey", "extraFormats", "extraContext", "validate", "nested"]);
    var renderer = React.useContext(WidgetContext_1.WidgetContext).renderer;
    var processedSchema = React.useMemo(function () {
        return widget_util_1.getBestSchemaMatch(schema, value);
    }, [schema, value]);
    var formats = React.useMemo(function () {
        var _a;
        return uniqBy_1.default(__spreadArrays((extraFormats !== null && extraFormats !== void 0 ? extraFormats : []), ((_a = renderer === null || renderer === void 0 ? void 0 : renderer.formats) !== null && _a !== void 0 ? _a : []), widgets_1.defaultFormats), function (format) { return format.name; });
    }, [renderer === null || renderer === void 0 ? void 0 : renderer.formats, extraFormats, widgets_1.defaultFormats]);
    var _c = React.useState(validate && !nested ? buildValidation(processedSchema, formats) : null), validation = _c[0], setValidation = _c[1];
    var _d = React.useState(null), validationErrors = _d[0], setValidationErrors = _d[1];
    React.useEffect(function () {
        if (!validate || nested) {
            setValidationErrors(null);
            return;
        }
        setValidation(buildValidation(processedSchema, formats));
    }, [validate, nested, formats, processedSchema]);
    React.useEffect(function () {
        if (!validate || nested) {
            return;
        }
        var v = validation;
        if (!v) {
            v = buildValidation(processedSchema, formats);
            setValidation(v);
        }
        v.validate(value);
        setValidationErrors(v.validate.errors);
    }, [validate, nested, validation, value, processedSchema]);
    if (uiSchema === null) {
        return null;
    }
    var processedUiSchema = widget_util_1.transformUiSchema({
        value: value,
        uiSchema: uiSchema,
        extraContext: extraContext,
    });
    var processedValue = exports.getValue(value, processedSchema, processedUiSchema);
    var types = (processedSchema === null || processedSchema === void 0 ? void 0 : processedSchema.type) != null ? castArray_1.default(processedSchema.type) : [];
    if (processedValue === undefined ||
        (processedValue === null && !types.includes(types_1.JsonTypes.null))) {
        return null;
    }
    var wrapperProps = pick_1.default((_b = processedUiSchema['ui:options']) !== null && _b !== void 0 ? _b : {}, widgetWrapperUiOptionKeyPaths);
    var Widget = exports.getWidget(processedValue, processedSchema === null || processedSchema === void 0 ? void 0 : processedSchema.format, processedUiSchema['ui:widget'], formats);
    return (React.createElement(Flex_1.Flex, __assign({ minWidth: 0, minHeight: 0, alignItems: "flex-start", mb: 1, flexDirection: "column" }, props, wrapperProps),
        validationErrors && (React.createElement(Alert_1.Alert, { my: 2, plaintext: true, danger: true, tooltip: validation === null || validation === void 0 ? void 0 : validation.validator.errorsText(validationErrors) }, "Invalid data/schema")),
        React.createElement(widgets_1.WidgetMeta, { schema: processedSchema, uiSchema: processedUiSchema, valueKey: valueKey }),
        React.createElement(Widget, { extraContext: extraContext, extraFormats: formats, value: processedValue, schema: processedSchema, uiSchema: processedUiSchema })));
};
var RenditionRendererBase = asRendition_1.default(RendererBase);
exports.Renderer = function (props) {
    return React.createElement(RenditionRendererBase, __assign({}, props));
};
