"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var Flex_1 = require("../../Flex");
var Txt_1 = require("../../Txt");
var types_1 = require("../types");
var ui_options_1 = require("./ui-options");
var widget_util_1 = require("./widget-util");
var colorUtils_1 = require("../../../utils/colorUtils");
var DEFAULT_WIDTH = '100px';
var DEFAULT_HEIGHT = '100px';
var ColorWidget = widget_util_1.widgetFactory('Color', {
    label: ui_options_1.UiOption.string,
    hideValueDisplay: ui_options_1.UiOption.bool,
    width: ui_options_1.UiOption.space,
    height: ui_options_1.UiOption.space,
}, [types_1.JsonTypes.string])(function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, label = _a.label, hideValueDisplay = _a.hideValueDisplay, _b = _a.width, width = _b === void 0 ? DEFAULT_WIDTH : _b, _c = _a.height, height = _c === void 0 ? DEFAULT_HEIGHT : _c, props = __rest(_a, ["value", "schema", "uiSchema", "label", "hideValueDisplay", "width", "height"]);
    if (value == null) {
        return null;
    }
    var bg = value.toString() || 'transparent';
    var color = colorUtils_1.isLight(bg) ? '#000' : '#FFF';
    return (react_1.default.createElement(Flex_1.Flex, __assign({}, props, { width: width, height: height, bg: bg, color: color, alignItems: "center", flexDirection: "column", justifyContent: "center" }),
        label && react_1.default.createElement(Txt_1.Txt, null, label),
        !hideValueDisplay && react_1.default.createElement(Txt_1.Txt, null, value)));
});
exports.default = ColorWidget;
