"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var isArray_1 = __importDefault(require("lodash/isArray"));
var get_1 = __importDefault(require("lodash/get"));
var map_1 = __importDefault(require("lodash/map"));
var DropDownButton_1 = require("../../DropDownButton");
var widget_util_1 = require("./widget-util");
var types_1 = require("../types");
var ui_options_1 = require("./ui-options");
var index_1 = require("../index");
var validItemTypes = ['string', 'integer', 'number'];
var DropDownButtonWidget = widget_util_1.widgetFactory('DropDownButton', {
    label: ui_options_1.UiOption.string,
    disabled: ui_options_1.UiOption.boolean,
    primary: ui_options_1.UiOption.boolean,
    secondary: ui_options_1.UiOption.boolean,
    tertiary: ui_options_1.UiOption.boolean,
    quarternary: ui_options_1.UiOption.boolean,
    danger: ui_options_1.UiOption.boolean,
    warning: ui_options_1.UiOption.boolean,
    success: ui_options_1.UiOption.boolean,
    info: ui_options_1.UiOption.boolean,
    emphasized: ui_options_1.UiOption.boolean,
    square: ui_options_1.UiOption.boolean,
    border: ui_options_1.UiOption.boolean,
    joined: ui_options_1.UiOption.boolean,
    alignRight: ui_options_1.UiOption.boolean,
    listMaxHeight: ui_options_1.UiOption.space,
}, [types_1.JsonTypes.array])(function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, extraContext = _a.extraContext, extraFormats = _a.extraFormats, props = __rest(_a, ["value", "schema", "uiSchema", "extraContext", "extraFormats"]);
    if (!isArray_1.default(value)) {
        throw new Error("DropDownButtonWidget cannot be used to render a value of type '" + typeof value + "'");
    }
    var itemType = get_1.default(schema, ['items', 'type'], 'undefined');
    if (!validItemTypes.includes(itemType)) {
        throw new Error("DropDownButtonWidget cannot be used to render an array of items of type " + itemType);
    }
    var items = widget_util_1.getArrayItems({ value: value, schema: schema, uiSchema: uiSchema, extraContext: extraContext });
    return (React.createElement(DropDownButton_1.DropDownButton, __assign({}, props), map_1.default(items, function (item, index) { return (React.createElement(index_1.Renderer, __assign({ key: index }, item, { extraFormats: extraFormats }))); })));
});
exports.default = DropDownButtonWidget;
