"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DurationWidget = void 0;
var react_1 = __importDefault(require("react"));
var widget_util_1 = require("./widget-util");
var types_1 = require("../types");
var Txt_1 = require("../../Txt");
var date_fns_1 = require("date-fns");
exports.DurationWidget = widget_util_1.widgetFactory('Duration', {}, [types_1.JsonTypes.object])(function (_a) {
    var value = _a.value;
    var duration = react_1.default.useMemo(function () {
        if (!value.start || !value.end) {
            return '';
        }
        var interval = date_fns_1.intervalToDuration({
            start: new Date(value.start),
            end: new Date(value.end),
        });
        if (!interval) {
            return '';
        }
        var customInterval = {};
        Object.entries(interval).forEach(function (_a) {
            var key = _a[0], value = _a[1];
            if (value != null && value < 10) {
                customInterval[key] = "0" + value;
            }
            else {
                customInterval[key] = "" + value;
            }
        });
        var durationText = '';
        if (!!interval.years) {
            durationText += customInterval.years + "y ";
        }
        if (!!interval.years || !!interval.months) {
            durationText += customInterval.months + "m ";
        }
        if (!!interval.years || !!interval.months || !!interval.days) {
            durationText += customInterval.days + "d ";
        }
        durationText += customInterval.hours + ":" + customInterval.minutes + ":" + customInterval.seconds;
        return durationText;
    }, []);
    return react_1.default.createElement(Txt_1.Txt, null, duration);
});
