"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.typeWidgets = exports.defaultFormats = void 0;
var ArrayWidget_1 = __importDefault(require("./ArrayWidget"));
var BadgeWidget_1 = __importDefault(require("./BadgeWidget"));
var ButtonGroupWidget_1 = __importDefault(require("./ButtonGroupWidget"));
var ButtonWidget_1 = __importDefault(require("./ButtonWidget"));
var CheckboxWidget_1 = __importDefault(require("./CheckboxWidget"));
var ColorWidget_1 = __importDefault(require("./ColorWidget"));
var DropDownButtonWidget_1 = __importDefault(require("./DropDownButtonWidget"));
var HeadingWidget_1 = __importDefault(require("./HeadingWidget"));
var HighlightedNameWidget_1 = __importDefault(require("./HighlightedNameWidget"));
var ImgWidget_1 = __importDefault(require("./ImgWidget"));
var LinkWidget_1 = __importDefault(require("./LinkWidget"));
var ListWidget_1 = __importDefault(require("./ListWidget"));
var ObjectWidget_1 = __importDefault(require("./ObjectWidget"));
var ProgressBarWidget_1 = __importDefault(require("./ProgressBarWidget"));
var TagWidget_1 = __importDefault(require("./TagWidget"));
var TxtWidget_1 = __importDefault(require("./TxtWidget"));
var widget_util_1 = require("./widget-util");
var ElapsedTimeWidget_1 = require("./ElapsedTimeWidget");
var DurationWidget_1 = require("./DurationWidget");
var CodeWidget_1 = require("./CodeWidget");
var HashWidget_1 = require("./HashWidget");
var TemperatureWidget_1 = require("./TemperatureWidget");
var PercentageWidget_1 = require("./PercentageWidget");
var DisabledTextWidget_1 = require("./DisabledTextWidget");
var BooleanAsIconWidget_1 = require("./BooleanAsIconWidget");
var PlaceholderTextWidget_1 = require("./PlaceholderTextWidget");
var ui_options_1 = require("./ui-options");
Object.defineProperty(exports, "WidgetWrapperUiOptions", { enumerable: true, get: function () { return ui_options_1.WidgetWrapperUiOptions; } });
var widget_util_2 = require("./widget-util");
Object.defineProperty(exports, "getObjectPropertyNames", { enumerable: true, get: function () { return widget_util_2.getObjectPropertyNames; } });
Object.defineProperty(exports, "WidgetFactory", { enumerable: true, get: function () { return widget_util_2.widgetFactory; } });
var WidgetMeta_1 = require("./WidgetMeta");
Object.defineProperty(exports, "WidgetMeta", { enumerable: true, get: function () { return WidgetMeta_1.default; } });
exports.defaultFormats = __spreadArrays([
    {
        name: 'color',
        format: '.*',
        widget: ColorWidget_1.default,
    },
    {
        name: 'uri',
        format: '.*',
        widget: LinkWidget_1.default,
    },
    {
        name: 'email',
        format: '.*',
        widget: LinkWidget_1.default,
    },
    {
        name: 'elapsed-date-time',
        format: '.*',
        widget: ElapsedTimeWidget_1.ElapsedTimeWidget,
    },
    {
        name: 'duration',
        format: '.*',
        widget: DurationWidget_1.DurationWidget,
    },
    {
        name: 'code',
        format: '.*',
        widget: CodeWidget_1.CodeWidget,
    },
    {
        name: 'hash',
        format: '.*',
        widget: HashWidget_1.HashWidget,
    },
    {
        name: 'temperature',
        format: '.*',
        widget: TemperatureWidget_1.TemperatureWidget,
    },
    {
        name: 'percentage',
        format: '.*',
        widget: PercentageWidget_1.PercentageWidget,
    },
    {
        name: 'disabled-text',
        format: '.*',
        widget: DisabledTextWidget_1.DisabledTextWidget,
    },
    {
        name: 'boolean-as-icon',
        format: '.*',
        widget: BooleanAsIconWidget_1.BooleanAsIconWidget,
    },
    {
        name: 'placeholder-text',
        format: '.*',
        widget: PlaceholderTextWidget_1.PlaceholderTextWidget,
    }
], [
    ArrayWidget_1.default,
    BadgeWidget_1.default,
    ButtonGroupWidget_1.default,
    ButtonWidget_1.default,
    CheckboxWidget_1.default,
    ColorWidget_1.default,
    DropDownButtonWidget_1.default,
    HeadingWidget_1.default,
    HighlightedNameWidget_1.default,
    ImgWidget_1.default,
    LinkWidget_1.default,
    ListWidget_1.default,
    ObjectWidget_1.default,
    ProgressBarWidget_1.default,
    TagWidget_1.default,
    TxtWidget_1.default,
].map(function (widget) { return ({
    name: widget.displayName,
    format: '.*',
    widget: widget.uiOptions
        ? widget_util_1.withOptionProps(widget.uiOptions)(widget)
        : widget,
}); }));
exports.typeWidgets = {
    object: ObjectWidget_1.default,
    string: TxtWidget_1.default,
    null: TxtWidget_1.default,
    integer: TxtWidget_1.default,
    number: TxtWidget_1.default,
    boolean: TxtWidget_1.default,
    array: ArrayWidget_1.default,
    default: TxtWidget_1.default,
};
