"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Menu = void 0;
var react_1 = __importDefault(require("react"));
var react_router_1 = require("react-router");
var react_router_dom_1 = require("react-router-dom");
var styled_components_1 = __importDefault(require("styled-components"));
var Badge_1 = require("../Badge");
var Flex_1 = require("../Flex");
var Txt_1 = require("../Txt");
var StyledBadge = styled_components_1.default(Badge_1.Badge)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tborder-radius: 0 1em 1em 0;\n\tposition: absolute;\n\ttransform: scale(0.75);\n\tleft: -5%;\n\tbottom: 5%;\n"], ["\n\tborder-radius: 0 1em 1em 0;\n\tposition: absolute;\n\ttransform: scale(0.75);\n\tleft: -5%;\n\tbottom: 5%;\n"])));
var MenuItem = styled_components_1.default(Flex_1.Flex)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\theight: 48px;\n\tcursor: pointer;\n\tborder-bottom: 1px solid\n\t\t", ";\n\tborder-left: ", ";\n\tbackground: ", ";\n\n\t&:hover {\n\t\tbackground: ", ";\n\t}\n\tposition: relative;\n"], ["\n\theight: 48px;\n\tcursor: pointer;\n\tborder-bottom: 1px solid\n\t\t",
    ";\n\tborder-left: ",
    ";\n\tbackground: ",
    ";\n\n\t&:hover {\n\t\tbackground: ",
    ";\n\t}\n\tposition: relative;\n"])), function (props) {
    return props.isCurrent
        ? props.theme.colors.quartenary.light
        : props.theme.colors.tertiary.dark;
}, function (props) {
    return props.isCurrent ? "2px solid " + props.theme.colors.primary.main : 'none';
}, function (props) {
    return props.isCurrent
        ? props.theme.colors.quartenary.light
        : props.theme.colors.secondary.dark;
}, function (props) {
    return props.isCurrent
        ? props.theme.colors.quartenary.light
        : props.theme.colors.tertiary.dark;
});
exports.Menu = function (_a) {
    var items = _a.items, isCollapsed = _a.isCollapsed, props = __rest(_a, ["items", "isCollapsed"]);
    var pathname = react_router_1.useLocation().pathname;
    var currentItem = react_1.default.useMemo(function () {
        return (items.find(function (item) { return pathname === item.href; }) ||
            items.find(function (item) { return pathname.startsWith(item.href); }));
    }, [items, pathname]);
    return (react_1.default.createElement(Flex_1.Flex, __assign({ flexDirection: "column" }, props), items.map(function (item) {
        var isCurrent = currentItem === item;
        return (react_1.default.createElement(react_router_dom_1.NavLink, { key: item.href, to: item.href },
            react_1.default.createElement(MenuItem, { className: item.className, width: "100%", isCurrent: isCurrent, px: 3, py: 2, flexDirection: "row", alignItems: "center", justifyContent: isCollapsed ? 'center' : 'unset' },
                !!item.badge && react_1.default.createElement(StyledBadge, __assign({}, item.badge)),
                !!item.icon && (react_1.default.createElement(Txt_1.Txt.span, { bold: true, color: isCurrent ? 'text.main' : 'secondary.semilight', fontSize: isCollapsed ? 4 : 3, mr: isCollapsed ? 0 : 2 }, item.icon)),
                !isCollapsed && (react_1.default.createElement(Txt_1.Txt.span, { bold: true, fontSize: 2, style: { lineHeight: 1.33 }, color: isCurrent ? 'text.main' : 'quartenary.main' }, item.title)),
                !item.icon && isCollapsed && (react_1.default.createElement(Txt_1.Txt.span, { bold: true, tooltip: item.title, color: isCurrent ? 'text.main' : 'secondary.semilight', fontSize: 4, ml: 1 }, item.title.charAt(0).toUpperCase())))));
    })));
};
var templateObject_1, templateObject_2;
