"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Storage = exports.Memory = exports.CpuTemp = exports.CpuUsage = void 0;
var react_1 = __importDefault(require("react"));
var faMicrochip_1 = require("@fortawesome/free-solid-svg-icons/faMicrochip");
var faMemory_1 = require("@fortawesome/free-solid-svg-icons/faMemory");
var faHdd_1 = require("@fortawesome/free-solid-svg-icons/faHdd");
var utils_1 = require("../../stories/utils");
var _1 = require(".");
exports.default = {
    title: 'Core/StatsBar',
    component: _1.StatsBar,
};
var Template = utils_1.createTemplate(_1.StatsBar);
exports.CpuUsage = utils_1.createStory(Template, {
    title: react_1.default.createElement(_1.StatsTitle, { icon: faMicrochip_1.faMicrochip, title: "CPU" }),
    labelFormatter: function (_a) {
        var value = _a.value;
        return "~" + value + "%";
    },
    value: 23,
    max: 100,
    numSlices: 5,
});
exports.CpuTemp = utils_1.createStory(Template, {
    title: react_1.default.createElement(_1.StatsTitle, { icon: faMicrochip_1.faMicrochip, title: "Temperature" }),
    labelFormatter: function (_a) {
        var value = _a.value;
        return "~" + value + "C";
    },
    value: 34,
    max: 100,
});
exports.Memory = utils_1.createStory(Template, {
    title: react_1.default.createElement(_1.StatsTitle, { icon: faMemory_1.faMemory, title: "Memory" }),
    labelFormatter: function () { return react_1.default.createElement(_1.ValueWithMaxTitle, { value: "453 MB", max: "1 GB" }); },
    value: 453,
    max: 1000,
});
exports.Storage = utils_1.createStory(Template, {
    title: (react_1.default.createElement(_1.StatsTitle, { icon: faHdd_1.faHdd, title: "Storage", description: "Storage block device" })),
    labelFormatter: function () { return react_1.default.createElement(_1.ValueWithMaxTitle, { value: "623 MB", max: "1 GB" }); },
    value: 623,
    max: 1000,
});
