"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StatsBar = exports.StatsTitle = exports.ValueWithMaxTitle = void 0;
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var range_1 = __importDefault(require("lodash/range"));
var react_1 = __importDefault(require("react"));
var Box_1 = require("../Box");
var Flex_1 = require("../Flex");
var ProgressBar_1 = require("../ProgressBar");
var Txt_1 = require("../Txt");
exports.ValueWithMaxTitle = function (_a) {
    var value = _a.value, max = _a.max;
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Txt_1.Txt.span, null, value),
        "/",
        react_1.default.createElement(Txt_1.Txt.span, { color: "tertiary.main" }, max)));
};
var getDiscreteBarValue = function (value, numSlices, index) {
    var highlightedNumSlices = Math.ceil(value / (100 / numSlices));
    if (numSlices <= 1) {
        return value;
    }
    return highlightedNumSlices > index ? 100 : 0;
};
var DiscreteBar = function (_a) {
    var value = _a.value, numSlices = _a.numSlices, props = __rest(_a, ["value", "numSlices"]);
    return (react_1.default.createElement(Flex_1.Flex, { flexDirection: "row" }, range_1.default(numSlices).map(function (idx, i) { return (react_1.default.createElement(Box_1.Box, { key: i, flex: 1, mr: idx === numSlices - 1 ? 0 : 2 },
        react_1.default.createElement(ProgressBar_1.ProgressBar, __assign({ value: getDiscreteBarValue(value, numSlices, idx) }, props)))); })));
};
exports.StatsTitle = function (_a) {
    var icon = _a.icon, title = _a.title, description = _a.description;
    return (react_1.default.createElement(Flex_1.Flex, { flexDirection: "column", alignItems: "flex-start", justifyContent: "flex-start" },
        react_1.default.createElement(Box_1.Box, null,
            react_1.default.createElement(Txt_1.Txt.span, { mr: 1, color: "tertiary.semilight" },
                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: icon })),
            react_1.default.createElement(Txt_1.Txt.span, null, title)),
        react_1.default.createElement(Txt_1.Txt.span, { color: "tertiary.main", style: { lineHeight: 1 }, fontSize: 0 }, description || '\u200b')));
};
exports.StatsBar = function (_a) {
    var title = _a.title, labelFormatter = _a.labelFormatter, value = _a.value, max = _a.max, numSlices = _a.numSlices, props = __rest(_a, ["title", "labelFormatter", "value", "max", "numSlices"]);
    var percentage = (value / (max !== null && max !== void 0 ? max : 100)) * 100;
    var bg = __assign(__assign(__assign({}, (percentage <= 60 ? { success: true } : {})), (percentage > 60 && percentage <= 80 ? { warning: true } : {})), (percentage > 80 ? { danger: true } : {}));
    return (react_1.default.createElement(Flex_1.Flex, __assign({ flex: 1, minWidth: 152, flexDirection: "column" }, props),
        react_1.default.createElement(Flex_1.Flex, { mb: 2, flexDirection: "row", alignItems: "flex-start", justifyContent: "space-between" },
            react_1.default.createElement(Txt_1.Txt.span, null, title),
            react_1.default.createElement(Txt_1.Txt.span, null, labelFormatter ? labelFormatter({ value: value, max: max }) : value)),
        react_1.default.createElement(DiscreteBar, __assign({ numSlices: numSlices !== null && numSlices !== void 0 ? numSlices : 1, value: percentage }, bg))));
};
