"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var enzyme_1 = require("enzyme");
var __1 = require("../../");
describe('Steps component', function () {
    it('Error thrown if ordered is true and activeStepIndex is not set', function () {
        expect(function () {
            enzyme_1.mount(react_1.default.createElement(__1.Provider, null,
                react_1.default.createElement(__1.Steps, { m: 3, ordered: true, bordered: false },
                    react_1.default.createElement(__1.Step, { status: "completed", onClick: function () { return null; } }, "Do this"),
                    react_1.default.createElement(__1.Step, { status: "completed", onClick: function () { return null; } }, "And then this"),
                    react_1.default.createElement(__1.Step, { status: "pending", onClick: function () { return null; } }, "And finally this"))));
        }).toThrowError('You must specify the activeStepIndex for ordered Steps');
    });
    it('Error thrown if activeStepIndex is too high', function () {
        expect(function () {
            enzyme_1.mount(react_1.default.createElement(__1.Provider, null,
                react_1.default.createElement(__1.Steps, { m: 3, ordered: true, bordered: false, activeStepIndex: 3 },
                    react_1.default.createElement(__1.Step, { status: "completed", onClick: function () { return null; } }, "Do this"),
                    react_1.default.createElement(__1.Step, { status: "completed", onClick: function () { return null; } }, "And then this"),
                    react_1.default.createElement(__1.Step, { status: "pending", onClick: function () { return null; } }, "And finally this"))));
        }).toThrowError('activeStepIndex is out of range');
    });
});
