"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Closable = exports.Clickable = exports.Overflow = exports.MultipleValues = exports.Empty = exports.OnlyName = exports.OnlyValue = exports.Default = void 0;
var utils_1 = require("../../stories/utils");
var _1 = require(".");
exports.default = {
    title: 'Core/Tag',
    component: _1.Tag,
};
var Template = utils_1.createTemplate(_1.Tag);
exports.Default = utils_1.createStory(Template, {
    name: 'Tag',
    value: 'Value',
});
exports.OnlyValue = utils_1.createStory(Template, {
    value: 'Value',
});
exports.OnlyName = utils_1.createStory(Template, {
    value: 'Name',
});
exports.Empty = utils_1.createStory(Template, {});
exports.MultipleValues = utils_1.createStory(Template, {
    multiple: [
        { name: 'Tag1', operator: 'contains', value: 'value1' },
        {
            prefix: 'or',
            name: 'Tag2',
            operator: 'contains',
            value: 'value2',
        },
    ],
});
exports.Overflow = utils_1.createStory(Template, {
    multiple: [
        { name: 'Tag1', operator: 'contains', value: 'value1' },
        {
            prefix: 'or',
            name: 'Tag2',
            operator: 'contains',
            value: 'value2',
        },
        {
            prefix: 'or',
            name: 'Tag3',
            operator: 'contains',
            value: 'value3',
        },
        {
            prefix: 'or',
            name: 'Tag4',
            operator: 'contains',
            value: 'value4',
        },
    ],
});
exports.Clickable = utils_1.createStory(Template, {
    name: 'Tag',
    value: 'Value',
    onClick: function () { return null; },
});
exports.Closable = utils_1.createStory(Template, {
    name: 'Tag',
    value: 'Value',
    onClose: function () { return null; },
});
