"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Create = void 0;
var react_1 = __importDefault(require("react"));
var schemaOps_1 = require("../schemaOps");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var utils_1 = require("../utils");
var Button_1 = require("../../../components/Button");
var faMagic_1 = require("@fortawesome/free-solid-svg-icons/faMagic");
var useTranslation_1 = require("../../../hooks/useTranslation");
var Box_1 = require("../../../components/Box");
exports.Create = function (_a) {
    var model = _a.model, autouiContext = _a.autouiContext, hasOngoingAction = _a.hasOngoingAction, onActionTriggered = _a.onActionTriggered;
    var t = useTranslation_1.useTranslation().t;
    var actions = autouiContext.actions;
    var createActions = actions === null || actions === void 0 ? void 0 : actions.filter(function (action) { return action.type === 'create'; });
    if (!createActions || createActions.length < 1) {
        return null;
    }
    if (createActions.length > 1) {
        throw new Error('Only one create action per resource is allowed');
    }
    var disabledReason = !!createActions[0].isDisabled
        ? createActions[0].isDisabled({})
        : utils_1.getCreateDisabledReason(model.permissions, hasOngoingAction, t);
    return (react_1.default.createElement(Box_1.Box, null,
        react_1.default.createElement(Button_1.Button, { "data-action": "create-" + model.resource, onClick: function () {
                return onActionTriggered({
                    action: createActions[0],
                    schema: schemaOps_1.autoUIJsonSchemaPick(model.schema, model.permissions.create),
                });
            }, icon: react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faMagic_1.faMagic }), tooltip: typeof disabledReason === 'string' ? disabledReason : undefined, disabled: !!disabledReason, primary: true }, createActions[0].title)));
};
