"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Update = void 0;
var react_1 = __importDefault(require("react"));
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var schemaOps_1 = require("../schemaOps");
var utils_1 = require("../utils");
var DropDownButton_1 = require("../../../components/DropDownButton");
var faEllipsisH_1 = require("@fortawesome/free-solid-svg-icons/faEllipsisH");
var useTranslation_1 = require("../../../hooks/useTranslation");
var groupBy_1 = __importDefault(require("lodash/groupBy"));
var map_1 = __importDefault(require("lodash/map"));
var Button_1 = require("../../../components/Button");
var Box_1 = require("../../../components/Box");
exports.Update = function (_a) {
    var _b, _c;
    var model = _a.model, autouiContext = _a.autouiContext, selected = _a.selected, hasOngoingAction = _a.hasOngoingAction, onActionTriggered = _a.onActionTriggered;
    var t = useTranslation_1.useTranslation().t;
    var actions = autouiContext.actions;
    var updateActions = actions === null || actions === void 0 ? void 0 : actions.filter(function (action) { return action.type === 'update' || action.type === 'delete'; }).sort(function (a) { return (a.type === 'delete' ? 1 : -1); }).sort(function (a) { return (a.isDangerous ? 1 : a.type === 'delete' ? 0 : -1); });
    if (!updateActions || updateActions.length < 1) {
        return null;
    }
    if (updateActions.length === 1) {
        var action_1 = updateActions[0];
        var disabledReason_1 = (_b = utils_1.autoUIGetDisabledReason(selected, hasOngoingAction, action_1.type, t)) !== null && _b !== void 0 ? _b : (_c = action_1.isDisabled) === null || _c === void 0 ? void 0 : _c.call(action_1, { affectedEntries: selected });
        return (react_1.default.createElement(Box_1.Box, { alignSelf: "flex-start" },
            react_1.default.createElement(Button_1.Button, { key: action_1.title, "data-action": action_1.type + "-" + model.resource, onClick: function () {
                    return onActionTriggered({
                        action: action_1,
                        schema: action_1.type === 'delete'
                            ? {}
                            : schemaOps_1.autoUIJsonSchemaPick(model.schema, model.permissions[action_1.type]),
                        affectedEntries: selected,
                    });
                }, tooltip: typeof disabledReason_1 === 'string' ? disabledReason_1 : undefined, disabled: !!disabledReason_1, plain: updateActions.length > 1, danger: action_1.isDangerous, secondary: true }, action_1.title)));
    }
    var groupedActions = groupBy_1.default(updateActions, function (action) { return !!action.isDangerous; });
    var actionHandlers = map_1.default(groupedActions, function (actions) {
        return actions.map(function (action) {
            var _a, _b;
            var disabledReason = (_a = utils_1.autoUIGetDisabledReason(selected, hasOngoingAction, action.type, t)) !== null && _a !== void 0 ? _a : (_b = action.isDisabled) === null || _b === void 0 ? void 0 : _b.call(action, { affectedEntries: selected });
            return {
                content: action.title,
                onClick: function () {
                    return onActionTriggered({
                        action: action,
                        schema: action.type === 'delete'
                            ? {}
                            : schemaOps_1.autoUIJsonSchemaPick(model.schema, model.permissions[action.type]),
                        affectedEntries: selected,
                    });
                },
                tooltip: typeof disabledReason === 'string' ? disabledReason : undefined,
                disabled: !!disabledReason,
                danger: action.isDangerous,
            };
        });
    });
    var disabledReason = utils_1.autoUIGetDisabledReason(selected, hasOngoingAction, null, t);
    return (react_1.default.createElement(Box_1.Box, { alignSelf: "flex-start" },
        react_1.default.createElement(DropDownButton_1.DropDownButton, { compact: [true, true, false, false], joined: true, alignRight: true, secondary: true, disabled: !!disabledReason, tooltip: disabledReason, icon: react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faEllipsisH_1.faEllipsisH }), label: t('labels.actions'), items: actionHandlers })));
};
