"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("../../stories/utils");
var helpers_1 = require("./models/helpers");
var example_1 = require("./models/example");
var _1 = require(".");
var Button_1 = require("../../components/Button");
var flatten_1 = __importDefault(require("lodash/flatten"));
var Heading_1 = require("../../components/Heading");
exports.default = {
    title: 'Extra/AutoUI',
    component: _1.AutoUI,
};
var DemoAutoUI = function (_a) {
    var data = _a.data, model = _a.model, otherProps = __rest(_a, ["data", "model"]);
    var _b = react_1.default.useState(true), dataIsArray = _b[0], setDataIsArray = _b[1];
    var memoizedData = react_1.default.useMemo(function () {
        return helpers_1.autoUIRunTransformers(example_1.dataExample, example_1.transformers, {
            accessRole: 'administrator',
        });
    }, [example_1.dataExample]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Heading_1.Heading.h5, null, "The AutoUI component determines whether the data passed into it is a collection or an entity. Click the button below to change the value passed in for \"data\"."),
        react_1.default.createElement(Button_1.Button, { onClick: function () { return setDataIsArray(!dataIsArray); }, label: "Pass an " + (dataIsArray ? 'entity' : 'array') + " for \"data\"", my: 3 }),
        react_1.default.createElement(_1.AutoUI, __assign({ data: dataIsArray
                ? data !== null && data !== void 0 ? data : memoizedData : flatten_1.default([data !== null && data !== void 0 ? data : memoizedData])[0], model: model !== null && model !== void 0 ? model : helpers_1.autoUIGetModelForCollection(example_1.model), actions: [] }, otherProps))));
};
var Template = utils_1.createTemplate(DemoAutoUI);
exports.Default = utils_1.createStory(Template, {});
