"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomWidget = void 0;
var react_1 = __importDefault(require("react"));
var types_1 = require("../../components/Renderer/types");
var widget_util_1 = require("../../components/Renderer/widgets/widget-util");
var Renderer_1 = require("../../components/Renderer");
var castArray_1 = __importDefault(require("lodash/castArray"));
exports.CustomWidget = function (_a) {
    var value = _a.value, extraContext = _a.extraContext, schema = _a.schema, extraFormats = _a.extraFormats, uiSchema = _a.uiSchema;
    var processedUiSchema = widget_util_1.transformUiSchema({
        value: value,
        uiSchema: uiSchema,
        extraContext: extraContext,
    });
    var processedValue = Renderer_1.getValue(value, schema, processedUiSchema);
    var types = (schema === null || schema === void 0 ? void 0 : schema.type) != null ? castArray_1.default(schema.type) : [];
    if (processedValue === undefined ||
        (processedValue === null && !types.includes(types_1.JsonTypes.null))) {
        return null;
    }
    var Widget = Renderer_1.getWidget(processedValue, schema.format, undefined, extraFormats);
    return (react_1.default.createElement(Widget, { extraContext: extraContext, extraFormats: extraFormats, value: processedValue, schema: schema }));
};
