import React from 'react';
import type { JSONSchema7 as JSONSchema } from 'json-schema';
import { AutoUIContext, AutoUIBaseResource } from '../schemaOps';
import { FilterRenderMode, FiltersView } from '../../../components/Filters';
interface FiltersProps<T> {
    schema: JSONSchema;
    filters: JSONSchema[];
    views: FiltersView[];
    autouiContext: AutoUIContext<T>;
    changeFilters: (filters: JSONSchema[]) => void;
    changeViews: (views: FiltersView[]) => void;
    renderMode?: FilterRenderMode;
    onSearch?: (searchTerm: string) => React.ReactElement | null;
}
export declare const Filters: <T extends AutoUIBaseResource<T>>({ schema, filters, views, changeFilters, changeViews, autouiContext, renderMode, onSearch, }: FiltersProps<T>) => JSX.Element;
export {};
