"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FocusSearch = void 0;
var react_1 = __importDefault(require("react"));
var Txt_1 = require("../../../components/Txt");
var Checkbox_1 = require("../../../components/Checkbox");
var reject_1 = __importDefault(require("lodash/reject"));
var styled_components_1 = __importDefault(require("styled-components"));
var Box_1 = require("../../../components/Box");
var Flex_1 = require("../../../components/Flex");
var useHistory_1 = require("../../../hooks/useHistory");
var utils_1 = require("../../../utils");
var SchemaSieve_1 = require("../../../components/Filters/SchemaSieve");
var helpers_1 = require("../models/helpers");
var Focus = styled_components_1.default(Box_1.Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tflex-basis: 100%;\n\tbackground-color: white;\n\tborder: solid 1px ", ";\n\tmax-height: 200px;\n\tposition: absolute;\n\twidth: 100%;\n\tz-index: 1;\n\tborder-radius: 0 0 ", "\n\t\t", ";\n\toverflow: hidden;\n"], ["\n\tflex-basis: 100%;\n\tbackground-color: white;\n\tborder: solid 1px ", ";\n\tmax-height: 200px;\n\tposition: absolute;\n\twidth: 100%;\n\tz-index: 1;\n\tborder-radius: 0 0 ", "\n\t\t", ";\n\toverflow: hidden;\n"])), function (props) { return props.theme.colors.quartenary.dark; }, function (props) { return props.theme.global.drop.border.radius; }, function (props) { return props.theme.global.drop.border.radius; });
var FocusContent = styled_components_1.default(Box_1.Box)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tmax-height: 180px;\n\toverflow-y: auto;\n\toverflow-x: auto;\n"], ["\n\tmax-height: 180px;\n\toverflow-y: auto;\n\toverflow-x: auto;\n"])));
var FocusItem = styled_components_1.default(Box_1.Box)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\tcursor: ", ";\n\t&:hover {\n\t\tbackground: #dde1f0; // This is the background color Select uses for entities on hover. We do not have it in our theme\n\t}\n"], ["\n\tcursor: ", ";\n\t&:hover {\n\t\tbackground: #dde1f0; // This is the background color Select uses for entities on hover. We do not have it in our theme\n\t}\n"])), function (props) { return (props.hasGetBaseUrl ? 'pointer' : 'default'); });
exports.FocusSearch = function (_a) {
    var searchTerm = _a.searchTerm, filtered = _a.filtered, selected = _a.selected, setSelected = _a.setSelected, autouiContext = _a.autouiContext, model = _a.model, hasUpdateActions = _a.hasUpdateActions;
    var history = useHistory_1.useHistory();
    var filteredFittingSearchTerms = react_1.default.useMemo(function () {
        var filter = SchemaSieve_1.createFullTextSearchFilter(model.schema, searchTerm);
        return SchemaSieve_1.filter(filter, filtered);
    }, [searchTerm, filtered]);
    var getEntityValue = function (entity) {
        var _a, _b, _c;
        var property = (_a = model.priorities) === null || _a === void 0 ? void 0 : _a.primary[0];
        var schemaProperty = (_b = model.schema.properties) === null || _b === void 0 ? void 0 : _b[property];
        var refScheme = schemaProperty
            ? helpers_1.getPropertyRefScheme(schemaProperty)
            : null;
        if (!refScheme || typeof schemaProperty === 'boolean') {
            return entity[property];
        }
        return (schemaProperty === null || schemaProperty === void 0 ? void 0 : schemaProperty.type) === 'array'
            ? (_c = entity[property][0]) === null || _c === void 0 ? void 0 : _c[refScheme] : (schemaProperty === null || schemaProperty === void 0 ? void 0 : schemaProperty.type) === 'object'
            ? entity[property][refScheme]
            : entity[property];
    };
    if (!filteredFittingSearchTerms.length) {
        return (react_1.default.createElement(Focus, null,
            react_1.default.createElement(Flex_1.Flex, { justifyContent: "space-around", py: 2 },
                react_1.default.createElement("em", null, "no results"))));
    }
    return (react_1.default.createElement(Focus, null,
        react_1.default.createElement(FocusContent, null, filteredFittingSearchTerms.map(function (entity) { return (react_1.default.createElement(FocusItem, { px: 1, py: 2, key: entity.id, onClick: function (e) {
                var _a;
                e.preventDefault();
                if (autouiContext.getBaseUrl && history) {
                    try {
                        var url = new URL(autouiContext.getBaseUrl(entity));
                        window.open(url.toString(), '_blank');
                    }
                    catch (err) {
                        (_a = history.push) === null || _a === void 0 ? void 0 : _a.call(history, autouiContext.getBaseUrl(entity));
                    }
                }
            }, hasGetBaseUrl: !!autouiContext.getBaseUrl },
            react_1.default.createElement(Flex_1.Flex, { flexDirection: "row" },
                hasUpdateActions && (react_1.default.createElement(Flex_1.Flex, { flexDirection: "column", ml: 1, mr: 3, alignItems: "center" },
                    react_1.default.createElement(Checkbox_1.Checkbox, { onChange: function () {
                            var isChecked = !!selected.find(function (s) { return s.id === entity.id; });
                            var checkedItems = !isChecked
                                ? selected.concat(entity)
                                : reject_1.default(selected, {
                                    id: entity.id,
                                });
                            setSelected(checkedItems);
                        }, checked: !!selected.find(function (s) { return s.id === entity.id; }), onClick: utils_1.stopEvent }))),
                react_1.default.createElement(Flex_1.Flex, { flexDirection: "column", alignItems: "center", ml: !hasUpdateActions ? 1 : undefined },
                    react_1.default.createElement(Txt_1.Txt, null, getEntityValue(entity)))))); }))));
};
var templateObject_1, templateObject_2, templateObject_3;
