"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLensForTarget = exports.getLensBySlug = exports.getLens = exports.getLenses = void 0;
var groupBy_1 = __importDefault(require("lodash/groupBy"));
var sortBy_1 = __importDefault(require("lodash/sortBy"));
var find_1 = __importDefault(require("lodash/find"));
var first_1 = __importDefault(require("lodash/first"));
var flatten_1 = __importDefault(require("lodash/flatten"));
var values_1 = __importDefault(require("lodash/values"));
var skhema_1 = __importDefault(require("skhema"));
var json_e_1 = __importDefault(require("json-e"));
var types = __importStar(require("./types"));
var map_1 = __importDefault(require("lodash/map"));
var uniq_1 = __importDefault(require("lodash/uniq"));
var lenses = Object.values(types);
exports.getLenses = function (data, context, customLenses) {
    if (context === void 0) { context = {}; }
    if (!data) {
        return [];
    }
    var filteredLenses = lenses.concat(customLenses !== null && customLenses !== void 0 ? customLenses : []);
    var slugs = filteredLenses.map(function (lens) { return lens.slug; });
    if (slugs.length > uniq_1.default(slugs).length) {
        throw new Error('Lenses must have unique slugs');
    }
    var sortedData = filteredLenses
        .map(function (lens) {
        var filter = json_e_1.default(lens.data.filter, context);
        return {
            lens: lens,
            match: skhema_1.default.match(filter, data),
        };
    })
        .filter(function (value) { return value.match.valid; });
    sortedData = flatten_1.default(values_1.default(map_1.default(groupBy_1.default(sortedData, 'lens.data.format'), function (group) {
        return group.reduce(function (prev, current) {
            if (current.match.score > prev.match.score) {
                return current;
            }
            else {
                return prev;
            }
        });
    })));
    return sortBy_1.default(sortedData, 'match.score')
        .reverse()
        .map(function (value) { return value.lens; });
};
exports.getLens = function (data, context) {
    return first_1.default(exports.getLenses(data, context));
};
exports.getLensBySlug = function (slug) {
    var fullList = flatten_1.default(values_1.default(lenses));
    return (find_1.default(fullList, {
        slug: slug,
    }) || null);
};
exports.getLensForTarget = function (target) {
    return find_1.default(lenses, function (lens) {
        return (lens.data.pathRegExp && new RegExp(lens.data.pathRegExp).test(target));
    });
};
