"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.entity = void 0;
var react_1 = __importDefault(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var faCube_1 = require("@fortawesome/free-solid-svg-icons/faCube");
var Flex_1 = require("../../../../components/Flex");
var Card_1 = require("../../../../components/Card");
var Txt_1 = require("../../../../components/Txt");
var Heading_1 = require("../../../../components/Heading");
var Divider_1 = require("../../../../components/Divider");
var Update_1 = require("../../Actions/Update");
var Label = styled_components_1.default(Txt_1.Txt)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tcolor: #252629;\n\tfont-size: 11px;\n\ttext-transform: uppercase;\n\tmargin-bottom: 6px;\n"], ["\n\tcolor: #252629;\n\tfont-size: 11px;\n\ttext-transform: uppercase;\n\tmargin-bottom: 6px;\n"])));
exports.entity = {
    slug: 'entity',
    name: 'Default entity lens',
    data: {
        label: 'Entity',
        format: 'summary',
        renderer: function (_a) {
            var _b;
            var data = _a.data, properties = _a.properties, hasUpdateActions = _a.hasUpdateActions, model = _a.model, autouiContext = _a.autouiContext;
            var _c = react_1.default.useState(), actionData = _c[0], setActionData = _c[1];
            var onActionTriggered = react_1.default.useCallback(function (actionData) {
                setActionData(actionData);
                if (actionData.action.actionFn) {
                    actionData.action.actionFn({
                        affectedEntries: actionData.affectedEntries || [],
                    });
                }
            }, []);
            var onActionDone = react_1.default.useCallback(function () {
                setActionData(undefined);
            }, []);
            return (react_1.default.createElement(Card_1.Card, null, data && (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(Flex_1.Flex, { flexDirection: "row", justifyContent: "space-between" },
                    react_1.default.createElement(Flex_1.Flex, { flexDirection: "column" },
                        react_1.default.createElement(Heading_1.Heading.h2, null, properties.length > 0 &&
                            properties[0].render(data[properties[0].key], data))),
                    react_1.default.createElement(Flex_1.Flex, { flexDirection: "column", alignItems: "flex-end" }, hasUpdateActions && (react_1.default.createElement(Update_1.Update, { model: model, selected: [data], autouiContext: autouiContext, hasOngoingAction: false, onActionTriggered: onActionTriggered })))),
                react_1.default.createElement(Divider_1.Divider, null),
                react_1.default.createElement(Flex_1.Flex, { flexDirection: "row", flexWrap: "wrap", justifyContent: "space-between", alignItems: "center" }, properties.map(function (property) {
                    return property.priority !== 'primary' && (react_1.default.createElement(Flex_1.Flex, { flexDirection: "column", m: 10, key: property.key, flex: ['100%', '0 0 30%'] },
                        react_1.default.createElement(Label, null, property.title),
                        react_1.default.createElement(Txt_1.Txt, null, property.render(data[property.key], data))));
                })),
                ((_b = actionData === null || actionData === void 0 ? void 0 : actionData.action) === null || _b === void 0 ? void 0 : _b.renderer) &&
                    actionData.action.renderer({
                        schema: actionData.schema,
                        affectedEntries: actionData.affectedEntries,
                        onDone: onActionDone,
                    })))));
        },
        icon: faCube_1.faCube,
        type: '*',
        filter: {
            type: 'object',
            properties: {
                id: {
                    type: 'number',
                },
            },
        },
    },
};
var templateObject_1;
