"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getColumnsFromSchema = exports.autoUIGetDisabledReason = exports.autoUIJsonSchemaPick = exports.autoUIAddToSchema = exports.autoUIGetModelForCollection = exports.autoUIDefaultPermissions = exports.autoUIRunTransformers = exports.AutoUI = void 0;
var react_1 = __importDefault(require("react"));
var schemaOps_1 = require("./schemaOps");
Object.defineProperty(exports, "autoUIJsonSchemaPick", { enumerable: true, get: function () { return schemaOps_1.autoUIJsonSchemaPick; } });
var Lenses_1 = require("./Lenses");
var utils_1 = require("../../utils");
var LensSelection_1 = require("./Lenses/LensSelection");
var styled_components_1 = __importDefault(require("styled-components"));
var Flex_1 = require("../../components/Flex");
var SchemaSieve_1 = require("../../components/Filters/SchemaSieve");
var isEqual_1 = __importDefault(require("lodash/isEqual"));
var Spinner_1 = require("../../components/Spinner");
var useTranslation_1 = require("../../hooks/useTranslation");
var NoRecordsFoundArrow_1 = require("./NoRecordsFoundArrow");
var useHistory_1 = require("../../hooks/useHistory");
var Filters_1 = require("./Filters/Filters");
var Box_1 = require("../../components/Box");
var Tags_1 = require("./Actions/Tags");
var Update_1 = require("./Actions/Update");
var Create_1 = require("./Actions/Create");
var helpers_1 = require("./models/helpers");
Object.defineProperty(exports, "autoUIAddToSchema", { enumerable: true, get: function () { return helpers_1.autoUIAddToSchema; } });
Object.defineProperty(exports, "autoUIDefaultPermissions", { enumerable: true, get: function () { return helpers_1.autoUIDefaultPermissions; } });
Object.defineProperty(exports, "autoUIGetModelForCollection", { enumerable: true, get: function () { return helpers_1.autoUIGetModelForCollection; } });
Object.defineProperty(exports, "autoUIRunTransformers", { enumerable: true, get: function () { return helpers_1.autoUIRunTransformers; } });
var utils_2 = require("./utils");
Object.defineProperty(exports, "autoUIGetDisabledReason", { enumerable: true, get: function () { return utils_2.autoUIGetDisabledReason; } });
var FocusSearch_1 = require("./Filters/FocusSearch");
var utils_3 = require("./utils");
var CustomWidget_1 = require("./CustomWidget");
var widgets_1 = require("../../components/Renderer/widgets");
var HeaderGrid = styled_components_1.default(Flex_1.Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t> * {\n\t\t&:first-child {\n\t\t\tmargin-right: 4px;\n\t\t}\n\t\t&:not(:last-child):not(:first-child) {\n\t\t\tmargin-left: 4px;\n\t\t\tmargin-right: 4px;\n\t\t}\n\t\t&:last-child {\n\t\t\tmargin-left: 4px;\n\t\t}\n\t}\n"], ["\n\t> * {\n\t\t&:first-child {\n\t\t\tmargin-right: 4px;\n\t\t}\n\t\t&:not(:last-child):not(:first-child) {\n\t\t\tmargin-left: 4px;\n\t\t\tmargin-right: 4px;\n\t\t}\n\t\t&:last-child {\n\t\t\tmargin-left: 4px;\n\t\t}\n\t}\n"])));
exports.AutoUI = function (_a) {
    var _b;
    var modelRaw = _a.model, data = _a.data, formats = _a.formats, actions = _a.actions, sdk = _a.sdk, customSort = _a.customSort, refresh = _a.refresh, getBaseUrl = _a.getBaseUrl, onEntityClick = _a.onEntityClick, onChange = _a.onChange, customLenses = _a.customLenses, lensContext = _a.lensContext, boxProps = __rest(_a, ["model", "data", "formats", "actions", "sdk", "customSort", "refresh", "getBaseUrl", "onEntityClick", "onChange", "customLenses", "lensContext"]);
    var t = useTranslation_1.useTranslation().t;
    var history = useHistory_1.useHistory();
    var modelRef = react_1.default.useRef(modelRaw);
    var model = react_1.default.useMemo(function () {
        if (isEqual_1.default(modelRaw, modelRef.current)) {
            return modelRef.current;
        }
        return modelRaw;
    }, [modelRaw]);
    var _c = react_1.default.useState([]), filters = _c[0], setFilters = _c[1];
    var _d = react_1.default.useState([]), views = _d[0], setViews = _d[1];
    var _e = react_1.default.useState([]), selected = _e[0], $setSelected = _e[1];
    var _f = react_1.default.useState(), isBusyMessage = _f[0], setIsBusyMessage = _f[1];
    var _g = react_1.default.useState(), actionData = _g[0], setActionData = _g[1];
    var setSelected = react_1.default.useCallback(function (items) {
        $setSelected(items);
        if (!!actionData) {
            setActionData(__assign(__assign({}, actionData), { affectedEntries: items }));
        }
    }, [$setSelected, setActionData, actionData]);
    var showFilters = react_1.default.useMemo(function () { return Array.isArray(data) && !!((data === null || data === void 0 ? void 0 : data.length) && data.length > 0); }, [data]);
    var filtered = react_1.default.useMemo(function () { return (Array.isArray(data) ? SchemaSieve_1.filter(filters, data) : []); }, [data, filters]);
    react_1.default.useEffect(function () {
        setSelected([]);
    }, [filters]);
    var onActionTriggered = react_1.default.useCallback(function (actionData) {
        setActionData(actionData);
        if (actionData.action.actionFn) {
            actionData.action.actionFn({
                affectedEntries: actionData.affectedEntries || [],
            });
        }
    }, []);
    var defaultLensSlug = utils_1.getFromLocalStorage(model.resource + "__view_lens");
    var lenses = react_1.default.useMemo(function () { return Lenses_1.getLenses(data, lensContext, customLenses); }, [data, lensContext, customLenses]);
    var _h = react_1.default.useState(lenses[0]), lens = _h[0], setLens = _h[1];
    react_1.default.useEffect(function () {
        var foundLens = lenses.find(function (lens) { return (lens === null || lens === void 0 ? void 0 : lens.slug) === defaultLensSlug; }) || lenses[0];
        if ((lens === null || lens === void 0 ? void 0 : lens.slug) === (foundLens === null || foundLens === void 0 ? void 0 : foundLens.slug)) {
            return;
        }
        setLens(foundLens);
    }, [lenses]);
    var lensRendererOnEntityClick = react_1.default.useCallback(function (row, event) {
        var _a;
        onEntityClick === null || onEntityClick === void 0 ? void 0 : onEntityClick(row, event);
        if (event.isPropagationStopped() && event.isDefaultPrevented()) {
            return;
        }
        if (getBaseUrl && !event.ctrlKey && !event.metaKey && history) {
            event.preventDefault();
            try {
                var url = new URL(getBaseUrl(row));
                window.open(url.toString(), '_blank');
            }
            catch (err) {
                (_a = history.push) === null || _a === void 0 ? void 0 : _a.call(history, getBaseUrl(row));
            }
        }
    }, [onEntityClick, getBaseUrl, history]);
    var autouiContext = react_1.default.useMemo(function () {
        var _a, _b;
        var tagField = schemaOps_1.getFieldForFormat(model.schema, 'tag');
        var tagsAction = !!(sdk === null || sdk === void 0 ? void 0 : sdk.tags)
            ? {
                title: t('actions.manage_tags'),
                type: 'update',
                renderer: function (_a) {
                    var affectedEntries = _a.affectedEntries, onDone = _a.onDone;
                    return !!affectedEntries && (react_1.default.createElement(Tags_1.Tags, { selected: affectedEntries, autouiContext: autouiContext, onDone: onDone, setIsBusyMessage: setIsBusyMessage, refresh: refresh }));
                },
                isDisabled: function (_a) {
                    var affectedEntries = _a.affectedEntries;
                    return !!affectedEntries &&
                        utils_2.getTagsDisabledReason(affectedEntries, tagField, t);
                },
            }
            : null;
        return {
            resource: model.resource,
            idField: 'id',
            nameField: (_b = (_a = model.priorities) === null || _a === void 0 ? void 0 : _a.primary[0]) !== null && _b !== void 0 ? _b : 'id',
            tagField: tagField,
            getBaseUrl: getBaseUrl,
            onEntityClick: onEntityClick,
            actions: !!tagsAction ? (actions || []).concat(tagsAction) : actions,
            customSort: customSort,
            sdk: sdk,
        };
    }, [model, getBaseUrl, onEntityClick, actions, customSort, sdk]);
    var properties = react_1.default.useMemo(function () {
        return exports.getColumnsFromSchema({
            schema: model.schema,
            idField: autouiContext.idField,
            tagField: autouiContext.tagField,
            customSort: autouiContext.customSort,
            priorities: model.priorities,
            formats: formats,
        });
    }, [
        model.schema,
        autouiContext.idField,
        autouiContext.tagField,
        autouiContext.customSort,
        model.priorities,
    ]);
    var hasUpdateActions = react_1.default.useMemo(function () {
        var _a;
        return !!((_a = actions === null || actions === void 0 ? void 0 : actions.filter(function (action) { return action.type !== 'create'; })) === null || _a === void 0 ? void 0 : _a.length) ||
            !!(sdk === null || sdk === void 0 ? void 0 : sdk.tags);
    }, [actions, sdk === null || sdk === void 0 ? void 0 : sdk.tags]);
    return (react_1.default.createElement(Flex_1.Flex, __assign({ flex: 1, flexDirection: "column" }, boxProps),
        react_1.default.createElement(Spinner_1.Spinner, { flex: 1, label: isBusyMessage !== null && isBusyMessage !== void 0 ? isBusyMessage : t('loading.resource', {
                resource: t("resource." + model.resource + "_plural").toLowerCase(),
            }), show: data == null || !!isBusyMessage },
            react_1.default.createElement(Flex_1.Flex, { height: "100%", flexDirection: "column" },
                Array.isArray(data) && (react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(Box_1.Box, { mb: 3 },
                        react_1.default.createElement(HeaderGrid, { flexWrap: "wrap", justifyContent: "space-between", alignItems: "baseline" },
                            react_1.default.createElement(Create_1.Create, { model: model, autouiContext: autouiContext, hasOngoingAction: false, onActionTriggered: onActionTriggered }),
                            data.length > 0 && (react_1.default.createElement(Update_1.Update, { model: model, selected: selected, autouiContext: autouiContext, hasOngoingAction: false, onActionTriggered: onActionTriggered })),
                            showFilters && (react_1.default.createElement(Box_1.Box, { order: [-1, -1, -1, 0], flex: ['1 0 100%', '1 0 100%', '1 0 100%', 'auto'], alignSelf: "flex-start", mb: 2 },
                                react_1.default.createElement(Filters_1.Filters, { schema: model.schema, filters: filters, views: views, autouiContext: autouiContext, changeFilters: function (updatedFilters) {
                                        setFilters(updatedFilters);
                                        if (onChange) {
                                            onChange({
                                                filters: updatedFilters,
                                            });
                                        }
                                    }, changeViews: setViews, onSearch: function (term) { return (react_1.default.createElement(FocusSearch_1.FocusSearch, { searchTerm: term, filtered: filtered, selected: selected, setSelected: setSelected, autouiContext: autouiContext, model: model, hasUpdateActions: hasUpdateActions })); } }))),
                            data.length > 0 && (react_1.default.createElement(LensSelection_1.LensSelection, { lenses: lenses, lens: lens, setLens: function (lens) {
                                    setLens(lens);
                                    utils_1.setToLocalStorage(model.resource + "__view_lens", lens.slug);
                                } }))),
                        filters.length > 0 && (react_1.default.createElement(Filters_1.Filters, { renderMode: 'summary', schema: model.schema, filters: filters, views: views, autouiContext: autouiContext, changeFilters: setFilters, changeViews: setViews }))),
                    data.length === 0 && (react_1.default.createElement(NoRecordsFoundArrow_1.NoRecordsFoundArrow, null,
                        t("no_data.no_resource_data", {
                            resource: t("resource.item_plural").toLowerCase(),
                        }),
                        react_1.default.createElement("br", null),
                        t('questions.how_about_adding_one'))))),
                !Array.isArray(data) && (react_1.default.createElement(HeaderGrid, null,
                    react_1.default.createElement(LensSelection_1.LensSelection, { lenses: lenses, lens: lens, setLens: function (lens) {
                            setLens(lens);
                            utils_1.setToLocalStorage(model.resource + "__view_lens", lens.slug);
                        } }))),
                lens &&
                    data &&
                    (!Array.isArray(data) ||
                        (Array.isArray(data) && data.length > 0)) && (react_1.default.createElement(lens.data.renderer, { flex: 1, filtered: filtered, selected: selected, properties: properties, hasUpdateActions: hasUpdateActions, changeSelected: setSelected, data: data, autouiContext: autouiContext, onEntityClick: !!onEntityClick || !!getBaseUrl
                        ? lensRendererOnEntityClick
                        : undefined, model: model })),
                ((_b = actionData === null || actionData === void 0 ? void 0 : actionData.action) === null || _b === void 0 ? void 0 : _b.renderer) &&
                    actionData.action.renderer({
                        schema: actionData.schema,
                        affectedEntries: actionData.affectedEntries,
                        onDone: function () { return setActionData(undefined); },
                    })))));
};
exports.getColumnsFromSchema = function (_a) {
    var _b;
    var schema = _a.schema, idField = _a.idField, tagField = _a.tagField, customSort = _a.customSort, priorities = _a.priorities, formats = _a.formats;
    return Object.entries((_b = schema.properties) !== null && _b !== void 0 ? _b : {})
        .filter(function (entry) {
        return entry[0] !== tagField && entry[0] !== idField;
    })
        .map(function (_a) {
        var _b;
        var key = _a[0], val = _a[1];
        if (typeof val !== 'object') {
            return;
        }
        var definedPriorities = priorities !== null && priorities !== void 0 ? priorities : {};
        var priority = definedPriorities.primary.find(function (prioritizedKey) { return prioritizedKey === key; })
            ? 'primary'
            : definedPriorities.secondary.find(function (prioritizedKey) { return prioritizedKey === key; })
                ? 'secondary'
                : 'tertiary';
        var widgetSchema = __assign(__assign({}, val), { title: undefined });
        return {
            title: val.title || key,
            field: key,
            key: key,
            selected: utils_3.getSelected(key, priorities),
            priority: priority,
            type: 'predefined',
            sortable: (_b = customSort === null || customSort === void 0 ? void 0 : customSort[key]) !== null && _b !== void 0 ? _b : utils_3.getSortingFunction(key, val),
            render: function (fieldVal, entry) {
                var calculatedField = helpers_1.autoUIAdaptRefScheme(fieldVal, val);
                return val.format ? (react_1.default.createElement(CustomWidget_1.CustomWidget, { extraFormats: __spreadArrays((formats !== null && formats !== void 0 ? formats : []), widgets_1.defaultFormats), schema: widgetSchema, value: calculatedField, extraContext: entry })) : (calculatedField);
            },
        };
    })
        .filter(function (columnDef) { return !!columnDef; });
};
var templateObject_1;
