import { AutoUIModel, AutoUIRawModel } from '../schemaOps';
import type { JSONSchema7 as JSONSchema, JSONSchema7Definition as JSONSchemaDefinition } from 'json-schema';
import { Dictionary } from '../../../common-types';
declare type Transformers<T extends Dictionary<any>, TTransformer extends Dictionary<any>, TContext extends any> = {
    [field in keyof TTransformer]: (entry: T, context?: TContext) => TTransformer[field];
};
export declare const autoUIDefaultPermissions: {
    read: never[];
    create: never[];
    update: never[];
    delete: boolean;
};
export declare const isJson: (str: string) => boolean;
export declare const autoUIRunTransformers: <T extends Dictionary<any>, TResult extends T, TContext extends unknown>(data: T | undefined, transformers: Transformers<T, Pick<TResult, Exclude<keyof TResult, keyof T>>, TContext>, context?: TContext | undefined) => TResult | undefined;
export declare const autoUIAdaptRefScheme: (field: unknown, property: JSONSchemaDefinition) => any;
export declare const autoUIGetModelForCollection: <T>(model: AutoUIRawModel<T>, context?: {
    accessRole?: string | null | undefined;
} | undefined) => AutoUIModel<T>;
export declare const autoUIAddToSchema: (schema: JSONSchema, schemaProperty: string, property: string, value: any) => {
    properties: {
        [x: string]: boolean | JSONSchema | {
            $id?: string | undefined;
            $ref?: string | undefined;
            $schema?: string | undefined;
            $comment?: string | undefined;
            $defs?: {
                [key: string]: JSONSchemaDefinition;
            } | undefined;
            type?: "string" | "number" | "boolean" | "object" | "integer" | "array" | "null" | import("json-schema").JSONSchema7TypeName[] | undefined;
            enum?: import("json-schema").JSONSchema7Type[] | undefined;
            const?: string | number | boolean | import("json-schema").JSONSchema7Object | import("json-schema").JSONSchema7Array | null | undefined;
            multipleOf?: number | undefined;
            maximum?: number | undefined;
            exclusiveMaximum?: number | undefined;
            minimum?: number | undefined;
            exclusiveMinimum?: number | undefined;
            maxLength?: number | undefined;
            minLength?: number | undefined;
            pattern?: string | undefined;
            items?: boolean | JSONSchema | JSONSchemaDefinition[] | undefined;
            additionalItems?: boolean | JSONSchema | undefined;
            maxItems?: number | undefined;
            minItems?: number | undefined;
            uniqueItems?: boolean | undefined;
            contains?: JSONSchema | undefined;
            maxProperties?: number | undefined;
            minProperties?: number | undefined;
            required?: string[] | undefined;
            properties?: {
                [key: string]: JSONSchemaDefinition;
            } | undefined;
            patternProperties?: {
                [key: string]: JSONSchemaDefinition;
            } | undefined;
            additionalProperties?: boolean | JSONSchema | undefined;
            dependencies?: {
                [key: string]: boolean | string[] | JSONSchema;
            } | undefined;
            propertyNames?: boolean | JSONSchema | undefined;
            if?: boolean | JSONSchema | undefined;
            then?: boolean | JSONSchema | undefined;
            else?: boolean | JSONSchema | undefined;
            allOf?: JSONSchemaDefinition[] | undefined;
            anyOf?: JSONSchemaDefinition[] | undefined;
            oneOf?: JSONSchemaDefinition[] | undefined;
            not?: boolean | JSONSchema | undefined;
            format?: string | undefined;
            contentMediaType?: string | undefined;
            contentEncoding?: string | undefined;
            definitions?: {
                [key: string]: JSONSchemaDefinition;
            } | undefined;
            title?: string | undefined;
            description?: string | undefined;
            default?: string | number | boolean | import("json-schema").JSONSchema7Object | import("json-schema").JSONSchema7Array | null | undefined;
            readOnly?: boolean | undefined;
            writeOnly?: boolean | undefined;
            examples?: string | number | boolean | import("json-schema").JSONSchema7Object | import("json-schema").JSONSchema7Array | null | undefined;
        };
    };
    $id?: string | undefined;
    $ref?: string | undefined;
    $schema?: string | undefined;
    $comment?: string | undefined;
    $defs?: {
        [key: string]: JSONSchemaDefinition;
    } | undefined;
    type?: "string" | "number" | "boolean" | "object" | "integer" | "array" | "null" | import("json-schema").JSONSchema7TypeName[] | undefined;
    enum?: import("json-schema").JSONSchema7Type[] | undefined;
    const?: string | number | boolean | import("json-schema").JSONSchema7Object | import("json-schema").JSONSchema7Array | null | undefined;
    multipleOf?: number | undefined;
    maximum?: number | undefined;
    exclusiveMaximum?: number | undefined;
    minimum?: number | undefined;
    exclusiveMinimum?: number | undefined;
    maxLength?: number | undefined;
    minLength?: number | undefined;
    pattern?: string | undefined;
    items?: boolean | JSONSchema | JSONSchemaDefinition[] | undefined;
    additionalItems?: boolean | JSONSchema | undefined;
    maxItems?: number | undefined;
    minItems?: number | undefined;
    uniqueItems?: boolean | undefined;
    contains?: JSONSchema | undefined;
    maxProperties?: number | undefined;
    minProperties?: number | undefined;
    required?: string[] | undefined;
    patternProperties?: {
        [key: string]: JSONSchemaDefinition;
    } | undefined;
    additionalProperties?: boolean | JSONSchema | undefined;
    dependencies?: {
        [key: string]: boolean | string[] | JSONSchema;
    } | undefined;
    propertyNames?: boolean | JSONSchema | undefined;
    if?: boolean | JSONSchema | undefined;
    then?: boolean | JSONSchema | undefined;
    else?: boolean | JSONSchema | undefined;
    allOf?: JSONSchemaDefinition[] | undefined;
    anyOf?: JSONSchemaDefinition[] | undefined;
    oneOf?: JSONSchemaDefinition[] | undefined;
    not?: boolean | JSONSchema | undefined;
    format?: string | undefined;
    contentMediaType?: string | undefined;
    contentEncoding?: string | undefined;
    definitions?: {
        [key: string]: JSONSchemaDefinition;
    } | undefined;
    title?: string | undefined;
    description?: string | undefined;
    default?: string | number | boolean | import("json-schema").JSONSchema7Object | import("json-schema").JSONSchema7Array | null | undefined;
    readOnly?: boolean | undefined;
    writeOnly?: boolean | undefined;
    examples?: string | number | boolean | import("json-schema").JSONSchema7Object | import("json-schema").JSONSchema7Array | null | undefined;
};
export declare const getPropertyRefScheme: (schemaValue: JSONSchema | JSONSchemaDefinition) => any;
export {};
