"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionSidebar = void 0;
var react_1 = __importDefault(require("react"));
var Flex_1 = require("../../components/Flex");
var Button_1 = require("../../components/Button");
var _1 = require(".");
var styled_components_1 = __importDefault(require("styled-components"));
var Form_1 = require("../../components/Form");
var odata_1 = require("./odata");
var faTimes_1 = require("@fortawesome/free-solid-svg-icons/faTimes");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Notifications_1 = require("../../components/Notifications");
var useTranslation_1 = require("../../hooks/useTranslation");
var replaceRefValues = function (object, openApiJson) {
    if (object === null || typeof object !== 'object') {
        return object;
    }
    if (Array.isArray(object)) {
        return object.map(function (value) {
            return replaceRefValues(value, openApiJson);
        });
    }
    var build = {};
    for (var key in object) {
        if (object.hasOwnProperty(key)) {
            var value = object[key];
            if (typeof value === 'object' && !!value['$ref']) {
                value = odata_1.getFromRef(openApiJson, value['$ref']);
            }
            if (typeof value === 'object' && !value['$ref']) {
                value = replaceRefValues(value, openApiJson);
            }
            build[key] = value;
        }
    }
    return build;
};
var ActionSidebarWrapper = styled_components_1.default(Flex_1.Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tborder-left: 1px solid black;\n\tposition: absolute;\n\tright: 0;\n\ttop: 0;\n\tbottom: 0;\n\tz-index: 9;\n\twidth: ", "px;\n\tbackground: white;\n\toverflow: scroll;\n"], ["\n\tborder-left: 1px solid black;\n\tposition: absolute;\n\tright: 0;\n\ttop: 0;\n\tbottom: 0;\n\tz-index: 9;\n\twidth: ", "px;\n\tbackground: white;\n\toverflow: scroll;\n"])), function () { return _1.ACTION_SIDEBAR_WIDTH; });
exports.ActionSidebar = function (_a) {
    var resourceName = _a.resourceName, openApiJson = _a.openApiJson, action = _a.action, schema = _a.schema, id = _a.id, onClose = _a.onClose;
    var t = useTranslation_1.useTranslation().t;
    var memoizedReferenceSchema = react_1.default.useMemo(function () {
        return replaceRefValues(schema, openApiJson);
    }, [schema, openApiJson]);
    var submit = function (_a) {
        var formData = _a.formData;
        return __awaiter(void 0, void 0, void 0, function () {
            var err_1;
            var _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!(action === _1.ActionMethods.POST)) return [3, 4];
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 3, , 4]);
                        return [4, odata_1.pine.post(__assign(__assign({ resource: resourceName }, (id && !isNaN(parseInt(id, 10)) && { id: id })), { body: formData }))];
                    case 2:
                        _c.sent();
                        Notifications_1.notifications.addNotification({
                            content: t('success.resource_added_successfully', {
                                name: resourceName,
                            }),
                            type: 'danger',
                        });
                        return [3, 4];
                    case 3:
                        err_1 = _c.sent();
                        Notifications_1.notifications.addNotification({
                            content: (_b = err_1.message) !== null && _b !== void 0 ? _b : err_1,
                            type: 'danger',
                        });
                        return [3, 4];
                    case 4: return [2];
                }
            });
        });
    };
    return (react_1.default.createElement(ActionSidebarWrapper, { p: 3, flexDirection: "column" },
        react_1.default.createElement(Flex_1.Flex, { justifyContent: "end" },
            react_1.default.createElement(Button_1.Button, { plain: true, onClick: onClose, icon: react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faTimes_1.faTimes }) })),
        react_1.default.createElement(Form_1.Form, { my: 2, schema: memoizedReferenceSchema, onFormSubmit: submit })));
};
var templateObject_1;
