"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Content = void 0;
var react_1 = __importDefault(require("react"));
var react_router_1 = require("react-router");
var odata_1 = require("./odata");
var useRequest_1 = require("../../hooks/useRequest");
var AutoUI_1 = require("../AutoUI");
var utils_1 = require("../AutoUI/utils");
var isEmpty_1 = __importDefault(require("lodash/isEmpty"));
var _1 = require(".");
var updateSchema = function (schema) {
    if (!schema.properties) {
        return schema;
    }
    var newSchema = __assign(__assign({}, schema), { properties: Object.entries(schema.properties).reduce(function (acc, _a) {
            var _b, _c;
            var key = _a[0], value = _a[1];
            return typeof value === 'object'
                ? __assign(__assign({}, acc), (_b = {}, _b[key] = __assign(__assign({}, value), { title: key.split('_').join(' ') }), _b)) : __assign(__assign({}, acc), (_c = {}, _c[key] = value, _c));
        }, {}) });
    return newSchema;
};
var generateModel = function (schema, resourceName, naturalPropertiesKeys) {
    var firstPropertyKey = naturalPropertiesKeys[0], otherPropertyKeys = naturalPropertiesKeys.slice(1);
    return {
        resource: resourceName,
        schema: updateSchema(schema),
        permissions: {
            read: __spreadArrays([firstPropertyKey], otherPropertyKeys),
            create: [firstPropertyKey],
            update: [],
            delete: false,
        },
        priorities: {
            primary: [firstPropertyKey],
            secondary: __spreadArrays(otherPropertyKeys),
            tertiary: [],
        },
    };
};
exports.Content = function (_a) {
    var openApiJson = _a.openApiJson, openActionSidebar = _a.openActionSidebar;
    var pathname = react_router_1.useLocation().pathname;
    var resourceName = pathname.replace(/^\/([^\/]*).*$/, '$1');
    var id = pathname.substring(pathname.lastIndexOf('/') + 1);
    var endsWithValidId = !isNaN(parseInt(id, 10));
    var schema = odata_1.getSchemaFromLocation(openApiJson, resourceName);
    var naturalPropertiesKeys = odata_1.getAllNaturalPropertiesKeys(schema === null || schema === void 0 ? void 0 : schema.properties);
    var correspondingPath = !endsWithValidId
        ? openApiJson.paths["/" + resourceName]
        : openApiJson.paths["/" + resourceName + "({id})"];
    var data = useRequest_1.useRequest(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, odata_1.pine.get(__assign(__assign({ resource: resourceName }, (endsWithValidId && { id: id })), { options: {
                            $select: __spreadArrays(odata_1.getSelectableOptions(correspondingPath, [])),
                        } }))];
                case 1: return [2, _a.sent()];
            }
        });
    }); }, [openApiJson, pathname], { polling: false })[0];
    var model = react_1.default.useMemo(function () {
        if (!schema) {
            return null;
        }
        return generateModel(schema, resourceName, naturalPropertiesKeys);
    }, [schema, resourceName, naturalPropertiesKeys]);
    var memoizedData = react_1.default.useMemo(function () {
        return AutoUI_1.autoUIRunTransformers(data, {
            contract: function () { return null; },
            __permissions: function () { return model === null || model === void 0 ? void 0 : model.permissions; },
        }, {});
    }, [data, model]);
    var memoizedActions = react_1.default.useMemo(function () {
        if (!correspondingPath) {
            return undefined;
        }
        return Object.entries(correspondingPath)
            .filter(function (_a) {
            var pathkey = _a[0];
            return [
                _1.ActionMethods.POST,
                _1.ActionMethods.PATCH,
                _1.ActionMethods.DELETE,
            ].includes(pathkey);
        })
            .map(function (_a) {
            var pathKey = _a[0], pathDescription = _a[1];
            var requestSchemaRef = utils_1.findInObject(pathDescription.requestBody, '$ref');
            var requestSchema = requestSchemaRef
                ? odata_1.getFromRef(openApiJson, requestSchemaRef)
                : id;
            if (pathKey === _1.ActionMethods.POST) {
                return {
                    title: "Add " + resourceName,
                    type: 'create',
                    actionFn: function () {
                        return openActionSidebar({
                            action: _1.ActionMethods.POST,
                            schema: requestSchema,
                            resourceName: resourceName,
                            id: id,
                        });
                    },
                };
            }
            if (pathKey === _1.ActionMethods.PATCH) {
                return {
                    title: "Update " + resourceName,
                    type: 'update',
                };
            }
            return {
                title: "Delete " + resourceName,
                type: 'delete',
            };
        });
    }, [correspondingPath]);
    if (!model) {
        return react_1.default.createElement(react_1.default.Fragment, null, "Could not generate a model");
    }
    if (!memoizedData || isEmpty_1.default(memoizedData)) {
        return react_1.default.createElement(react_1.default.Fragment, null, "No data");
    }
    return (react_1.default.createElement(AutoUI_1.AutoUI, __assign({ model: model, actions: memoizedActions, data: memoizedData }, (!endsWithValidId && {
        onEntityClick: function (entity) { return utils_1.history.push(pathname + "/" + entity.id); },
    }))));
};
