"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sidebar = void 0;
var react_1 = __importDefault(require("react"));
var react_router_dom_1 = require("react-router-dom");
var styled_components_1 = __importDefault(require("styled-components"));
var react_router_dom_2 = require("react-router-dom");
var Flex_1 = require("../../components/Flex");
var Txt_1 = require("../../components/Txt");
var SidebarWrapper = styled_components_1.default(Flex_1.Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\toverflow: auto;\n\tbackground: ", ";\n\tflex-direction: column;\n\tflex-wrap: nowrap;\n"], ["\n\toverflow: auto;\n\tbackground: ", ";\n\tflex-direction: column;\n\tflex-wrap: nowrap;\n"])), function (props) { return props.theme.colors.secondary.main; });
var MenuItem = styled_components_1.default(Flex_1.Flex)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\theight: 48px;\n\tcursor: pointer;\n\tborder-bottom: 1px solid\n\t\t", ";\n\tborder-left: ", ";\n\tbackground: ", ";\n\n\t&:hover {\n\t\tbackground: ", ";\n\t}\n"], ["\n\theight: 48px;\n\tcursor: pointer;\n\tborder-bottom: 1px solid\n\t\t",
    ";\n\tborder-left: ",
    ";\n\tbackground: ",
    ";\n\n\t&:hover {\n\t\tbackground: ",
    ";\n\t}\n"])), function (props) {
    return props.isCurrent
        ? props.theme.colors.quartenary.light
        : props.theme.colors.tertiary.dark;
}, function (props) {
    return props.isCurrent ? "2px solid " + props.theme.colors.primary.main : 'none';
}, function (props) {
    return props.isCurrent
        ? props.theme.colors.quartenary.light
        : props.theme.colors.secondary.dark;
}, function (props) {
    return props.isCurrent
        ? props.theme.colors.quartenary.light
        : props.theme.colors.tertiary.dark;
});
exports.Sidebar = function (_a) {
    var openApiJson = _a.openApiJson, _b = _a.isCollapsed, isCollapsed = _b === void 0 ? false : _b, flexProps = __rest(_a, ["openApiJson", "isCollapsed"]);
    var pathname = react_router_dom_2.useLocation().pathname;
    var menuItems = react_1.default.useMemo(function () {
        return Object.entries(openApiJson.components.schemas)
            .filter(function (_a) {
            var key = _a[0], value = _a[1];
            return !key.endsWith('-create') &&
                !key.endsWith('-update') &&
                !!value.title;
        })
            .map(function (_a) {
            var _b, _c;
            var key = _a[0], value = _a[1];
            return ({
                resource: key.substring(key.indexOf('.') + 1),
                title: (_c = (_b = value.title) === null || _b === void 0 ? void 0 : _b.split('_')) === null || _c === void 0 ? void 0 : _c.join(' '),
            });
        });
    }, [openApiJson]);
    return (react_1.default.createElement(SidebarWrapper, __assign({}, flexProps), menuItems.map(function (item) {
        var isCurrent = pathname.split('/').some(function (i) { return i === item.resource; });
        return (react_1.default.createElement(react_router_dom_1.NavLink, { key: item.resource, to: "/" + item.resource },
            react_1.default.createElement(MenuItem, { width: "100%", isCurrent: isCurrent, px: 3, py: 2, flexDirection: "row", alignItems: "center" },
                react_1.default.createElement(Txt_1.Txt.span, { bold: true, fontSize: 2, style: { lineHeight: 1.33 }, color: isCurrent ? 'text.main' : 'quartenary.main', display: isCollapsed ? 'none' : undefined, truncate: true, tooltip: item.title }, item.title))));
    })));
};
var templateObject_1, templateObject_2;
