"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutoUIApp = exports.ActionMethods = exports.ACTION_SIDEBAR_WIDTH = void 0;
var react_1 = __importDefault(require("react"));
var Navbar_1 = require("./Navbar");
var Sidebar_1 = require("./Sidebar");
var react_router_dom_1 = require("react-router-dom");
var Content_1 = require("./Content");
var styled_components_1 = require("styled-components");
var __1 = require("../..");
var utils_1 = require("../AutoUI/utils");
var Flex_1 = require("../../components/Flex");
var Box_1 = require("../../components/Box");
var ActionSidebar_1 = require("./ActionSidebar");
var SIDEBAR_WIDTH = 166;
var NAVBAR_HEIGHT = 60;
exports.ACTION_SIDEBAR_WIDTH = 340;
var GlobalStyle = styled_components_1.createGlobalStyle(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\thtml,\n\tbody {\n\t\theight: 100%;\n\t\tmargin: 0;\n\t\tpadding: 0;\n\t}\n"], ["\n\thtml,\n\tbody {\n\t\theight: 100%;\n\t\tmargin: 0;\n\t\tpadding: 0;\n\t}\n"])));
var ActionMethods;
(function (ActionMethods) {
    ActionMethods["POST"] = "post";
    ActionMethods["PATCH"] = "patch";
    ActionMethods["DELETE"] = "delete";
})(ActionMethods = exports.ActionMethods || (exports.ActionMethods = {}));
exports.AutoUIApp = function (_a) {
    var openApiJson = _a.openApiJson, title = _a.title, logo = _a.logo;
    var actionSidebarWrapper = react_1.default.useRef(null);
    var _b = react_1.default.useState(), actionSidebar = _b[0], setActionSidebar = _b[1];
    react_1.default.useEffect(function () {
        if (!actionSidebarWrapper.current) {
            return;
        }
        utils_1.onClickOutOrEsc(actionSidebarWrapper.current, function () {
            setActionSidebar(null);
        });
    }, [actionSidebarWrapper.current]);
    return (react_1.default.createElement(__1.Provider, null,
        react_1.default.createElement(react_router_dom_1.Router, { history: utils_1.history },
            react_1.default.createElement(GlobalStyle, null),
            react_1.default.createElement(Navbar_1.Navbar, { height: NAVBAR_HEIGHT, title: title, logo: logo }),
            react_1.default.createElement(Flex_1.Flex, { style: { position: 'relative' } },
                react_1.default.createElement(Sidebar_1.Sidebar, { width: SIDEBAR_WIDTH + "px", height: "calc(100vh - " + NAVBAR_HEIGHT + "px)", openApiJson: openApiJson, isCollapsed: false }),
                react_1.default.createElement(Box_1.Box, { width: "calc(100vw - " + (actionSidebar
                        ? SIDEBAR_WIDTH + exports.ACTION_SIDEBAR_WIDTH
                        : SIDEBAR_WIDTH) + "px)", height: "calc(100vh - " + NAVBAR_HEIGHT + "px)", px: 2, py: 1, style: { overflow: 'auto' } },
                    react_1.default.createElement(react_router_dom_1.Switch, null, Object.keys(openApiJson.paths).map(function (path) { return (react_1.default.createElement(react_router_dom_1.Route, { key: path, path: path, render: function () { return (react_1.default.createElement(Content_1.Content, { openApiJson: openApiJson, openActionSidebar: setActionSidebar })); } })); }))),
                actionSidebar && (react_1.default.createElement(Flex_1.Flex, { ref: actionSidebarWrapper },
                    react_1.default.createElement(ActionSidebar_1.ActionSidebar, __assign({}, actionSidebar, { openApiJson: openApiJson, onClose: function () { return setActionSidebar(null); } }))))))));
};
var templateObject_1;
