"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFromRef = exports.getSelectableOptions = exports.getAllNaturalPropertiesKeys = exports.getSchemaFromLocation = exports.pine = void 0;
var pinejs_client_fetch_1 = __importDefault(require("pinejs-client-fetch"));
var get_1 = __importDefault(require("lodash/get"));
exports.pine = new pinejs_client_fetch_1.default({
    apiPrefix: process.env.REACT_APP_API_HOST || process.env.STORYBOOK_APP_API_HOST,
}, { fetch: fetch });
exports.getSchemaFromLocation = function (openApiJson, resourceName) {
    var schemaName = Object.keys(openApiJson.components.schemas).find(function (key) {
        return key.includes(resourceName);
    });
    if (!schemaName) {
        return null;
    }
    return openApiJson.components.schemas[schemaName];
};
exports.getAllNaturalPropertiesKeys = function (properties) {
    return Object.entries(properties !== null && properties !== void 0 ? properties : [])
        .filter(function (_a) {
        var _key = _a[0], value = _a[1];
        return !!value.type;
    })
        .map(function (_a) {
        var key = _a[0];
        return key;
    });
};
exports.getSelectableOptions = function (pathObject, _parameters) {
    var _a, _b, _c, _d, _e, _f;
    return ((_f = (_e = (_d = (_c = (_b = (_a = pathObject === null || pathObject === void 0 ? void 0 : pathObject.get) === null || _a === void 0 ? void 0 : _a.parameters) === null || _b === void 0 ? void 0 : _b.find(function (p) { return p.name === '$select'; })) === null || _c === void 0 ? void 0 : _c.schema) === null || _d === void 0 ? void 0 : _d.items) === null || _e === void 0 ? void 0 : _e.enum) !== null && _f !== void 0 ? _f : []);
};
exports.getFromRef = function (openApiJson, ref) {
    var tree = ref.replace('#/', '').split('/');
    return get_1.default(openApiJson, tree);
};
