"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withConfirm = exports.useForwardedRef = void 0;
var React = __importStar(require("react"));
var Box_1 = require("../components/Box");
var Button_1 = require("../components/Button");
var Popover_1 = require("../components/Popover");
var Confirm = function (_a) {
    var text = _a.text, onOK = _a.onOK, onCancel = _a.onCancel, rest = __rest(_a, ["text", "onOK", "onCancel"]);
    return (React.createElement(Popover_1.Popover, __assign({}, rest, { onDismiss: onCancel }),
        React.createElement(Box_1.Box, { mx: 2, mt: 2, fontSize: 3 }, text),
        React.createElement(Box_1.Box, null,
            React.createElement(Button_1.Button, { m: 2, size: "small", onClick: onCancel }, "Cancel"),
            React.createElement(Button_1.Button, { m: 2, size: "small", primary: true, onClick: onOK }, "OK"))));
};
exports.useForwardedRef = function (ref) {
    var innerRef = React.useRef(null);
    React.useEffect(function () {
        if (!ref) {
            return;
        }
        if (typeof ref === 'function') {
            ref(innerRef.current);
        }
        else {
            ref.current = innerRef.current;
        }
    });
    return innerRef;
};
function withConfirm(Base) {
    return React.forwardRef(function (_a, ref) {
        var onClick = _a.onClick, confirmation = _a.confirmation, rest = __rest(_a, ["onClick", "confirmation"]);
        var targetRef = exports.useForwardedRef(ref);
        var _b = React.useState(null), clickEvent = _b[0], setClickEvent = _b[1];
        var handleOk = React.useCallback(function () {
            if (onClick) {
                onClick(clickEvent);
            }
            setClickEvent(null);
        }, [onClick, clickEvent]);
        var handleCancel = React.useCallback(function () {
            setClickEvent(null);
        }, []);
        var handleBaseClick = React.useCallback(function (e) {
            setClickEvent(e);
        }, []);
        var confirmOptions = React.useMemo(function () {
            return typeof confirmation === 'string'
                ? {
                    text: confirmation,
                }
                : confirmation;
        }, [confirmation]);
        return (React.createElement(React.Fragment, null,
            clickEvent && (React.createElement(Confirm, __assign({}, confirmOptions, { target: targetRef.current, onOK: handleOk, onCancel: handleCancel }))),
            React.createElement(Base, __assign({}, rest, { ref: targetRef, onClick: handleBaseClick }))));
    });
}
exports.withConfirm = withConfirm;
