"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DownloadFormModel = exports.DownloadImageLabel = void 0;
var toNumber_1 = __importDefault(require("lodash/toNumber"));
var React = __importStar(require("react"));
var Box_1 = require("../../components/Box");
var Checkbox_1 = require("../../components/Checkbox");
var Divider_1 = require("../../components/Divider");
var Input_1 = require("../../components/Input");
var Select_1 = require("../../components/Select");
var RadioButtonGroup_1 = require("../../components/RadioButtonGroup");
var Txt_1 = require("../../components/Txt");
var Collapsible_1 = require("./Collapsible");
var PasswordInput_1 = require("./PasswordInput");
var styled_components_1 = __importDefault(require("styled-components"));
var OsConfiguration_1 = require("./OsConfiguration");
var useTranslation_1 = require("../../hooks/useTranslation");
var moment_1 = __importDefault(require("moment"));
exports.DownloadImageLabel = styled_components_1.default.label(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tdisplay: flex;\n\tflex-direction: row;\n\talign-items: center;\n\theight: 21px;\n\tfont-size: 12px;\n\tmargin-bottom: 8px;\n\tfont-weight: normal;\n"], ["\n\tdisplay: flex;\n\tflex-direction: row;\n\talign-items: center;\n\theight: 21px;\n\tfont-size: 12px;\n\tmargin-bottom: 8px;\n\tfont-weight: normal;\n"])));
var matches = function (condition, data) {
    if (!condition) {
        return true;
    }
    for (var k in condition) {
        if (!condition[k]) {
            continue;
        }
        if (condition[k] !== data[k]) {
            return false;
        }
    }
    return true;
};
var getDefaultValue = function (options) {
    if (options.default) {
        return options.default;
    }
    else if (options.choices) {
        return options.choices[0];
    }
    else if (options.type === 'number' && options.min) {
        return options.min;
    }
    return undefined;
};
var FormControl = function (_a) {
    var _b, _c, _d, _e;
    var onModelChange = _a.onModelChange, options = _a.options, model = _a.model;
    var t = useTranslation_1.useTranslation().t;
    React.useEffect(function () {
        var _a;
        if (model[options.name]) {
            return;
        }
        var defaultVal = getDefaultValue(options);
        if (defaultVal != null) {
            onModelChange((_a = {}, _a[options.name] = getDefaultValue(options), _a));
        }
    }, [options, model, onModelChange]);
    var error = React.useMemo(function () {
        var value = model[options.name];
        if (value !== undefined && typeof value === 'number') {
            if (options.min) {
                if (value < options.min) {
                    return t('fields_errors.does_not_satisfy_minimum', {
                        minimum: options.min,
                    });
                }
            }
            if (options.max) {
                if (value > options.max) {
                    return t('fields_errors.does_not_satisfy_maximum', {
                        maximum: options.max,
                    });
                }
            }
        }
    }, [options, model]);
    return (React.createElement("div", { style: options.hidden ? { display: 'none' } : {} },
        options.hidden && (React.createElement("input", { name: options.name, value: model[options.name], onChange: function (e) {
                var _a;
                return onModelChange((_a = {}, _a[options.name] = e.target.value, _a));
            } })),
        !options.hidden && (React.createElement(React.Fragment, null,
            options.type !== 'confirm' && (React.createElement(exports.DownloadImageLabel, null,
                options.message,
                !!options.docs && React.createElement(OsConfiguration_1.DocsLink, { href: options.docs }))),
            options.type === 'list' && ((_b = options.choices) === null || _b === void 0 ? void 0 : _b.length) === 1 && (React.createElement("div", null,
                React.createElement("input", { type: "hidden", name: options.name, value: model[options.name], onChange: function (e) {
                        var _a;
                        return onModelChange((_a = {}, _a[options.name] = e.target.value, _a));
                    } }),
                React.createElement("em", null,
                    "(",
                    options.choices[0],
                    ")"))),
            options.type === 'list' && ((_c = options.choices) === null || _c === void 0 ? void 0 : _c.length) === 2 && (React.createElement(React.Fragment, null,
                React.createElement("input", { type: "hidden", name: options.name, value: model[options.name] }),
                React.createElement(Box_1.Box, { mr: 4 },
                    React.createElement(RadioButtonGroup_1.RadioButtonGroup, { options: options.choices.map(function (choice) {
                            var _a, _b;
                            return ({
                                disabled: false,
                                value: choice,
                                label: (_b = (_a = options.choicesLabels) === null || _a === void 0 ? void 0 : _a[choice]) !== null && _b !== void 0 ? _b : choice,
                            });
                        }), value: model[options.name], onChange: function (e) {
                            var _a;
                            return onModelChange((_a = {}, _a[options.name] = e.target.value, _a));
                        } })))),
            options.type === 'list' && ((_e = (_d = options.choices) === null || _d === void 0 ? void 0 : _d.length) !== null && _e !== void 0 ? _e : 0) > 2 && (React.createElement(Select_1.Select, { name: options.name, options: options.choices, width: "100%", value: model[options.name], onChange: function (_a) {
                    var _b;
                    var option = _a.option;
                    return onModelChange((_b = {}, _b[options.name] = option, _b));
                } })),
            options.type === 'confirm' && (React.createElement(Checkbox_1.Checkbox, { mb: 2, name: options.name, label: options.message, checked: model[options.name], onChange: function (e) {
                    var _a;
                    return onModelChange((_a = {}, _a[options.name] = e.target.checked, _a));
                } })),
            options.type === 'number' && (React.createElement(Input_1.Input, { mb: 2, name: options.name, type: "number", onChange: function (e) {
                    var _a;
                    var parsed = toNumber_1.default(e.target.value);
                    if (!isNaN(parsed)) {
                        onModelChange((_a = {}, _a[options.name] = parsed, _a));
                    }
                }, value: model[options.name], min: options.min, max: options.max })),
            options.type === 'password' && (React.createElement(Box_1.Box, { mb: 2 },
                React.createElement(PasswordInput_1.PasswordInput, { name: options.name, onChange: function (e) {
                        var _a;
                        return onModelChange((_a = {}, _a[options.name] = e.target.value, _a));
                    }, value: model[options.name], autoComplete: "new-password" }))),
            options.type === 'datetime-local' && (React.createElement(React.Fragment, null,
                React.createElement("input", { type: "hidden", name: options.name, value: !!model[options.name]
                        ? moment_1.default(model[options.name])
                            .utc()
                            .format()
                        : undefined }),
                React.createElement(Input_1.Input, { mb: 2, type: "datetime-local", value: !!model[options.name]
                        ? model[options.name]
                        : undefined, onChange: function (e) {
                        var _a;
                        console.log(e.currentTarget.value);
                        onModelChange((_a = {},
                            _a[options.name] = e.currentTarget.value,
                            _a));
                    }, onKeyPress: function (e) {
                        var _a;
                        if (e.key === 'Enter' && !!model[options.name]) {
                            onModelChange((_a = {}, _a[options.name] = undefined, _a));
                        }
                    } }))),
            (!options.type || options.type === 'text') && (React.createElement(Input_1.Input, { mb: 2, type: "text", name: options.name, onChange: function (e) {
                    var _a;
                    return onModelChange((_a = {}, _a[options.name] = e.target.value, _a));
                }, value: model[options.name], autoComplete: "new-password" })),
            error && (React.createElement(Txt_1.Txt, { color: "red", fontSize: 10 }, error))))));
};
var FormField = function (_a) {
    var onModelChange = _a.onModelChange, model = _a.model, options = _a.options;
    var shouldShow = matches(options.when, model);
    if (!shouldShow) {
        return null;
    }
    return (React.createElement(FormControl, { options: options, model: model, onModelChange: onModelChange }));
};
var FormGroup = function (_a) {
    var onModelChange = _a.onModelChange, model = _a.model, options = _a.options;
    return (React.createElement(React.Fragment, null,
        React.createElement(Divider_1.Divider, { type: "dashed" }),
        React.createElement(Collapsible_1.Collapsible, { collapsible: !!options.isCollapsible, initiallyCollapsed: options.collapsed, title: options.message },
            React.createElement(FormFields, { onModelChange: onModelChange, options: options.options, model: model }))));
};
var FormFields = function (_a) {
    var onModelChange = _a.onModelChange, model = _a.model, options = _a.options;
    return (React.createElement(React.Fragment, null, options.map(function (option) {
        return (React.createElement(React.Fragment, { key: option.name },
            option.isGroup && (React.createElement(FormGroup, { onModelChange: onModelChange, model: model, options: option })),
            !option.isGroup && (React.createElement(FormField, { onModelChange: onModelChange, model: model, options: option }))));
    })));
};
exports.DownloadFormModel = function (_a) {
    var model = _a.model, onModelChange = _a.onModelChange, options = _a.options;
    if (!options) {
        return null;
    }
    return (React.createElement(FormFields, { onModelChange: function (updatedField) {
            return onModelChange(__assign(__assign({}, model), updatedField));
        }, model: model, options: options }));
};
var templateObject_1;
