import * as React from 'react';
import { ButtonProps } from '../../components/Button';
import { DeviceType } from './models';
import { DownloadOptions } from './DownloadImageModal';
export declare type ModalAction = Omit<ButtonProps, 'onClick' | 'label'> & {
    label: string;
    onClick?: (event: React.MouseEvent, model: DownloadOptions) => void;
};
interface ImageFormProps {
    downloadUrl: string;
    appId: number;
    releaseId?: number;
    rawVersion: string | null;
    developmentMode: boolean;
    deviceType: DeviceType;
    authToken?: string;
    onDownloadStart?: (downloadConfigOnly: boolean, downloadOptions: DownloadOptions) => void;
    setIsDownloadingConfig: (isDownloading: boolean) => void;
    downloadConfig?: (model: DownloadOptions) => Promise<void> | undefined;
    getDownloadSize?: (slug: string, version: string | null) => Promise<string | undefined>;
    modalActions?: ModalAction[];
    configurationComponent: React.ReactNode;
}
export declare const ImageForm: ({ downloadUrl, appId, releaseId, rawVersion, developmentMode, deviceType, authToken, onDownloadStart, setIsDownloadingConfig, downloadConfig, getDownloadSize, modalActions, configurationComponent, }: ImageFormProps) => JSX.Element;
export {};
