"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OsTypeSelector = void 0;
var React = __importStar(require("react"));
var Badge_1 = require("../../components/Badge");
var Flex_1 = require("../../components/Flex");
var Select_1 = require("../../components/Select");
var Txt_1 = require("../../components/Txt");
var useTranslation_1 = require("../../hooks/useTranslation");
var models_1 = require("./models");
var utils_1 = require("./utils");
var OsTypeOption = function (_a) {
    var osType = _a.osType, bold = _a.bold;
    var t = useTranslation_1.useTranslation().t;
    if (!osType) {
        return React.createElement(Txt_1.Txt.span, null, t('placeholders.select_os_type'));
    }
    return (React.createElement(Flex_1.Flex, { width: "100%", justifyContent: "space-between", alignItems: "center" },
        React.createElement(Txt_1.Txt.span, { bold: bold }, utils_1.getOsTypeName(osType.slug)),
        React.createElement(Flex_1.Flex, null,
            !osType.supportedForDeviceType && (React.createElement(Badge_1.Badge, { mx: 2, shade: 11 }, t('no_data.no_versions_yet'))),
            !osType.supportedForApp && (React.createElement(Badge_1.Badge, { shade: 6, mx: 2 }, t('info.production_and_enterprise_plan_only'))))));
};
exports.OsTypeSelector = function (_a) {
    var supportedOsTypes = _a.supportedOsTypes, hasEsrVersions = _a.hasEsrVersions, selectedOsTypeSlug = _a.selectedOsTypeSlug, onSelectedOsTypeChange = _a.onSelectedOsTypeChange, otherProps = __rest(_a, ["supportedOsTypes", "hasEsrVersions", "selectedOsTypeSlug", "onSelectedOsTypeChange"]);
    var t = useTranslation_1.useTranslation().t;
    var selectOsTypes = Object.values({
        default: models_1.OsTypesEnum.DEFAULT,
        ESR: models_1.OsTypesEnum.ESR,
    }).map(function (osType) {
        var supportedForDeviceType = osType === models_1.OsTypesEnum.ESR ? hasEsrVersions : true;
        var supportedForApp = supportedOsTypes.includes(osType);
        var disabled = !supportedForApp || !supportedForDeviceType;
        return {
            slug: osType,
            disabled: disabled,
            supportedForDeviceType: supportedForDeviceType,
            supportedForApp: supportedForApp,
        };
    });
    var selectedOsType = selectOsTypes.find(function (osType) {
        return osType.slug === selectedOsTypeSlug && osType.supportedForDeviceType;
    });
    return (React.createElement(Select_1.Select, __assign({ id: "newAppApplicationType", options: selectOsTypes, valueKey: "slug", disabledKey: "disabled", disabled: supportedOsTypes.length === 0, value: selectedOsType, valueLabel: React.createElement(Flex_1.Flex, { width: "100%", py: 2, pl: 3 },
            React.createElement(OsTypeOption, { osType: selectedOsType })), onChange: function (_a) {
            var option = _a.option;
            return !option.disabled && onSelectedOsTypeChange(option.slug);
        } }, otherProps), function (option) { return (React.createElement(Flex_1.Flex, { tooltip: !option.supportedForDeviceType
            ? t('info.no_esr_versions_are_available_for_device_type')
            : undefined, flexDirection: "column", py: 2, pl: 3 },
        React.createElement(OsTypeOption, { osType: option, bold: selectedOsTypeSlug === option.slug }))); }));
};
