"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPoll = exports.Poll = void 0;
var DEFAULT_INTERVAL = 15000;
var DEFAULT_GRACE_RATIO = 0.33;
var Poll = (function () {
    function Poll(fn, interval, graceRatio, isTabActive) {
        this._cancelled = true;
        this._counter = 0;
        this.pollInterval = null;
        this.lastCompleteTime = 0;
        this.blocked = false;
        this.interval = interval;
        this.fn = fn;
        this.poll = this.poll.bind(this);
        this.graceInterval = this.interval * graceRatio;
        this.isTabActive = isTabActive;
    }
    Object.defineProperty(Poll.prototype, "cancelled", {
        get: function () {
            return this._cancelled;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Poll.prototype, "counter", {
        get: function () {
            return this._counter;
        },
        enumerable: false,
        configurable: true
    });
    Poll.prototype.poll = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var forced;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.cancelled || this.blocked) {
                            return [2];
                        }
                        forced = opts && opts.forced;
                        if (!forced && !this.isTabActive && this.lastCompleteTime !== 0) {
                            return [2];
                        }
                        if (!forced && Date.now() - this.lastCompleteTime < this.graceInterval) {
                            return [2];
                        }
                        this.blocked = true;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, , 3, 4]);
                        return [4, this.fn(this)];
                    case 2:
                        _a.sent();
                        this.lastCompleteTime = Date.now();
                        return [3, 4];
                    case 3:
                        this._counter++;
                        this.blocked = false;
                        return [7];
                    case 4: return [2];
                }
            });
        });
    };
    Poll.prototype.start = function () {
        if (this.pollInterval != null) {
            return;
        }
        this.lastCompleteTime = 0;
        this._cancelled = false;
        this.pollInterval = setInterval(this.poll, this.interval);
        return this.poll();
    };
    Poll.prototype.stop = function () {
        if (this.pollInterval) {
            clearInterval(this.pollInterval);
        }
        this._cancelled = true;
        this.pollInterval = null;
    };
    Poll.prototype.destroy = function () {
        var _this = this;
        this.stop();
        this.fn = function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2, undefined];
        }); }); };
    };
    return Poll;
}());
exports.Poll = Poll;
exports.createPoll = function (fn, interval, isTabActive, graceRatio) {
    if (interval === void 0) { interval = DEFAULT_INTERVAL; }
    if (isTabActive === void 0) { isTabActive = true; }
    if (graceRatio === void 0) { graceRatio = DEFAULT_GRACE_RATIO; }
    return new Poll(fn, interval, graceRatio, isTabActive);
};
