import React from 'react';
import { mount } from 'enzyme';
import { Avatar, Provider } from '../../';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
describe('Avatar component', function () {
    describe('firstName and lastName properties', function () {
        it('should render the Avatar with initials if src is not passed', function () {
            var component = mount(React.createElement(Provider, null,
                React.createElement(Avatar, { firstName: "test", lastName: "user" })));
            expect(component.text()).toContain('TU');
        });
    });
    describe('null src, valid firstName and valid lastName properties', function () {
        it('should render the Avatar with initials if src is passed but it is null', function () {
            var component = mount(React.createElement(Provider, null,
                React.createElement(Avatar, { firstName: "example", lastName: "user" })));
            expect(component.text()).toContain('EU');
        });
    });
    describe('component with all props to null', function () {
        it('should render fallback icon if no props has value', function () {
            var component = mount(React.createElement(Provider, null,
                React.createElement(Avatar, null)));
            expect(component.children().find(FontAwesomeIcon)).toHaveLength(1);
        });
    });
});
