import React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { Breadcrumbs } from '.';
import { faRecycle } from '@fortawesome/free-solid-svg-icons/faRecycle';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { Flex } from '../..';
export default {
    title: 'Core/Breadcrumbs',
    component: Breadcrumbs,
    parameters: {
        backgrounds: {
            default: 'dark',
        },
    },
};
var crumbs = [
    {
        text: 'route 1',
        href: '/?path=/story/core-breadcrumbs--default',
        onClick: function (event) {
            event.preventDefault();
            alert('click route 1');
        },
    },
    {
        text: 'route 2',
        href: '/?path=/story/core-breadcrumbs--default',
        onClick: function (event) {
            event.preventDefault();
            alert('click route 2');
        },
    },
    {
        text: 'route 3 with icon',
        href: '/?path=/story/core-breadcrumbs--default',
        icon: React.createElement(FontAwesomeIcon, { icon: faRecycle }),
        onClick: function (event) {
            event.preventDefault();
            alert('click route 3');
        },
    },
];
var Template = createTemplate(Breadcrumbs);
var WrappedBreadcrumb = function (_a) {
    var crumbs = _a.crumbs;
    return (React.createElement(Flex, { maxWidth: "70px" },
        React.createElement(Breadcrumbs, { crumbs: crumbs })));
};
export var Default = createStory(Template, {
    crumbs: crumbs,
});
export var Wrapped = createStory(WrappedBreadcrumb, {
    crumbs: crumbs,
});
