import { __makeTemplateObject } from "tslib";
import * as React from 'react';
import styled from 'styled-components';
import { Link } from '../Link';
import { Flex } from '../Flex';
import { Txt } from '../Txt';
import { useTheme } from '../../hooks/useTheme';
var Circle = styled(Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tborder: 1px solid\n\t\t", ";\n\tborder-radius: 50%;\n\twidth: ", "px;\n\theight: ", "px;\n\tbackground: ", ";\n"], ["\n\tborder: 1px solid\n\t\t",
    ";\n\tborder-radius: 50%;\n\twidth: ", "px;\n\theight: ", "px;\n\tbackground: ",
    ";\n"])), function (props) {
    return props.isLast
        ? props.dark
            ? props.theme.colors.secondary.dark
            : props.theme.colors.quartenary.light
        : props.dark
            ? props.theme.colors.tertiary.light
            : props.theme.colors.text.light;
}, function (props) { return props.theme.space[props.emphasized ? 3 : 2]; }, function (props) { return props.theme.space[props.emphasized ? 3 : 2]; }, function (props) {
    return props.isLast
        ? props.dark
            ? props.theme.colors.secondary.dark
            : props.theme.colors.quartenary.light
        : props.dark
            ? props.theme.colors.tertiary.light
            : props.theme.colors.text.light;
});
var BreadcrumbContent = React.memo(function (_a) {
    var icon = _a.icon, text = _a.text, secondaryIcon = _a.secondaryIcon;
    var crumbRef = React.useRef(null);
    var _b = React.useState(false), shouldShowTooltip = _b[0], setShouldShowTooltip = _b[1];
    React.useEffect(function () {
        if (!(crumbRef === null || crumbRef === void 0 ? void 0 : crumbRef.current)) {
            return;
        }
        setShouldShowTooltip(crumbRef.current.scrollWidth > crumbRef.current.clientWidth);
    }, []);
    return (React.createElement(Flex, { ref: crumbRef, alignItems: "center", width: "100%" },
        icon && React.createElement(Flex, { mr: 2 }, icon),
        React.createElement(Txt, { tooltip: shouldShowTooltip ? text : undefined, whitespace: "nowrap", truncate: shouldShowTooltip }, text),
        secondaryIcon && React.createElement(Flex, { ml: 2 }, secondaryIcon)));
});
export var Breadcrumbs = function (_a) {
    var crumbs = _a.crumbs, _b = _a.isCollapsed, isCollapsed = _b === void 0 ? false : _b, emphasized = _a.emphasized, dark = _a.dark;
    var theme = useTheme();
    return (React.createElement(Flex, { flexDirection: "column", flexWrap: "wrap", width: "100%" }, crumbs.map(function (crumb, i) {
        var _a, _b;
        var isLast = i === crumbs.length - 1;
        return (crumb && (React.createElement(Txt, { bold: isLast, fontSize: 2, color: isLast
                ? "" + (dark ? 'secondary.dark' : 'white')
                : "" + (dark ? 'tertiary.light' : 'secondary.semilight'), key: crumb.text, width: "100%" },
            React.createElement(Flex, { flexDirection: "column", width: "100%" },
                React.createElement(Flex, { alignItems: "center", width: "100%" },
                    !crumb.component && (React.createElement(Circle, { dark: dark, isLast: isLast, emphasized: emphasized })),
                    React.createElement(Flex, { width: "calc(100% - " + theme.space[2] + "px)", pl: 2 }, crumb.onClick ? (React.createElement(Link, { style: { display: 'inherit', color: 'inherit' }, onClick: crumb.onClick, width: "100%", href: crumb.href }, !!crumb.component ? (crumb.component) : (React.createElement(BreadcrumbContent, { text: isCollapsed && !crumb.icon
                            ? (_a = crumb.text) === null || _a === void 0 ? void 0 : _a.charAt(0) : isCollapsed && !!crumb.icon
                            ? ''
                            : crumb.text, icon: crumb.icon, secondaryIcon: crumb.secondaryIcon })))) : (React.createElement(BreadcrumbContent, { text: isCollapsed && !crumb.icon
                            ? (_b = crumb.text) === null || _b === void 0 ? void 0 : _b.charAt(0) : isCollapsed && !!crumb.icon
                            ? ''
                            : crumb.text, icon: crumb.icon, secondaryIcon: crumb.secondaryIcon })))),
                !isLast && (React.createElement(Flex, { mt: -2, mb: -2, width: theme.space[emphasized ? 3 : 2], justifyContent: "center" },
                    React.createElement(Flex, { height: theme.space[4], width: "1px", bg: "text." + (dark ? 'dark' : 'light') })))))));
    })));
};
var templateObject_1;
