import React from 'react';
import { mount } from 'enzyme';
import { Provider } from '../../';
import { Breadcrumbs } from './';
import { Txt } from '../Txt';
describe('Breadcrumbs component', function () {
    describe('crumbs property', function () {
        it('should render the Breadcrumbs with four routes', function () {
            var crumbs = [
                { text: 'route 1', href: '/route1' },
                { text: 'route 2', href: '/route2' },
                { text: 'route 3', href: '/route3' },
                { text: 'route 4', href: '/route4' },
            ];
            var component = mount(React.createElement(Provider, null,
                React.createElement(Breadcrumbs, { crumbs: crumbs })));
            var crumbsContent = component.findWhere(function (node) { return node.is(Txt) && typeof node.prop('children') === 'string'; });
            expect(crumbsContent).toHaveLength(4);
            crumbsContent.forEach(function (crumb, index) {
                expect(crumb.text()).toEqual(crumbs[index].text);
            });
        });
    });
});
