import React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { Button } from '.';
import { faExpand } from '@fortawesome/free-solid-svg-icons/faExpand';
import { faRecycle } from '@fortawesome/free-solid-svg-icons/faRecycle';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
export default {
    title: 'Core/Button',
    component: Button,
};
var Template = createTemplate(Button);
export var Default = createStory(Template, {
    children: 'Default',
});
export var Primary = createStory(Template, {
    children: 'Primary',
    primary: true,
});
export var Disabled = createStory(Template, {
    children: 'Disabled',
    disabled: true,
});
export var Outlined = createStory(Template, {
    children: 'Outlined',
    outline: true,
});
export var Underlined = createStory(Template, {
    children: 'Underlined',
    underline: true,
});
export var Plain = createStory(Template, {
    children: 'Plain',
    plain: true,
});
export var WithIcon = createStory(Template, {
    children: 'With icon',
    icon: React.createElement(FontAwesomeIcon, { icon: faExpand }),
    plain: true,
});
export var IconOnly = createStory(Template, {
    icon: React.createElement(FontAwesomeIcon, { icon: faRecycle }),
    plain: true,
});
export var Active = createStory(Template, {
    children: 'Active',
    active: true,
});
export var Link = createStory(Template, {
    children: 'Link',
    href: '#',
});
export var WithConfirmation = createStory(Template, {
    children: 'Dangerous',
    danger: true,
    confirmation: {
        placement: 'bottom',
        text: 'Are you sure?',
    },
});
