import * as React from 'react';
import { Link, Flex, Button, Txt } from '../..';
import { createTemplate, createStory } from '../../stories/utils';
import { Card } from './';
var rows = [
    React.createElement("div", null, "Lorem Ipsum dolor si amet"),
    React.createElement(Link, { href: "www.balena.io" }, "Link"),
    React.createElement(Txt, { showCopyMode: "always", copy: "This value has been copied to your clipboard!" }, "Row with Copy component"),
    React.createElement(Flex, { justifyContent: "space-between" },
        React.createElement("div", null, "Row with"),
        React.createElement("div", null, "Flex")),
    React.createElement("div", null, "Lorem Ipsum dolor si amet"),
];
export default {
    title: 'Core/Card',
    component: Card,
    decorators: [
        function (Story) { return (React.createElement("div", { style: { width: 400, height: 400 } },
            React.createElement(Story, null))); },
    ],
};
var Template = createTemplate(Card);
export var Default = createStory(Template, {
    children: "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam\n  scelerisque euismod risus at gravida. Pellentesque a nunc semper,\n  ultrices lacus nec, mattis mauris",
});
export var Small = createStory(Template, {
    children: "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam\n  scelerisque euismod risus at gravida. Pellentesque a nunc semper,\n  ultrices lacus nec, mattis mauris",
    small: [true, false, true, true],
});
export var WithHeader = createStory(Template, {
    title: 'Card with Button',
    cta: (React.createElement(Button, { plain: true, primary: true, onClick: function () { return window.alert('Action with Button'); } }, "Update")),
    children: "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam\n  scelerisque euismod risus at gravida. Pellentesque a nunc semper,\n  ultrices lacus nec, mattis mauris",
});
export var WithRows = createStory(Template, {
    title: 'Card with Button',
    cta: React.createElement(Link, { href: "https://balena.io" }, "Link"),
    rows: rows,
});
