import type { JSONSchema7 as JSONSchema } from 'json-schema';
export declare const operators: {
    is: {
        getLabel: (_s: JSONSchema) => string;
    };
    is_more_than: {
        getLabel: (_s: JSONSchema) => string;
    };
    is_less_than: {
        getLabel: (_s: JSONSchema) => string;
    };
};
declare type OperatorSlug = keyof typeof operators;
interface NumberFilter extends JSONSchema {
    title: OperatorSlug;
    properties?: {
        [k: string]: {
            type: 'number';
            const?: number;
            exclusiveMinimum?: number;
            exclusiveMaximum?: number;
        };
    };
}
export declare const decodeFilter: (filter: NumberFilter) => {
    field: string;
    operator: OperatorSlug;
    value: number;
} | null;
export declare const createFilter: (field: string, operator: OperatorSlug, value: any, schema: JSONSchema) => NumberFilter;
export {};
