import { __assign, __makeTemplateObject } from "tslib";
import { faChartPie } from '@fortawesome/free-solid-svg-icons/faChartPie';
import { faTrash } from '@fortawesome/free-solid-svg-icons/faTrash';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import cloneDeep from 'lodash/cloneDeep';
import groupBy from 'lodash/groupBy';
import map from 'lodash/map';
import * as React from 'react';
import styled from 'styled-components';
import { stopEvent } from '../../utils';
import { Box } from '../Box';
import { Button } from '../Button';
import { DropDownButton } from '../DropDownButton';
import FilterDescription from './FilterDescription';
import { Flex } from '../Flex';
import theme from '../../theme';
var PlainPanel = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tborder-radius: 2px;\n\tbackground-color: #ffffff;\n\tbox-shadow: 0 0 6px 0 rgba(0, 0, 0, 0.1);\n\tborder: solid 1px #9b9b9b;\n"], ["\n\tborder-radius: 2px;\n\tbackground-color: #ffffff;\n\tbox-shadow: 0 0 6px 0 rgba(0, 0, 0, 0.1);\n\tborder: solid 1px #9b9b9b;\n"])));
var Preview = styled(PlainPanel)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tdisplay: none;\n\tposition: absolute;\n\tright: 230px;\n\twidth: 300px;\n\tright: 100%;\n\tmargin-right: 3px;\n\ttop: 2px;\n\tpadding: 15px 15px 5px;\n"], ["\n\tdisplay: none;\n\tposition: absolute;\n\tright: 230px;\n\twidth: 300px;\n\tright: 100%;\n\tmargin-right: 3px;\n\ttop: 2px;\n\tpadding: 15px 15px 5px;\n"])));
var ViewsMenu = function (props) {
    var loadView = function (view) {
        var filters = cloneDeep(view.filters);
        props.setFilters(filters);
    };
    var views = props.views, renderMode = props.renderMode, hasMultipleScopes = props.hasMultipleScopes, compact = props.compact, deleteView = props.deleteView;
    var hasViews = views.length > 0;
    var groupedViews = groupBy(views, function (item) { return item.scope || 'Unscoped'; });
    var memoizedItems = React.useMemo(function () {
        return !hasViews
            ? [[{ content: "You haven't created any views yet" }]]
            : map(groupedViews, function (views, scope) {
                return views.map(function (view, index) { return ({
                    content: (React.createElement(Flex, { flexDirection: "row", justifyContent: "space-between", alignItems: "center", key: scope + "-" + index },
                        React.createElement(Flex, { flexDirection: "column", mr: 3 },
                            React.createElement(Flex, { flexDirection: "row" },
                                hasMultipleScopes && (React.createElement(Flex, { flexDirection: "column", mr: 1 },
                                    React.createElement("strong", null, scope))),
                                React.createElement(Flex, { flexDirection: "column" }, view.name)),
                            React.createElement(Flex, { flexDirection: "row", color: theme.colors.gray },
                                view.filters.length,
                                " filter",
                                view.filters.length > 1 && 's')),
                        React.createElement(Flex, { flexDirection: "column" },
                            React.createElement(Button, { plain: true, onClick: function (e) {
                                    deleteView(view);
                                    stopEvent(e);
                                } },
                                React.createElement(FontAwesomeIcon, { icon: faTrash }))),
                        React.createElement(Preview, null, view.filters.map(function (filter) { return (React.createElement(Box, { mb: 10, key: filter.$id },
                            React.createElement(FilterDescription, { filter: filter }))); })))),
                    onClick: function () { return loadView(view); },
                }); });
            });
    }, [views, deleteView]);
    return (React.createElement(DropDownButton, __assign({ mx: (renderMode === null || renderMode === void 0 ? void 0 : renderMode.length) === 1 ? 0 : 1, disabled: props.disabled, quartenary: true, light: props.dark, outline: true, joined: true, alignRight: (renderMode === null || renderMode === void 0 ? void 0 : renderMode.length) === 1, noListFormat: true, icon: React.createElement(FontAwesomeIcon, { icon: faChartPie }), label: "Views", compact: compact }, props.buttonProps, { items: memoizedItems })));
};
export default ViewsMenu;
var templateObject_1, templateObject_2;
