import { mount } from 'enzyme';
import noop from 'lodash/noop';
import React from 'react';
import sinon from 'sinon';
import { Pager, Provider } from '../../';
describe('Pager component', function () {
    it('should disable the "prev" button on page 0', function () {
        var callback = sinon.spy();
        var component = mount(React.createElement(Provider, null,
            React.createElement(Pager, { totalItems: 436, itemsPerPage: 50, page: 0, nextPage: noop, prevPage: callback })));
        var firstButton = component.find('button').first();
        firstButton.simulate('click');
        expect(callback.callCount).toEqual(0);
        expect(firstButton.prop('disabled')).toEqual(true);
    });
    it('should disable the "next" button on the last page', function () {
        var callback = sinon.spy();
        var component = mount(React.createElement(Provider, null,
            React.createElement(Pager, { totalItems: 100, itemsPerPage: 50, page: 1, nextPage: callback, prevPage: noop })));
        var lastButton = component.find('button').last();
        lastButton.simulate('click');
        expect(callback.callCount).toEqual(0);
        expect(lastButton.prop('disabled')).toEqual(true);
    });
});
