import { __assign, __rest } from "tslib";
import { faStar as faStarSolid } from '@fortawesome/free-solid-svg-icons/faStar';
import { faStar as faStarRegular } from '@fortawesome/free-regular-svg-icons/faStar';
import { FontAwesomeIcon, } from '@fortawesome/react-fontawesome';
import * as React from 'react';
import range from 'lodash/range';
import isNumber from 'lodash/isNumber';
import asRendition from '../../asRendition';
import { useTheme } from '../../hooks/useTheme';
import { Flex } from '../Flex';
var Star = function (_a) {
    var full = _a.full, rest = __rest(_a, ["full"]);
    var theme = useTheme();
    var iconProps = full
        ? {
            color: theme.rating.star.color.full,
            icon: faStarSolid,
        }
        : {
            color: theme.rating.star.color.empty,
            icon: faStarRegular,
        };
    return React.createElement(FontAwesomeIcon, __assign({}, iconProps, rest));
};
var isStarFull = function (hoverValue, newValue, value) {
    if (hoverValue > 0) {
        return newValue <= hoverValue;
    }
    return isNumber(value) && newValue <= value;
};
var BaseRating = React.memo(function (_a) {
    var value = _a.value, onChange = _a.onChange, rest = __rest(_a, ["value", "onChange"]);
    var _b = React.useState(0), hoverValue = _b[0], setHoverValue = _b[1];
    return (React.createElement(Flex, __assign({}, rest), range(1, 6).map(function (newValue) {
        return (React.createElement(Star, { key: newValue, full: isStarFull(hoverValue, newValue, value), onClick: function () { return onChange(newValue); }, onMouseOver: function () { return setHoverValue(newValue); }, onMouseOut: function () { return setHoverValue(0); } }));
    })));
});
export var Rating = asRendition(BaseRating);
