import { FormatValidator, FormatDefinition } from 'ajv';
import { UiSchema as rjsfUiSchema } from '@rjsf/core';
import { Widget } from './widgets/widget-util';
export type { JSONSchema7 as JSONSchema } from 'json-schema';
export declare const JsonTypes: {
    readonly array: "array";
    readonly object: "object";
    readonly number: "number";
    readonly integer: "integer";
    readonly string: "string";
    readonly boolean: "boolean";
    readonly null: "null";
};
export interface JsonTypesTypeMap {
    array: unknown[];
    object: {};
    number: number;
    integer: number;
    string: string;
    boolean: boolean;
    null: null;
}
export declare type DefinedValue = number | string | boolean | {
    [key: string]: any;
} | any[];
export declare type Value = DefinedValue | null;
export interface UiSchema extends Pick<rjsfUiSchema, 'ui:options' | 'ui:order'> {
    'ui:widget'?: string;
    'ui:title'?: string;
    'ui:description'?: string;
    'ui:value'?: Value;
}
export interface Format {
    name: string;
    format: FormatValidator | FormatDefinition;
    widget?: Widget;
}
