import { __assign, __rest } from "tslib";
import * as React from 'react';
import map from 'lodash/map';
import get from 'lodash/get';
import { Flex } from '../../Flex';
import { widgetFactory, getArrayItems } from './widget-util';
import { Renderer } from '../index';
import { JsonTypes } from '../types';
import { UiOption } from './ui-options';
var ArrayWidget = widgetFactory('Array', {
    orientation: __assign(__assign({}, UiOption.string), { enum: ['vertical', 'horizontal'] }),
    truncate: UiOption.integer,
}, [JsonTypes.array])(function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, extraContext = _a.extraContext, extraFormats = _a.extraFormats, rest = __rest(_a, ["value", "schema", "uiSchema", "extraContext", "extraFormats"]);
    var items = getArrayItems({
        value: value,
        schema: schema,
        uiSchema: uiSchema,
        extraContext: extraContext,
        extraFormats: extraFormats,
    });
    return (React.createElement(Flex, { flexDirection: get(uiSchema, ['ui:options', 'orientation']) === 'horizontal'
            ? 'row'
            : 'column', flexWrap: "wrap" }, map(items, function (item, index) {
        return React.createElement(Renderer, __assign({ key: index, nested: true }, item, rest));
    })));
});
export default ArrayWidget;
