import { __assign, __rest } from "tslib";
import * as React from 'react';
import get from 'lodash/get';
import { Badge } from '../../Badge';
import { hashCode } from '../../../utils';
import { UiOption } from './ui-options';
import { widgetFactory } from './widget-util';
import { JsonTypes } from '../types';
var BadgeWidget = widgetFactory('Badge', {
    shade: UiOption.number,
}, [JsonTypes.string, JsonTypes.integer, JsonTypes.number, JsonTypes.boolean])(function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, props = __rest(_a, ["value", "schema", "uiSchema"]);
    if (value == null) {
        return null;
    }
    var shade = get(props, 'shade', hashCode(value.toString(), 23));
    return (React.createElement(Badge, __assign({}, props, { shade: shade }), value.toString()));
});
export default BadgeWidget;
