import { __assign, __rest } from "tslib";
import React from 'react';
import { Flex } from '../../Flex';
import { Txt } from '../../Txt';
import { JsonTypes } from '../types';
import { UiOption } from './ui-options';
import { widgetFactory } from './widget-util';
import { isLight } from '../../../utils/colorUtils';
var DEFAULT_WIDTH = '100px';
var DEFAULT_HEIGHT = '100px';
var ColorWidget = widgetFactory('Color', {
    label: UiOption.string,
    hideValueDisplay: UiOption.bool,
    width: UiOption.space,
    height: UiOption.space,
}, [JsonTypes.string])(function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, label = _a.label, hideValueDisplay = _a.hideValueDisplay, _b = _a.width, width = _b === void 0 ? DEFAULT_WIDTH : _b, _c = _a.height, height = _c === void 0 ? DEFAULT_HEIGHT : _c, props = __rest(_a, ["value", "schema", "uiSchema", "label", "hideValueDisplay", "width", "height"]);
    if (value == null) {
        return null;
    }
    var bg = value.toString() || 'transparent';
    var color = isLight(bg) ? '#000' : '#FFF';
    return (React.createElement(Flex, __assign({}, props, { width: width, height: height, bg: bg, color: color, alignItems: "center", flexDirection: "column", justifyContent: "center" }),
        label && React.createElement(Txt, null, label),
        !hideValueDisplay && React.createElement(Txt, null, value)));
});
export default ColorWidget;
