import React from 'react';
import { widgetFactory } from './widget-util';
import { JsonTypes } from '../types';
import { Txt } from '../../Txt';
import { intervalToDuration } from 'date-fns';
export var DurationWidget = widgetFactory('Duration', {}, [JsonTypes.object])(function (_a) {
    var value = _a.value;
    var duration = React.useMemo(function () {
        if (!value.start || !value.end) {
            return '';
        }
        var interval = intervalToDuration({
            start: new Date(value.start),
            end: new Date(value.end),
        });
        if (!interval) {
            return '';
        }
        var customInterval = {};
        Object.entries(interval).forEach(function (_a) {
            var key = _a[0], value = _a[1];
            if (value != null && value < 10) {
                customInterval[key] = "0" + value;
            }
            else {
                customInterval[key] = "" + value;
            }
        });
        var durationText = '';
        if (!!interval.years) {
            durationText += customInterval.years + "y ";
        }
        if (!!interval.years || !!interval.months) {
            durationText += customInterval.months + "m ";
        }
        if (!!interval.years || !!interval.months || !!interval.days) {
            durationText += customInterval.days + "d ";
        }
        durationText += customInterval.hours + ":" + customInterval.minutes + ":" + customInterval.seconds;
        return durationText;
    }, []);
    return React.createElement(Txt, null, duration);
});
