import { __assign, __rest } from "tslib";
import * as React from 'react';
import get from 'lodash/get';
import { Link } from '../../Link';
import { UiOption } from './ui-options';
import { widgetFactory } from './widget-util';
import { JsonTypes } from '../types';
var LinkWidget = widgetFactory('Link', {
    blank: UiOption.boolean,
    download: UiOption.string,
    href: UiOption.string,
    rel: UiOption.string,
    type: UiOption.string,
}, [JsonTypes.string])(function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, props = __rest(_a, ["value", "schema", "uiSchema"]);
    if (value == null) {
        return null;
    }
    var href = get(props, 'href', value.toString());
    if (get(schema, 'format') === 'email') {
        href = "mailto:" + href.replace(/^mailto:/, '');
    }
    return (React.createElement(Link, __assign({}, props, { href: href }), value.toString()));
});
export default LinkWidget;
