import { __assign, __rest } from "tslib";
import * as React from 'react';
import map from 'lodash/map';
import { List } from '../../List';
import { widgetFactory, getArrayItems } from './widget-util';
import { Renderer } from '../index';
import { JsonTypes } from '../types';
import { UiOption } from './ui-options';
var ListWidget = widgetFactory('List', {
    truncate: UiOption.integer,
    ordered: UiOption.boolean,
}, [JsonTypes.array])(function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, truncate = _a.truncate, extraFormats = _a.extraFormats, extraContext = _a.extraContext, props = __rest(_a, ["value", "schema", "uiSchema", "truncate", "extraFormats", "extraContext"]);
    var items = getArrayItems({
        value: value,
        schema: schema,
        uiSchema: uiSchema,
        extraContext: extraContext,
        extraFormats: extraFormats,
    });
    return (React.createElement(List, __assign({}, props), map(items, function (item, index) {
        return (React.createElement(Renderer, __assign({ key: index, nested: true }, item, { extraFormats: extraFormats })));
    })));
});
export default ListWidget;
