import { __assign, __makeTemplateObject, __rest } from "tslib";
import React from 'react';
import { useLocation } from 'react-router';
import { NavLink } from 'react-router-dom';
import styled from 'styled-components';
import { Badge } from '../Badge';
import { Flex } from '../Flex';
import { Txt } from '../Txt';
var StyledBadge = styled(Badge)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tborder-radius: 0 1em 1em 0;\n\tposition: absolute;\n\ttransform: scale(0.75);\n\tleft: -5%;\n\tbottom: 5%;\n"], ["\n\tborder-radius: 0 1em 1em 0;\n\tposition: absolute;\n\ttransform: scale(0.75);\n\tleft: -5%;\n\tbottom: 5%;\n"])));
var MenuItem = styled(Flex)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\theight: 48px;\n\tcursor: pointer;\n\tborder-bottom: 1px solid\n\t\t", ";\n\tborder-left: ", ";\n\tbackground: ", ";\n\n\t&:hover {\n\t\tbackground: ", ";\n\t}\n\tposition: relative;\n"], ["\n\theight: 48px;\n\tcursor: pointer;\n\tborder-bottom: 1px solid\n\t\t",
    ";\n\tborder-left: ",
    ";\n\tbackground: ",
    ";\n\n\t&:hover {\n\t\tbackground: ",
    ";\n\t}\n\tposition: relative;\n"])), function (props) {
    return props.isCurrent
        ? props.theme.colors.quartenary.light
        : props.theme.colors.tertiary.dark;
}, function (props) {
    return props.isCurrent ? "2px solid " + props.theme.colors.primary.main : 'none';
}, function (props) {
    return props.isCurrent
        ? props.theme.colors.quartenary.light
        : props.theme.colors.secondary.dark;
}, function (props) {
    return props.isCurrent
        ? props.theme.colors.quartenary.light
        : props.theme.colors.tertiary.dark;
});
export var Menu = function (_a) {
    var items = _a.items, isCollapsed = _a.isCollapsed, props = __rest(_a, ["items", "isCollapsed"]);
    var pathname = useLocation().pathname;
    var currentItem = React.useMemo(function () {
        return (items.find(function (item) { return pathname === item.href; }) ||
            items.find(function (item) { return pathname.startsWith(item.href); }));
    }, [items, pathname]);
    return (React.createElement(Flex, __assign({ flexDirection: "column" }, props), items.map(function (item) {
        var isCurrent = currentItem === item;
        return (React.createElement(NavLink, { key: item.href, to: item.href },
            React.createElement(MenuItem, { className: item.className, width: "100%", isCurrent: isCurrent, px: 3, py: 2, flexDirection: "row", alignItems: "center", justifyContent: isCollapsed ? 'center' : 'unset' },
                !!item.badge && React.createElement(StyledBadge, __assign({}, item.badge)),
                !!item.icon && (React.createElement(Txt.span, { bold: true, color: isCurrent ? 'text.main' : 'secondary.semilight', fontSize: isCollapsed ? 4 : 3, mr: isCollapsed ? 0 : 2 }, item.icon)),
                !isCollapsed && (React.createElement(Txt.span, { bold: true, fontSize: 2, style: { lineHeight: 1.33 }, color: isCurrent ? 'text.main' : 'quartenary.main' }, item.title)),
                !item.icon && isCollapsed && (React.createElement(Txt.span, { bold: true, tooltip: item.title, color: isCurrent ? 'text.main' : 'secondary.semilight', fontSize: 4, ml: 1 }, item.title.charAt(0).toUpperCase())))));
    })));
};
var templateObject_1, templateObject_2;
