import { __assign, __rest } from "tslib";
import * as React from 'react';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { Flex } from '../Flex';
import { Breadcrumbs } from '../Breadcrumbs';
import { Button } from '../Button';
import { faChevronLeft } from '@fortawesome/free-solid-svg-icons/faChevronLeft';
import { faChevronRight } from '@fortawesome/free-solid-svg-icons/faChevronRight';
import { Menu } from './Menu';
export var Sidebar = function (_a) {
    var menuItems = _a.menuItems, crumbs = _a.crumbs, _b = _a.showBreadcrumbs, showBreadcrumbs = _b === void 0 ? true : _b, _c = _a.isCollapsed, isCollapsed = _c === void 0 ? false : _c, additionalComponents = _a.additionalComponents, setIsCollapsed = _a.setIsCollapsed, props = __rest(_a, ["menuItems", "crumbs", "showBreadcrumbs", "isCollapsed", "additionalComponents", "setIsCollapsed"]);
    return (React.createElement(Flex, __assign({ flexDirection: "column", flexWrap: "nowrap", backgroundColor: "secondary.main" }, props),
        showBreadcrumbs && !!crumbs && (React.createElement(Flex, { pl: isCollapsed ? 15 : 24, pr: 1, mb: 3, mt: 20 },
            React.createElement(Breadcrumbs, { crumbs: crumbs, isCollapsed: isCollapsed }))),
        React.createElement(Menu, { flex: "1", ml: !isCollapsed && showBreadcrumbs && !!crumbs ? 32 : 0, flexDirection: "column", style: { overflowX: 'auto' }, items: menuItems, isCollapsed: isCollapsed }),
        React.createElement(Flex, { justifyContent: "space-between", alignItems: "center", mb: 3, px: 2 },
            additionalComponents,
            !!setIsCollapsed && isCollapsed != null && (React.createElement(Button, { height: "38px", width: "38px", color: "text.light", icon: React.createElement(FontAwesomeIcon, { icon: isCollapsed ? faChevronRight : faChevronLeft }), onClick: function () { return setIsCollapsed(!isCollapsed); }, style: {
                    background: 'rgba(0, 0, 0, 0.1)',
                    borderRadius: '2px',
                } })))));
};
