import type { IconProp } from '@fortawesome/fontawesome-svg-core';
import React from 'react';
import { FlexProps } from '../Flex';
export declare type LabelFormatterProp = (props: {
    value: number;
    max: number | null;
}) => React.ReactElement | string;
export interface StatsBarProps extends Omit<FlexProps, 'title'> {
    title: React.ReactElement;
    labelFormatter?: LabelFormatterProp;
    value: number;
    max: number | null;
    numSlices?: number;
}
export interface StatsTitleProps {
    icon: IconProp;
    title: string;
    description?: string;
}
export interface ValueWithMaxTitleProps {
    value: string;
    max: string;
}
export declare const ValueWithMaxTitle: ({ value, max }: ValueWithMaxTitleProps) => JSX.Element;
export declare const StatsTitle: ({ icon, title, description }: StatsTitleProps) => JSX.Element;
export declare const StatsBar: ({ title, labelFormatter, value, max, numSlices, ...props }: StatsBarProps) => JSX.Element;
