import React from 'react';
import { mount } from 'enzyme';
import { Provider, Steps, Step } from '../../';
describe('Steps component', function () {
    it('Error thrown if ordered is true and activeStepIndex is not set', function () {
        expect(function () {
            mount(React.createElement(Provider, null,
                React.createElement(Steps, { m: 3, ordered: true, bordered: false },
                    React.createElement(Step, { status: "completed", onClick: function () { return null; } }, "Do this"),
                    React.createElement(Step, { status: "completed", onClick: function () { return null; } }, "And then this"),
                    React.createElement(Step, { status: "pending", onClick: function () { return null; } }, "And finally this"))));
        }).toThrowError('You must specify the activeStepIndex for ordered Steps');
    });
    it('Error thrown if activeStepIndex is too high', function () {
        expect(function () {
            mount(React.createElement(Provider, null,
                React.createElement(Steps, { m: 3, ordered: true, bordered: false, activeStepIndex: 3 },
                    React.createElement(Step, { status: "completed", onClick: function () { return null; } }, "Do this"),
                    React.createElement(Step, { status: "completed", onClick: function () { return null; } }, "And then this"),
                    React.createElement(Step, { status: "pending", onClick: function () { return null; } }, "And finally this"))));
        }).toThrowError('activeStepIndex is out of range');
    });
});
