import React from 'react';
import { createStory, createTemplate } from '../../stories/utils';
import Theme from '../../theme';
import { Flex } from '../Flex';
import { Heading } from '../Heading';
import { Txt } from '../Txt';
export default {
    title: 'Styles/Colors',
};
var getContrast = function (hexColor) {
    var r = parseInt(hexColor.substr(1, 2), 16);
    var g = parseInt(hexColor.substr(3, 2), 16);
    var b = parseInt(hexColor.substr(5, 2), 16);
    var colorSpace = (r * 299 + g * 587 + b * 114) / 1000;
    return colorSpace >= 128 ? 'black' : 'white';
};
var SwatchesComponent = function () {
    return (React.createElement(Flex, { flexWrap: "wrap" }, Object.entries(Theme.colors).map(function (_a) {
        var key = _a[0], value = _a[1];
        return (React.createElement(Flex, { flexDirection: "column", mr: 5, mb: 3 },
            React.createElement(Heading.h4, { bold: true }, key),
            React.createElement(Flex, null, Object.entries(value).map(function (_a) {
                var colorKey = _a[0], colorValue = _a[1];
                return (React.createElement(Flex, { width: "100px", height: "100px", bg: colorValue, alignItems: "center", justifyContent: "center" },
                    React.createElement(Txt, { color: getContrast(colorValue) }, colorKey)));
            }))));
    })));
};
var Template = createTemplate(SwatchesComponent);
export var Default = createStory(Template, {});
