/// <reference types="react" />
export interface TableColumnStateBase {
    title?: string;
    key: string;
    selected: boolean;
    locked?: boolean;
}
export interface PredefinedTableColumnState extends TableColumnStateBase {
    type?: 'predefined';
}
export interface TagTableColumnState extends TableColumnStateBase {
    title?: string;
    type?: 'tag';
    tagKey?: string;
}
export declare type TableColumnState = PredefinedTableColumnState | TagTableColumnState;
export declare const TableColumnStateStoredProps: Array<keyof PredefinedTableColumnState | keyof TagTableColumnState>;
export declare const getNewTagTableColumnState: (tagKey: string | undefined) => TagTableColumnState;
interface TableColumnSelectorProps<T extends TableColumnState> {
    columns: T[];
    setColumns: (visibleColumns: T[]) => void;
    addTagColumn: () => void;
    tagKeys?: string[];
}
export declare const TableColumnSelector: <T extends TableColumnState>(props: TableColumnSelectorProps<T>) => JSX.Element;
export {};
