import { createTemplate, createStory } from '../../stories/utils';
import { Tag } from '.';
export default {
    title: 'Core/Tag',
    component: Tag,
};
var Template = createTemplate(Tag);
export var Default = createStory(Template, {
    name: 'Tag',
    value: 'Value',
});
export var OnlyValue = createStory(Template, {
    value: 'Value',
});
export var OnlyName = createStory(Template, {
    value: 'Name',
});
export var Empty = createStory(Template, {});
export var MultipleValues = createStory(Template, {
    multiple: [
        { name: 'Tag1', operator: 'contains', value: 'value1' },
        {
            prefix: 'or',
            name: 'Tag2',
            operator: 'contains',
            value: 'value2',
        },
    ],
});
export var Overflow = createStory(Template, {
    multiple: [
        { name: 'Tag1', operator: 'contains', value: 'value1' },
        {
            prefix: 'or',
            name: 'Tag2',
            operator: 'contains',
            value: 'value2',
        },
        {
            prefix: 'or',
            name: 'Tag3',
            operator: 'contains',
            value: 'value3',
        },
        {
            prefix: 'or',
            name: 'Tag4',
            operator: 'contains',
            value: 'value4',
        },
    ],
});
export var Clickable = createStory(Template, {
    name: 'Tag',
    value: 'Value',
    onClick: function () { return null; },
});
export var Closable = createStory(Template, {
    name: 'Tag',
    value: 'Value',
    onClose: function () { return null; },
});
