import { __extends, __makeTemplateObject } from "tslib";
import * as React from 'react';
import styled from 'styled-components';
import { Theme } from '../../../index';
import { Txt } from '../../Txt';
import { getThemeColoring } from '../../../utils';
import { CaretButton } from './CaretButton';
var Container = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tfont-size: 16px;\n\tfont-weight: normal;\n\tcolor: #b3b6b9;\n"], ["\n\tfont-size: 16px;\n\tfont-weight: normal;\n\tcolor: #b3b6b9;\n"])));
var ItemNameHolder = styled(Txt)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tfont-size: 0.9em;\n\twhite-space: normal;\n\tcolor: ", ";\n"], ["\n\tfont-size: 0.9em;\n\twhite-space: normal;\n\tcolor: ", ";\n"])), function (prop) { return prop.color || ''; });
var CollectionSummary = (function (_super) {
    __extends(CollectionSummary, _super);
    function CollectionSummary(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            isExpanded: !!_this.props.initiallyExpanded,
        };
        return _this;
    }
    CollectionSummary.prototype.render = function () {
        var _this = this;
        var _a = this.props, items = _a.items, itemsType = _a.itemsType, maxVisibleItemCount = _a.maxVisibleItemCount;
        var itemNameColor = getThemeColoring(Theme, this.props, 'main');
        return (React.createElement(Container, null,
            items.length === 1 && React.createElement(Txt, { color: itemNameColor }, items[0]),
            items.length > 1 && (React.createElement("div", null,
                React.createElement(CaretButton, { isExpanded: this.state.isExpanded, onClick: function () {
                        return _this.setState({
                            isExpanded: !_this.state.isExpanded,
                        });
                    } },
                    React.createElement("span", null, items.length + " " + itemsType)),
                this.state.isExpanded && (React.createElement(ItemNameHolder, { color: itemNameColor }, maxVisibleItemCount && items.length > maxVisibleItemCount
                    ? items.slice(0, maxVisibleItemCount).join(', ') + ", ..."
                    : items.join(', ')))))));
    };
    return CollectionSummary;
}(React.Component));
export { CollectionSummary };
var templateObject_1, templateObject_2;
