import { __assign, __extends, __makeTemplateObject, __rest } from "tslib";
import * as React from 'react';
import styled from 'styled-components';
import { TagLabel as TagLabelBase } from './TagLabel';
import isEqual from 'lodash/isEqual';
import map from 'lodash/map';
import sortBy from 'lodash/sortBy';
import { Flex } from '../Flex';
export var TagLabel = styled(TagLabelBase)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tdisplay: inline-flex;\n\tmax-width: 200px;\n"], ["\n\tdisplay: inline-flex;\n\tmax-width: 200px;\n"])));
var getDefaultState = function () { return ({
    sortedTags: [],
}); };
var TagLabelList = (function (_super) {
    __extends(TagLabelList, _super);
    function TagLabelList(props) {
        var _this = _super.call(this, props) || this;
        _this.state = getDefaultState();
        return _this;
    }
    TagLabelList.prototype.componentDidMount = function () {
        this.setState({ sortedTags: sortBy(this.props.tags || [], 'tag_key') });
    };
    TagLabelList.prototype.componentWillReceiveProps = function (_a) {
        var tags = _a.tags;
        if (!this.state.sortedTags || !isEqual(this.props.tags, tags)) {
            this.setState({ sortedTags: sortBy(tags || [], 'tag_key') });
        }
    };
    TagLabelList.prototype.render = function () {
        var _a = this.props, tags = _a.tags, nowrap = _a.nowrap, restProps = __rest(_a, ["tags", "nowrap"]);
        return (React.createElement(Flex, __assign({ mx: "-5px", flexWrap: nowrap ? 'nowrap' : 'wrap' }, restProps), map(this.state.sortedTags, function (tag) { return (React.createElement(TagLabel, { key: tag.tag_key, tag: tag, mx: "5px", my: nowrap ? undefined : '5px' })); })));
    };
    return TagLabelList;
}(React.Component));
export { TagLabelList };
var templateObject_1;
