import { TextAreaProps as GrommetTextAreaProps } from 'grommet';
import * as React from 'react';
import { RenditionSystemProps } from '../../common-types';
export interface InternalTextareaProps extends React.HTMLAttributes<HTMLElement>, GrommetTextAreaProps {
    monospace?: boolean;
    autoComplete?: string;
    autoFocus?: boolean;
    cols?: number;
    dirName?: string;
    disabled?: boolean;
    form?: string;
    maxLength?: number;
    minLength?: number;
    readOnly?: boolean;
    required?: boolean;
    rows?: number;
    wrap?: string;
    onChange?: React.ChangeEventHandler<HTMLTextAreaElement>;
    onBlur?: React.FocusEventHandler<HTMLTextAreaElement>;
    onFocus?: React.FocusEventHandler<HTMLTextAreaElement>;
    autoRows?: boolean;
    maxRows?: number;
    minRows?: number;
    invalid?: boolean;
    valid?: boolean;
}
export declare type TextareaProps = InternalTextareaProps & RenditionSystemProps;
export declare const Textarea: React.FunctionComponent<TextareaProps>;
