import React from 'react';
import { autoUIJsonSchemaPick, } from '../schemaOps';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { getCreateDisabledReason } from '../utils';
import { Button } from '../../../components/Button';
import { faMagic } from '@fortawesome/free-solid-svg-icons/faMagic';
import { useTranslation } from '../../../hooks/useTranslation';
import { Box } from '../../../components/Box';
export var Create = function (_a) {
    var model = _a.model, autouiContext = _a.autouiContext, hasOngoingAction = _a.hasOngoingAction, onActionTriggered = _a.onActionTriggered;
    var t = useTranslation().t;
    var actions = autouiContext.actions;
    var createActions = actions === null || actions === void 0 ? void 0 : actions.filter(function (action) { return action.type === 'create'; });
    if (!createActions || createActions.length < 1) {
        return null;
    }
    if (createActions.length > 1) {
        throw new Error('Only one create action per resource is allowed');
    }
    var disabledReason = !!createActions[0].isDisabled
        ? createActions[0].isDisabled({})
        : getCreateDisabledReason(model.permissions, hasOngoingAction, t);
    return (React.createElement(Box, null,
        React.createElement(Button, { "data-action": "create-" + model.resource, onClick: function () {
                return onActionTriggered({
                    action: createActions[0],
                    schema: autoUIJsonSchemaPick(model.schema, model.permissions.create),
                });
            }, icon: React.createElement(FontAwesomeIcon, { icon: faMagic }), tooltip: typeof disabledReason === 'string' ? disabledReason : undefined, disabled: !!disabledReason, primary: true }, createActions[0].title)));
};
