import { __awaiter, __generator } from "tslib";
import React from 'react';
import { TagManagementModal } from '../../../components/TagManagementModal';
import { useTranslation } from '../../../hooks/useTranslation';
import { notifications } from '../../../components/Notifications';
export var Tags = function (_a) {
    var selected = _a.selected, autouiContext = _a.autouiContext, setIsBusyMessage = _a.setIsBusyMessage, refresh = _a.refresh, onDone = _a.onDone;
    var t = useTranslation().t;
    var sdk = autouiContext.sdk;
    var changeTags = React.useCallback(function (tags) { return __awaiter(void 0, void 0, void 0, function () {
        var err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(sdk === null || sdk === void 0 ? void 0 : sdk.tags)) {
                        return [2];
                    }
                    setIsBusyMessage(t("loading.updating_tags"));
                    notifications.addNotification({
                        id: 'change-tags-loading',
                        content: t("loading.updating_tags"),
                    });
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, 4, 5]);
                    return [4, sdk.tags.submit(tags)];
                case 2:
                    _a.sent();
                    notifications.addNotification({
                        id: 'change-tags',
                        content: 'Tags updated successfully',
                        type: 'success',
                    });
                    refresh === null || refresh === void 0 ? void 0 : refresh();
                    return [3, 5];
                case 3:
                    err_1 = _a.sent();
                    notifications.addNotification({
                        id: 'change-tags',
                        content: err_1.message,
                        type: 'danger',
                    });
                    return [3, 5];
                case 4:
                    notifications.removeNotification('change-tags-loading');
                    setIsBusyMessage(undefined);
                    return [7];
                case 5: return [2];
            }
        });
    }); }, [sdk === null || sdk === void 0 ? void 0 : sdk.tags, refresh, selected]);
    if (!autouiContext.tagField || !autouiContext.nameField) {
        return null;
    }
    return (React.createElement(TagManagementModal, { items: selected, itemType: autouiContext.resource, titleField: autouiContext.nameField, tagField: autouiContext.tagField, done: function (tagSubmitInfo) {
            changeTags(tagSubmitInfo);
            onDone();
        }, cancel: function () { return onDone(); } }));
};
