import React from 'react';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { autoUIJsonSchemaPick, } from '../schemaOps';
import { autoUIGetDisabledReason } from '../utils';
import { DropDownButton } from '../../../components/DropDownButton';
import { faEllipsisH } from '@fortawesome/free-solid-svg-icons/faEllipsisH';
import { useTranslation } from '../../../hooks/useTranslation';
import groupBy from 'lodash/groupBy';
import map from 'lodash/map';
import { Button } from '../../../components/Button';
import { Box } from '../../../components/Box';
export var Update = function (_a) {
    var _b, _c;
    var model = _a.model, autouiContext = _a.autouiContext, selected = _a.selected, hasOngoingAction = _a.hasOngoingAction, onActionTriggered = _a.onActionTriggered;
    var t = useTranslation().t;
    var actions = autouiContext.actions;
    var updateActions = actions === null || actions === void 0 ? void 0 : actions.filter(function (action) { return action.type === 'update' || action.type === 'delete'; }).sort(function (a) { return (a.type === 'delete' ? 1 : -1); }).sort(function (a) { return (a.isDangerous ? 1 : a.type === 'delete' ? 0 : -1); });
    if (!updateActions || updateActions.length < 1) {
        return null;
    }
    if (updateActions.length === 1) {
        var action_1 = updateActions[0];
        var disabledReason_1 = (_b = autoUIGetDisabledReason(selected, hasOngoingAction, action_1.type, t)) !== null && _b !== void 0 ? _b : (_c = action_1.isDisabled) === null || _c === void 0 ? void 0 : _c.call(action_1, { affectedEntries: selected });
        return (React.createElement(Box, { alignSelf: "flex-start" },
            React.createElement(Button, { key: action_1.title, "data-action": action_1.type + "-" + model.resource, onClick: function () {
                    return onActionTriggered({
                        action: action_1,
                        schema: action_1.type === 'delete'
                            ? {}
                            : autoUIJsonSchemaPick(model.schema, model.permissions[action_1.type]),
                        affectedEntries: selected,
                    });
                }, tooltip: typeof disabledReason_1 === 'string' ? disabledReason_1 : undefined, disabled: !!disabledReason_1, plain: updateActions.length > 1, danger: action_1.isDangerous, secondary: true }, action_1.title)));
    }
    var groupedActions = groupBy(updateActions, function (action) { return !!action.isDangerous; });
    var actionHandlers = map(groupedActions, function (actions) {
        return actions.map(function (action) {
            var _a, _b;
            var disabledReason = (_a = autoUIGetDisabledReason(selected, hasOngoingAction, action.type, t)) !== null && _a !== void 0 ? _a : (_b = action.isDisabled) === null || _b === void 0 ? void 0 : _b.call(action, { affectedEntries: selected });
            return {
                content: action.title,
                onClick: function () {
                    return onActionTriggered({
                        action: action,
                        schema: action.type === 'delete'
                            ? {}
                            : autoUIJsonSchemaPick(model.schema, model.permissions[action.type]),
                        affectedEntries: selected,
                    });
                },
                tooltip: typeof disabledReason === 'string' ? disabledReason : undefined,
                disabled: !!disabledReason,
                danger: action.isDangerous,
            };
        });
    });
    var disabledReason = autoUIGetDisabledReason(selected, hasOngoingAction, null, t);
    return (React.createElement(Box, { alignSelf: "flex-start" },
        React.createElement(DropDownButton, { compact: [true, true, false, false], joined: true, alignRight: true, secondary: true, disabled: !!disabledReason, tooltip: disabledReason, icon: React.createElement(FontAwesomeIcon, { icon: faEllipsisH }), label: t('labels.actions'), items: actionHandlers })));
};
