import { __assign, __rest } from "tslib";
import React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { autoUIGetModelForCollection, autoUIRunTransformers, } from './models/helpers';
import { dataExample, model as sshKeyModel, transformers, } from './models/example';
import { AutoUI as RenditionAutoUI } from '.';
import { Button } from '../../components/Button';
import flatten from 'lodash/flatten';
import { Heading } from '../../components/Heading';
export default {
    title: 'Extra/AutoUI',
    component: RenditionAutoUI,
};
var DemoAutoUI = function (_a) {
    var data = _a.data, model = _a.model, otherProps = __rest(_a, ["data", "model"]);
    var _b = React.useState(true), dataIsArray = _b[0], setDataIsArray = _b[1];
    var memoizedData = React.useMemo(function () {
        return autoUIRunTransformers(dataExample, transformers, {
            accessRole: 'administrator',
        });
    }, [dataExample]);
    return (React.createElement(React.Fragment, null,
        React.createElement(Heading.h5, null, "The AutoUI component determines whether the data passed into it is a collection or an entity. Click the button below to change the value passed in for \"data\"."),
        React.createElement(Button, { onClick: function () { return setDataIsArray(!dataIsArray); }, label: "Pass an " + (dataIsArray ? 'entity' : 'array') + " for \"data\"", my: 3 }),
        React.createElement(RenditionAutoUI, __assign({ data: dataIsArray
                ? data !== null && data !== void 0 ? data : memoizedData : flatten([data !== null && data !== void 0 ? data : memoizedData])[0], model: model !== null && model !== void 0 ? model : autoUIGetModelForCollection(sshKeyModel), actions: [] }, otherProps))));
};
var Template = createTemplate(DemoAutoUI);
export var Default = createStory(Template, {});
