import React from 'react';
import { JsonTypes, } from '../../components/Renderer/types';
import { transformUiSchema } from '../../components/Renderer/widgets/widget-util';
import { getValue, getWidget } from '../../components/Renderer';
import castArray from 'lodash/castArray';
export var CustomWidget = function (_a) {
    var value = _a.value, extraContext = _a.extraContext, schema = _a.schema, extraFormats = _a.extraFormats, uiSchema = _a.uiSchema;
    var processedUiSchema = transformUiSchema({
        value: value,
        uiSchema: uiSchema,
        extraContext: extraContext,
    });
    var processedValue = getValue(value, schema, processedUiSchema);
    var types = (schema === null || schema === void 0 ? void 0 : schema.type) != null ? castArray(schema.type) : [];
    if (processedValue === undefined ||
        (processedValue === null && !types.includes(JsonTypes.null))) {
        return null;
    }
    var Widget = getWidget(processedValue, schema.format, undefined, extraFormats);
    return (React.createElement(Widget, { extraContext: extraContext, extraFormats: extraFormats, value: processedValue, schema: schema }));
};
