import { __makeTemplateObject } from "tslib";
import React from 'react';
import { Txt } from '../../../components/Txt';
import { Checkbox } from '../../../components/Checkbox';
import reject from 'lodash/reject';
import styled from 'styled-components';
import { Box } from '../../../components/Box';
import { Flex } from '../../../components/Flex';
import { useHistory } from '../../../hooks/useHistory';
import { stopEvent } from '../../../utils';
import { createFullTextSearchFilter, filter as schemaSieveFilter, } from '../../../components/Filters/SchemaSieve';
import { getPropertyRefScheme } from '../models/helpers';
var Focus = styled(Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tflex-basis: 100%;\n\tbackground-color: white;\n\tborder: solid 1px ", ";\n\tmax-height: 200px;\n\tposition: absolute;\n\twidth: 100%;\n\tz-index: 1;\n\tborder-radius: 0 0 ", "\n\t\t", ";\n\toverflow: hidden;\n"], ["\n\tflex-basis: 100%;\n\tbackground-color: white;\n\tborder: solid 1px ", ";\n\tmax-height: 200px;\n\tposition: absolute;\n\twidth: 100%;\n\tz-index: 1;\n\tborder-radius: 0 0 ", "\n\t\t", ";\n\toverflow: hidden;\n"])), function (props) { return props.theme.colors.quartenary.dark; }, function (props) { return props.theme.global.drop.border.radius; }, function (props) { return props.theme.global.drop.border.radius; });
var FocusContent = styled(Box)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tmax-height: 180px;\n\toverflow-y: auto;\n\toverflow-x: auto;\n"], ["\n\tmax-height: 180px;\n\toverflow-y: auto;\n\toverflow-x: auto;\n"])));
var FocusItem = styled(Box)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\tcursor: ", ";\n\t&:hover {\n\t\tbackground: #dde1f0; // This is the background color Select uses for entities on hover. We do not have it in our theme\n\t}\n"], ["\n\tcursor: ", ";\n\t&:hover {\n\t\tbackground: #dde1f0; // This is the background color Select uses for entities on hover. We do not have it in our theme\n\t}\n"])), function (props) { return (props.hasGetBaseUrl ? 'pointer' : 'default'); });
export var FocusSearch = function (_a) {
    var searchTerm = _a.searchTerm, filtered = _a.filtered, selected = _a.selected, setSelected = _a.setSelected, autouiContext = _a.autouiContext, model = _a.model, hasUpdateActions = _a.hasUpdateActions;
    var history = useHistory();
    var filteredFittingSearchTerms = React.useMemo(function () {
        var filter = createFullTextSearchFilter(model.schema, searchTerm);
        return schemaSieveFilter(filter, filtered);
    }, [searchTerm, filtered]);
    var getEntityValue = function (entity) {
        var _a, _b, _c;
        var property = (_a = model.priorities) === null || _a === void 0 ? void 0 : _a.primary[0];
        var schemaProperty = (_b = model.schema.properties) === null || _b === void 0 ? void 0 : _b[property];
        var refScheme = schemaProperty
            ? getPropertyRefScheme(schemaProperty)
            : null;
        if (!refScheme || typeof schemaProperty === 'boolean') {
            return entity[property];
        }
        return (schemaProperty === null || schemaProperty === void 0 ? void 0 : schemaProperty.type) === 'array'
            ? (_c = entity[property][0]) === null || _c === void 0 ? void 0 : _c[refScheme] : (schemaProperty === null || schemaProperty === void 0 ? void 0 : schemaProperty.type) === 'object'
            ? entity[property][refScheme]
            : entity[property];
    };
    if (!filteredFittingSearchTerms.length) {
        return (React.createElement(Focus, null,
            React.createElement(Flex, { justifyContent: "space-around", py: 2 },
                React.createElement("em", null, "no results"))));
    }
    return (React.createElement(Focus, null,
        React.createElement(FocusContent, null, filteredFittingSearchTerms.map(function (entity) { return (React.createElement(FocusItem, { px: 1, py: 2, key: entity.id, onClick: function (e) {
                var _a;
                e.preventDefault();
                if (autouiContext.getBaseUrl && history) {
                    try {
                        var url = new URL(autouiContext.getBaseUrl(entity));
                        window.open(url.toString(), '_blank');
                    }
                    catch (err) {
                        (_a = history.push) === null || _a === void 0 ? void 0 : _a.call(history, autouiContext.getBaseUrl(entity));
                    }
                }
            }, hasGetBaseUrl: !!autouiContext.getBaseUrl },
            React.createElement(Flex, { flexDirection: "row" },
                hasUpdateActions && (React.createElement(Flex, { flexDirection: "column", ml: 1, mr: 3, alignItems: "center" },
                    React.createElement(Checkbox, { onChange: function () {
                            var isChecked = !!selected.find(function (s) { return s.id === entity.id; });
                            var checkedItems = !isChecked
                                ? selected.concat(entity)
                                : reject(selected, {
                                    id: entity.id,
                                });
                            setSelected(checkedItems);
                        }, checked: !!selected.find(function (s) { return s.id === entity.id; }), onClick: stopEvent }))),
                React.createElement(Flex, { flexDirection: "column", alignItems: "center", ml: !hasUpdateActions ? 1 : undefined },
                    React.createElement(Txt, null, getEntityValue(entity)))))); }))));
};
var templateObject_1, templateObject_2, templateObject_3;
