/// <reference types="react" />
import * as types from './types';
import type { JSONSchema7 } from 'json-schema';
import { IconProp } from '@fortawesome/fontawesome-svg-core';
export interface LensTemplate<T = any> {
    slug: string;
    name: string;
    data: {
        label: string;
        format: string;
        renderer: (props: types.CollectionLensRendererProps<T> | types.EntityLensRendererProps<T>) => React.ReactElement | null;
        icon: IconProp;
        type: string;
        filter: JSONSchema7;
        pathRegExp?: string;
    };
}
export declare const getLenses: <T extends unknown>(data: T | T[], context?: object, customLenses?: LensTemplate<any>[] | undefined) => LensTemplate<any>[];
export declare const getLens: <T extends unknown>(data: T[], context?: object | undefined) => LensTemplate<any> | undefined;
export declare const getLensBySlug: (slug: string) => LensTemplate<any> | null;
export declare const getLensForTarget: (target: string) => number | (<U>(callbackfn: (value: LensTemplate<any>, index: number, array: LensTemplate<any>[]) => U, thisArg?: any) => U[]) | {
    (...items: ConcatArray<LensTemplate<any>>[]): LensTemplate<any>[];
    (...items: (LensTemplate<any> | ConcatArray<LensTemplate<any>>)[]): LensTemplate<any>[];
} | ((separator?: string | undefined) => string) | ((start?: number | undefined, end?: number | undefined) => LensTemplate<any>[]) | ((...items: LensTemplate<any>[]) => number) | (() => LensTemplate<any>[]) | {
    <S extends LensTemplate<any>>(callbackfn: (value: LensTemplate<any>, index: number, array: LensTemplate<any>[]) => value is S, thisArg?: any): S[];
    (callbackfn: (value: LensTemplate<any>, index: number, array: LensTemplate<any>[]) => unknown, thisArg?: any): LensTemplate<any>[];
} | ((value: LensTemplate<any>, start?: number | undefined, end?: number | undefined) => LensTemplate<any>[]) | (() => string) | ((searchElement: LensTemplate<any>, fromIndex?: number | undefined) => number) | ((searchElement: LensTemplate<any>, fromIndex?: number | undefined) => number) | ((searchElement: LensTemplate<any>, fromIndex?: number | undefined) => boolean) | (() => IterableIterator<LensTemplate<any>>) | ((callbackfn: (value: LensTemplate<any>, index: number, array: LensTemplate<any>[]) => void, thisArg?: any) => void) | (() => string) | (() => LensTemplate<any> | undefined) | (() => LensTemplate<any> | undefined) | ((compareFn?: ((a: LensTemplate<any>, b: LensTemplate<any>) => number) | undefined) => LensTemplate<any>[]) | {
    (start: number, deleteCount?: number | undefined): LensTemplate<any>[];
    (start: number, deleteCount: number, ...items: LensTemplate<any>[]): LensTemplate<any>[];
} | ((...items: LensTemplate<any>[]) => number) | ((callbackfn: (value: LensTemplate<any>, index: number, array: LensTemplate<any>[]) => unknown, thisArg?: any) => boolean) | ((callbackfn: (value: LensTemplate<any>, index: number, array: LensTemplate<any>[]) => unknown, thisArg?: any) => boolean) | {
    (callbackfn: (previousValue: LensTemplate<any>, currentValue: LensTemplate<any>, currentIndex: number, array: LensTemplate<any>[]) => LensTemplate<any>): LensTemplate<any>;
    (callbackfn: (previousValue: LensTemplate<any>, currentValue: LensTemplate<any>, currentIndex: number, array: LensTemplate<any>[]) => LensTemplate<any>, initialValue: LensTemplate<any>): LensTemplate<any>;
    <U_1>(callbackfn: (previousValue: U_1, currentValue: LensTemplate<any>, currentIndex: number, array: LensTemplate<any>[]) => U_1, initialValue: U_1): U_1;
} | {
    (callbackfn: (previousValue: LensTemplate<any>, currentValue: LensTemplate<any>, currentIndex: number, array: LensTemplate<any>[]) => LensTemplate<any>): LensTemplate<any>;
    (callbackfn: (previousValue: LensTemplate<any>, currentValue: LensTemplate<any>, currentIndex: number, array: LensTemplate<any>[]) => LensTemplate<any>, initialValue: LensTemplate<any>): LensTemplate<any>;
    <U_2>(callbackfn: (previousValue: U_2, currentValue: LensTemplate<any>, currentIndex: number, array: LensTemplate<any>[]) => U_2, initialValue: U_2): U_2;
} | {
    <S_1 extends LensTemplate<any>>(predicate: (this: void, value: LensTemplate<any>, index: number, obj: LensTemplate<any>[]) => value is S_1, thisArg?: any): S_1 | undefined;
    (predicate: (value: LensTemplate<any>, index: number, obj: LensTemplate<any>[]) => unknown, thisArg?: any): LensTemplate<any> | undefined;
} | ((predicate: (value: LensTemplate<any>, index: number, obj: LensTemplate<any>[]) => unknown, thisArg?: any) => number) | ((target: number, start: number, end?: number | undefined) => LensTemplate<any>[]) | (() => IterableIterator<[number, LensTemplate<any>]>) | (() => IterableIterator<number>) | undefined;
