import { __makeTemplateObject } from "tslib";
import React from 'react';
import styled from 'styled-components';
import { faCube } from '@fortawesome/free-solid-svg-icons/faCube';
import { Flex } from '../../../../components/Flex';
import { Card } from '../../../../components/Card';
import { Txt } from '../../../../components/Txt';
import { Heading } from '../../../../components/Heading';
import { Divider } from '../../../../components/Divider';
import { Update } from '../../Actions/Update';
var Label = styled(Txt)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tcolor: #252629;\n\tfont-size: 11px;\n\ttext-transform: uppercase;\n\tmargin-bottom: 6px;\n"], ["\n\tcolor: #252629;\n\tfont-size: 11px;\n\ttext-transform: uppercase;\n\tmargin-bottom: 6px;\n"])));
export var entity = {
    slug: 'entity',
    name: 'Default entity lens',
    data: {
        label: 'Entity',
        format: 'summary',
        renderer: function (_a) {
            var _b;
            var data = _a.data, properties = _a.properties, hasUpdateActions = _a.hasUpdateActions, model = _a.model, autouiContext = _a.autouiContext;
            var _c = React.useState(), actionData = _c[0], setActionData = _c[1];
            var onActionTriggered = React.useCallback(function (actionData) {
                setActionData(actionData);
                if (actionData.action.actionFn) {
                    actionData.action.actionFn({
                        affectedEntries: actionData.affectedEntries || [],
                    });
                }
            }, []);
            var onActionDone = React.useCallback(function () {
                setActionData(undefined);
            }, []);
            return (React.createElement(Card, null, data && (React.createElement(React.Fragment, null,
                React.createElement(Flex, { flexDirection: "row", justifyContent: "space-between" },
                    React.createElement(Flex, { flexDirection: "column" },
                        React.createElement(Heading.h2, null, properties.length > 0 &&
                            properties[0].render(data[properties[0].key], data))),
                    React.createElement(Flex, { flexDirection: "column", alignItems: "flex-end" }, hasUpdateActions && (React.createElement(Update, { model: model, selected: [data], autouiContext: autouiContext, hasOngoingAction: false, onActionTriggered: onActionTriggered })))),
                React.createElement(Divider, null),
                React.createElement(Flex, { flexDirection: "row", flexWrap: "wrap", justifyContent: "space-between", alignItems: "center" }, properties.map(function (property) {
                    return property.priority !== 'primary' && (React.createElement(Flex, { flexDirection: "column", m: 10, key: property.key, flex: ['100%', '0 0 30%'] },
                        React.createElement(Label, null, property.title),
                        React.createElement(Txt, null, property.render(data[property.key], data))));
                })),
                ((_b = actionData === null || actionData === void 0 ? void 0 : actionData.action) === null || _b === void 0 ? void 0 : _b.renderer) &&
                    actionData.action.renderer({
                        schema: actionData.schema,
                        affectedEntries: actionData.affectedEntries,
                        onDone: onActionDone,
                    })))));
        },
        icon: faCube,
        type: '*',
        filter: {
            type: 'object',
            properties: {
                id: {
                    type: 'number',
                },
            },
        },
    },
};
var templateObject_1;
