import { __assign } from "tslib";
import React from 'react';
import { faTable } from '@fortawesome/free-solid-svg-icons/faTable';
import { Table } from '../../../../components/Table';
export var table = {
    slug: 'table',
    name: 'Default table lens',
    data: {
        label: 'Table',
        format: 'table',
        renderer: function (_a) {
            var filtered = _a.filtered, selected = _a.selected, properties = _a.properties, hasUpdateActions = _a.hasUpdateActions, changeSelected = _a.changeSelected, data = _a.data, autouiContext = _a.autouiContext, onEntityClick = _a.onEntityClick;
            return (React.createElement(Table, __assign({ rowKey: "id", data: filtered, checkedItems: selected, columns: properties }, (hasUpdateActions && { onCheck: changeSelected }), { usePager: data && data.length > 5, pagerPosition: "bottom", itemsPerPage: 50, getRowHref: autouiContext.getBaseUrl, onRowClick: onEntityClick, columnStateRestorationKey: autouiContext.resource + "__columns", sortingStateRestorationKey: autouiContext.resource + "__sort", tagField: autouiContext.tagField, enableCustomColumns: true })));
        },
        icon: faTable,
        type: '*',
        filter: {
            type: 'array',
            items: {
                type: 'object',
                properties: {
                    id: {
                        type: 'number',
                    },
                },
            },
        },
    },
};
