import { __assign, __rest } from "tslib";
import React from 'react';
import { mount } from 'enzyme';
import { Provider, Table } from '../..';
import { autoUIRunTransformers, autoUIGetModelForCollection, AutoUI, } from './index';
import { dataExample, transformers, model as sshKeyModel, } from './models/example';
var props = {};
var TestAutoUI = function () { return React.createElement(Demo, __assign({}, props)); };
var Demo = function (_a) {
    var data = _a.data, model = _a.model, otherProps = __rest(_a, ["data", "model"]);
    var memoizedData = React.useMemo(function () {
        return autoUIRunTransformers(dataExample, transformers, {
            accessRole: 'administrator',
        });
    }, [dataExample]);
    return (React.createElement(AutoUI, __assign({ data: data !== null && data !== void 0 ? data : memoizedData, model: model !== null && model !== void 0 ? model : autoUIGetModelForCollection(sshKeyModel), actions: [] }, otherProps)));
};
describe('AutoUI', function () {
    describe('Collection component', function () {
        it('should render the collection with N results', function () {
            var component = mount(React.createElement(Provider, null,
                React.createElement(TestAutoUI, null)));
            var table = component.find(Table);
            var tableRows = table.find('[data-display="table-body"] [data-display="table-row"]');
            expect(tableRows).toHaveLength(dataExample.length);
        });
    });
});
