import { __assign, __awaiter, __generator, __makeTemplateObject } from "tslib";
import React from 'react';
import { Flex } from '../../components/Flex';
import { Button } from '../../components/Button';
import { ActionMethods, ACTION_SIDEBAR_WIDTH } from '.';
import styled from 'styled-components';
import { Form } from '../../components/Form';
import { getFromRef, pine } from './odata';
import { faTimes } from '@fortawesome/free-solid-svg-icons/faTimes';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { notifications } from '../../components/Notifications';
import { useTranslation } from '../../hooks/useTranslation';
var replaceRefValues = function (object, openApiJson) {
    if (object === null || typeof object !== 'object') {
        return object;
    }
    if (Array.isArray(object)) {
        return object.map(function (value) {
            return replaceRefValues(value, openApiJson);
        });
    }
    var build = {};
    for (var key in object) {
        if (object.hasOwnProperty(key)) {
            var value = object[key];
            if (typeof value === 'object' && !!value['$ref']) {
                value = getFromRef(openApiJson, value['$ref']);
            }
            if (typeof value === 'object' && !value['$ref']) {
                value = replaceRefValues(value, openApiJson);
            }
            build[key] = value;
        }
    }
    return build;
};
var ActionSidebarWrapper = styled(Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tborder-left: 1px solid black;\n\tposition: absolute;\n\tright: 0;\n\ttop: 0;\n\tbottom: 0;\n\tz-index: 9;\n\twidth: ", "px;\n\tbackground: white;\n\toverflow: scroll;\n"], ["\n\tborder-left: 1px solid black;\n\tposition: absolute;\n\tright: 0;\n\ttop: 0;\n\tbottom: 0;\n\tz-index: 9;\n\twidth: ", "px;\n\tbackground: white;\n\toverflow: scroll;\n"])), function () { return ACTION_SIDEBAR_WIDTH; });
export var ActionSidebar = function (_a) {
    var resourceName = _a.resourceName, openApiJson = _a.openApiJson, action = _a.action, schema = _a.schema, id = _a.id, onClose = _a.onClose;
    var t = useTranslation().t;
    var memoizedReferenceSchema = React.useMemo(function () {
        return replaceRefValues(schema, openApiJson);
    }, [schema, openApiJson]);
    var submit = function (_a) {
        var formData = _a.formData;
        return __awaiter(void 0, void 0, void 0, function () {
            var err_1;
            var _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!(action === ActionMethods.POST)) return [3, 4];
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 3, , 4]);
                        return [4, pine.post(__assign(__assign({ resource: resourceName }, (id && !isNaN(parseInt(id, 10)) && { id: id })), { body: formData }))];
                    case 2:
                        _c.sent();
                        notifications.addNotification({
                            content: t('success.resource_added_successfully', {
                                name: resourceName,
                            }),
                            type: 'danger',
                        });
                        return [3, 4];
                    case 3:
                        err_1 = _c.sent();
                        notifications.addNotification({
                            content: (_b = err_1.message) !== null && _b !== void 0 ? _b : err_1,
                            type: 'danger',
                        });
                        return [3, 4];
                    case 4: return [2];
                }
            });
        });
    };
    return (React.createElement(ActionSidebarWrapper, { p: 3, flexDirection: "column" },
        React.createElement(Flex, { justifyContent: "end" },
            React.createElement(Button, { plain: true, onClick: onClose, icon: React.createElement(FontAwesomeIcon, { icon: faTimes }) })),
        React.createElement(Form, { my: 2, schema: memoizedReferenceSchema, onFormSubmit: submit })));
};
var templateObject_1;
