import { __assign, __makeTemplateObject } from "tslib";
import React from 'react';
import { Navbar } from './Navbar';
import { Sidebar } from './Sidebar';
import { Router, Switch, Route } from 'react-router-dom';
import { Content } from './Content';
import { createGlobalStyle } from 'styled-components';
import { Provider } from '../..';
import { history, onClickOutOrEsc } from '../AutoUI/utils';
import { Flex } from '../../components/Flex';
import { Box } from '../../components/Box';
import { ActionSidebar } from './ActionSidebar';
var SIDEBAR_WIDTH = 166;
var NAVBAR_HEIGHT = 60;
export var ACTION_SIDEBAR_WIDTH = 340;
var GlobalStyle = createGlobalStyle(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\thtml,\n\tbody {\n\t\theight: 100%;\n\t\tmargin: 0;\n\t\tpadding: 0;\n\t}\n"], ["\n\thtml,\n\tbody {\n\t\theight: 100%;\n\t\tmargin: 0;\n\t\tpadding: 0;\n\t}\n"])));
export var ActionMethods;
(function (ActionMethods) {
    ActionMethods["POST"] = "post";
    ActionMethods["PATCH"] = "patch";
    ActionMethods["DELETE"] = "delete";
})(ActionMethods || (ActionMethods = {}));
export var AutoUIApp = function (_a) {
    var openApiJson = _a.openApiJson, title = _a.title, logo = _a.logo;
    var actionSidebarWrapper = React.useRef(null);
    var _b = React.useState(), actionSidebar = _b[0], setActionSidebar = _b[1];
    React.useEffect(function () {
        if (!actionSidebarWrapper.current) {
            return;
        }
        onClickOutOrEsc(actionSidebarWrapper.current, function () {
            setActionSidebar(null);
        });
    }, [actionSidebarWrapper.current]);
    return (React.createElement(Provider, null,
        React.createElement(Router, { history: history },
            React.createElement(GlobalStyle, null),
            React.createElement(Navbar, { height: NAVBAR_HEIGHT, title: title, logo: logo }),
            React.createElement(Flex, { style: { position: 'relative' } },
                React.createElement(Sidebar, { width: SIDEBAR_WIDTH + "px", height: "calc(100vh - " + NAVBAR_HEIGHT + "px)", openApiJson: openApiJson, isCollapsed: false }),
                React.createElement(Box, { width: "calc(100vw - " + (actionSidebar
                        ? SIDEBAR_WIDTH + ACTION_SIDEBAR_WIDTH
                        : SIDEBAR_WIDTH) + "px)", height: "calc(100vh - " + NAVBAR_HEIGHT + "px)", px: 2, py: 1, style: { overflow: 'auto' } },
                    React.createElement(Switch, null, Object.keys(openApiJson.paths).map(function (path) { return (React.createElement(Route, { key: path, path: path, render: function () { return (React.createElement(Content, { openApiJson: openApiJson, openActionSidebar: setActionSidebar })); } })); }))),
                actionSidebar && (React.createElement(Flex, { ref: actionSidebarWrapper },
                    React.createElement(ActionSidebar, __assign({}, actionSidebar, { openApiJson: openApiJson, onClose: function () { return setActionSidebar(null); } }))))))));
};
var templateObject_1;
