import { mount } from 'enzyme';
import React from 'react';
import { act } from 'react-dom/test-utils';
import { Provider, useTheme } from '../';
import { useBreakpoint } from './useBreakpoint';
import { breakpoints } from '../theme';
var Sample = function () {
    var theme = useTheme();
    return React.createElement("span", null, theme.font);
};
test('useTheme should return correct theme object', function () {
    var theme = {
        font: 'Arial',
    };
    var component = mount(React.createElement(Provider, { theme: theme },
        React.createElement(Sample, null)));
    var text = component.find(Sample).text();
    expect(text).toEqual('Arial');
});
var resizeWindow = function (width) {
    if (width === void 0) { width = 600; }
    global.window.innerWidth = width;
    global.window.dispatchEvent(new Event('resize'));
};
var HookContainer = function (_a) {
    var children = _a.children, values = _a.values;
    return children(useBreakpoint(values));
};
var testHook = function (values) {
    var retrunValues;
    mount(React.createElement(Provider, null,
        React.createElement(HookContainer, { values: values }, function (hookVal) {
            retrunValues = hookVal;
            return null;
        })));
    return retrunValues;
};
describe('should test useBreakpoint hook in multiple resolutions', function () {
    var values = breakpoints.map(function (b) { return "less than " + b; });
    var table = breakpoints.map(function (b, index) { return ["name: " + b, b, values[index]]; });
    test.each(table)('useBreakpoint should return %s value with %d resolution', function (_name, resolution, expectedResult) {
        act(function () {
            resizeWindow(resolution - 1);
        });
        var hookValue = testHook(values);
        expect(hookValue).toEqual(expectedResult);
    });
});
