import * as React from 'react';
import { Poll } from '../utils/poll';
interface UseRequestOptions {
    polling: boolean;
    pollInterval?: number;
    stopExecution?: boolean;
}
declare type RequestError = Error | null | undefined;
declare type ForcePoll = () => void;
declare type ResolvableReturnType<T extends (...args: any[]) => any> = T extends (...args: any[]) => Promise<infer R> ? R : any;
export declare const useRequest: <TFn extends (poll: Poll | undefined) => Promise<any>, TResult extends ResolvableReturnType<TFn>>(action: TFn, deps: React.DependencyList, options: UseRequestOptions) => [TResult | undefined, true, RequestError, ForcePoll] | [TResult, false, RequestError, ForcePoll];
export {};
