import * as React from 'react';
import { useTranslation } from '../../hooks/useTranslation';
import { Flex } from '../../components/Flex';
import { Select } from '../../components/Select';
import { Txt } from '../../components/Txt';
import { DeviceLogo } from './DownloadImageModal';
import { FALLBACK_LOGO_UNKNOWN_DEVICE } from './utils';
var DeviceTypeOption = function (_a) {
    var _b, _c, _d;
    var deviceType = _a.deviceType, isSelected = _a.isSelected, emphasized = _a.emphasized, _e = _a.isOption, isOption = _e === void 0 ? false : _e;
    var t = useTranslation().t;
    var typeDisplayName = (_b = deviceType === null || deviceType === void 0 ? void 0 : deviceType.name) !== null && _b !== void 0 ? _b : t('placeholders.choose_device_type');
    var logoSrc = (_c = deviceType === null || deviceType === void 0 ? void 0 : deviceType.logo) !== null && _c !== void 0 ? _c : FALLBACK_LOGO_UNKNOWN_DEVICE;
    var defaultDisplayName = (_d = deviceType === null || deviceType === void 0 ? void 0 : deviceType.name) !== null && _d !== void 0 ? _d : '-';
    return (React.createElement(Flex, { style: { height: emphasized ? 46 : 36 }, py: 2, pl: 3, width: "100%", alignItems: "center" },
        React.createElement(DeviceLogo, { src: logoSrc, title: defaultDisplayName }),
        React.createElement(Txt, { className: isOption ? 'e2e-device-type-option' : '', ml: 2, bold: isSelected }, typeDisplayName)));
};
var DeviceTypeSelectorBase = function (_a) {
    var deviceTypeOptions = _a.deviceTypeOptions, selectedDeviceType = _a.selectedDeviceType, selectDeviceTypeOption = _a.selectDeviceTypeOption, emphasized = _a.emphasized, id = _a.id;
    var _b = React.useState(''), query = _b[0], setQuery = _b[1];
    var _c = React.useState([]), filteredDeviceTypes = _c[0], setFilteredDeviceTypes = _c[1];
    React.useEffect(function () {
        var filtered = deviceTypeOptions.filter(function (s) { return s.name.toLowerCase().indexOf(query.toLowerCase()) >= 0; });
        setFilteredDeviceTypes(filtered);
    }, [deviceTypeOptions, query]);
    React.useEffect(function () {
        if (deviceTypeOptions.length === 0) {
            return;
        }
        if (!deviceTypeOptions.some(function (dt) { return dt.slug === selectedDeviceType.slug; })) {
            selectDeviceTypeOption(null);
        }
    }, [deviceTypeOptions, selectedDeviceType, selectDeviceTypeOption]);
    return (React.createElement(Select, { id: id, emphasized: emphasized, options: filteredDeviceTypes, valueKey: "slug", labelKey: "name", value: selectedDeviceType || {}, placeholder: React.createElement(DeviceTypeOption, { emphasized: emphasized }), valueLabel: React.createElement(DeviceTypeOption, { emphasized: emphasized, deviceType: selectedDeviceType }), onChange: function (_a) {
            var option = _a.option;
            selectDeviceTypeOption(option);
            setQuery('');
        }, onSearch: setQuery }, function (option) { return (React.createElement(DeviceTypeOption, { deviceType: option, isSelected: option.slug === selectedDeviceType.slug, isOption: true })); }));
};
export var DeviceTypeSelector = React.memo(DeviceTypeSelectorBase);
