import { __assign, __makeTemplateObject } from "tslib";
import toNumber from 'lodash/toNumber';
import * as React from 'react';
import { Box } from '../../components/Box';
import { Checkbox } from '../../components/Checkbox';
import { Divider } from '../../components/Divider';
import { Input } from '../../components/Input';
import { Select } from '../../components/Select';
import { RadioButtonGroup } from '../../components/RadioButtonGroup';
import { Txt } from '../../components/Txt';
import { Collapsible } from './Collapsible';
import { PasswordInput } from './PasswordInput';
import styled from 'styled-components';
import { DocsLink } from './OsConfiguration';
import { useTranslation } from '../../hooks/useTranslation';
import moment from 'moment';
export var DownloadImageLabel = styled.label(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tdisplay: flex;\n\tflex-direction: row;\n\talign-items: center;\n\theight: 21px;\n\tfont-size: 12px;\n\tmargin-bottom: 8px;\n\tfont-weight: normal;\n"], ["\n\tdisplay: flex;\n\tflex-direction: row;\n\talign-items: center;\n\theight: 21px;\n\tfont-size: 12px;\n\tmargin-bottom: 8px;\n\tfont-weight: normal;\n"])));
var matches = function (condition, data) {
    if (!condition) {
        return true;
    }
    for (var k in condition) {
        if (!condition[k]) {
            continue;
        }
        if (condition[k] !== data[k]) {
            return false;
        }
    }
    return true;
};
var getDefaultValue = function (options) {
    if (options.default) {
        return options.default;
    }
    else if (options.choices) {
        return options.choices[0];
    }
    else if (options.type === 'number' && options.min) {
        return options.min;
    }
    return undefined;
};
var FormControl = function (_a) {
    var _b, _c, _d, _e;
    var onModelChange = _a.onModelChange, options = _a.options, model = _a.model;
    var t = useTranslation().t;
    React.useEffect(function () {
        var _a;
        if (model[options.name]) {
            return;
        }
        var defaultVal = getDefaultValue(options);
        if (defaultVal != null) {
            onModelChange((_a = {}, _a[options.name] = getDefaultValue(options), _a));
        }
    }, [options, model, onModelChange]);
    var error = React.useMemo(function () {
        var value = model[options.name];
        if (value !== undefined && typeof value === 'number') {
            if (options.min) {
                if (value < options.min) {
                    return t('fields_errors.does_not_satisfy_minimum', {
                        minimum: options.min,
                    });
                }
            }
            if (options.max) {
                if (value > options.max) {
                    return t('fields_errors.does_not_satisfy_maximum', {
                        maximum: options.max,
                    });
                }
            }
        }
    }, [options, model]);
    return (React.createElement("div", { style: options.hidden ? { display: 'none' } : {} },
        options.hidden && (React.createElement("input", { name: options.name, value: model[options.name], onChange: function (e) {
                var _a;
                return onModelChange((_a = {}, _a[options.name] = e.target.value, _a));
            } })),
        !options.hidden && (React.createElement(React.Fragment, null,
            options.type !== 'confirm' && (React.createElement(DownloadImageLabel, null,
                options.message,
                !!options.docs && React.createElement(DocsLink, { href: options.docs }))),
            options.type === 'list' && ((_b = options.choices) === null || _b === void 0 ? void 0 : _b.length) === 1 && (React.createElement("div", null,
                React.createElement("input", { type: "hidden", name: options.name, value: model[options.name], onChange: function (e) {
                        var _a;
                        return onModelChange((_a = {}, _a[options.name] = e.target.value, _a));
                    } }),
                React.createElement("em", null,
                    "(",
                    options.choices[0],
                    ")"))),
            options.type === 'list' && ((_c = options.choices) === null || _c === void 0 ? void 0 : _c.length) === 2 && (React.createElement(React.Fragment, null,
                React.createElement("input", { type: "hidden", name: options.name, value: model[options.name] }),
                React.createElement(Box, { mr: 4 },
                    React.createElement(RadioButtonGroup, { options: options.choices.map(function (choice) {
                            var _a, _b;
                            return ({
                                disabled: false,
                                value: choice,
                                label: (_b = (_a = options.choicesLabels) === null || _a === void 0 ? void 0 : _a[choice]) !== null && _b !== void 0 ? _b : choice,
                            });
                        }), value: model[options.name], onChange: function (e) {
                            var _a;
                            return onModelChange((_a = {}, _a[options.name] = e.target.value, _a));
                        } })))),
            options.type === 'list' && ((_e = (_d = options.choices) === null || _d === void 0 ? void 0 : _d.length) !== null && _e !== void 0 ? _e : 0) > 2 && (React.createElement(Select, { name: options.name, options: options.choices, width: "100%", value: model[options.name], onChange: function (_a) {
                    var _b;
                    var option = _a.option;
                    return onModelChange((_b = {}, _b[options.name] = option, _b));
                } })),
            options.type === 'confirm' && (React.createElement(Checkbox, { mb: 2, name: options.name, label: options.message, checked: model[options.name], onChange: function (e) {
                    var _a;
                    return onModelChange((_a = {}, _a[options.name] = e.target.checked, _a));
                } })),
            options.type === 'number' && (React.createElement(Input, { mb: 2, name: options.name, type: "number", onChange: function (e) {
                    var _a;
                    var parsed = toNumber(e.target.value);
                    if (!isNaN(parsed)) {
                        onModelChange((_a = {}, _a[options.name] = parsed, _a));
                    }
                }, value: model[options.name], min: options.min, max: options.max })),
            options.type === 'password' && (React.createElement(Box, { mb: 2 },
                React.createElement(PasswordInput, { name: options.name, onChange: function (e) {
                        var _a;
                        return onModelChange((_a = {}, _a[options.name] = e.target.value, _a));
                    }, value: model[options.name], autoComplete: "new-password" }))),
            options.type === 'datetime-local' && (React.createElement(React.Fragment, null,
                React.createElement("input", { type: "hidden", name: options.name, value: !!model[options.name]
                        ? moment(model[options.name])
                            .utc()
                            .format()
                        : undefined }),
                React.createElement(Input, { mb: 2, type: "datetime-local", value: !!model[options.name]
                        ? model[options.name]
                        : undefined, onChange: function (e) {
                        var _a;
                        console.log(e.currentTarget.value);
                        onModelChange((_a = {},
                            _a[options.name] = e.currentTarget.value,
                            _a));
                    }, onKeyPress: function (e) {
                        var _a;
                        if (e.key === 'Enter' && !!model[options.name]) {
                            onModelChange((_a = {}, _a[options.name] = undefined, _a));
                        }
                    } }))),
            (!options.type || options.type === 'text') && (React.createElement(Input, { mb: 2, type: "text", name: options.name, onChange: function (e) {
                    var _a;
                    return onModelChange((_a = {}, _a[options.name] = e.target.value, _a));
                }, value: model[options.name], autoComplete: "new-password" })),
            error && (React.createElement(Txt, { color: "red", fontSize: 10 }, error))))));
};
var FormField = function (_a) {
    var onModelChange = _a.onModelChange, model = _a.model, options = _a.options;
    var shouldShow = matches(options.when, model);
    if (!shouldShow) {
        return null;
    }
    return (React.createElement(FormControl, { options: options, model: model, onModelChange: onModelChange }));
};
var FormGroup = function (_a) {
    var onModelChange = _a.onModelChange, model = _a.model, options = _a.options;
    return (React.createElement(React.Fragment, null,
        React.createElement(Divider, { type: "dashed" }),
        React.createElement(Collapsible, { collapsible: !!options.isCollapsible, initiallyCollapsed: options.collapsed, title: options.message },
            React.createElement(FormFields, { onModelChange: onModelChange, options: options.options, model: model }))));
};
var FormFields = function (_a) {
    var onModelChange = _a.onModelChange, model = _a.model, options = _a.options;
    return (React.createElement(React.Fragment, null, options.map(function (option) {
        return (React.createElement(React.Fragment, { key: option.name },
            option.isGroup && (React.createElement(FormGroup, { onModelChange: onModelChange, model: model, options: option })),
            !option.isGroup && (React.createElement(FormField, { onModelChange: onModelChange, model: model, options: option }))));
    })));
};
export var DownloadFormModel = function (_a) {
    var model = _a.model, onModelChange = _a.onModelChange, options = _a.options;
    if (!options) {
        return null;
    }
    return (React.createElement(FormFields, { onModelChange: function (updatedField) {
            return onModelChange(__assign(__assign({}, model), updatedField));
        }, model: model, options: options }));
};
var templateObject_1;
