/// <reference types="react" />
import { IconProp } from '@fortawesome/fontawesome-svg-core';
import { DeviceType, OsVersionsByDeviceType } from './models';
export declare const DownloadImageLabel: import("styled-components").StyledComponent<"label", any, {}, never>;
interface OsConfigurationProps {
    deviceTypeOsVersions: OsVersionsByDeviceType;
    compatibleDeviceTypes: DeviceType[];
    selectedDeviceType: DeviceType;
    osTypes: string[];
    hasEsrVersions: boolean;
    selectedOsType: string;
    isInitialDefault?: boolean;
    onSelectedDeviceTypeChange: (deviceType: DeviceType) => void;
    onSelectedVersionChange: (osVersion: string) => void;
    onSelectedDevelopmentMode: (developmentMode: boolean) => void;
    onSelectedOsTypeChange: (osType: string) => void;
    docsIcon?: IconProp;
}
declare const BuildVariants: readonly ["dev", "prod"];
export declare type BuildVariant = typeof BuildVariants[number];
export declare const OsConfiguration: ({ deviceTypeOsVersions, compatibleDeviceTypes, selectedDeviceType, osTypes, hasEsrVersions, selectedOsType, isInitialDefault, onSelectedVersionChange, onSelectedDevelopmentMode, onSelectedDeviceTypeChange, onSelectedOsTypeChange, docsIcon, }: OsConfigurationProps) => JSX.Element;
interface DocsLinkProps {
    href: string;
    docsIcon?: IconProp;
}
export declare const DocsLink: ({ href, docsIcon }: DocsLinkProps) => JSX.Element;
export {};
