/// <reference types="react" />
import { SelectProps } from '../../components/Select';
interface OsTypeSelectorProps<T> extends Omit<SelectProps<T>, 'options' | 'onChange' | 'valueKey' | 'disabledKey' | 'valueLabel' | 'children'> {
    supportedOsTypes: string[];
    hasEsrVersions: boolean;
    selectedOsTypeSlug: string | undefined;
    onSelectedOsTypeChange: (osType: string) => void;
}
interface OsTypeObj {
    slug: string;
    disabled: boolean;
    supportedForDeviceType: boolean;
    supportedForApp: boolean;
}
export declare const OsTypeSelector: ({ supportedOsTypes, hasEsrVersions, selectedOsTypeSlug, onSelectedOsTypeChange, ...otherProps }: OsTypeSelectorProps<OsTypeObj>) => JSX.Element;
export {};
